Package: grapesAgri1
Type: Package
Title: Collection of Shiny Apps for Agricultural Research Data Analysis
Version: 1.1.0
Authors@R: c(
    person(given = "Pratheesh P.", family = "Gopinath",
           email = "grapescoa@gmail.com",
           role = c("aut", "cre"),
		       comment = c(ORCID = "0000-0003-3290-0436")),
	  person(given = "Rajender", family = "Parsad", 
           email = "Rajender.Parsad@icar.gov.in",
		       role = "aut"),
    person(given = "Brigit", family = "Joseph",
           email = "brigit.joseph@kau.in",
		       role = "aut"),
		person(given = "Adarsh.", family = "V.S.",
           email = "adarshvs0007@gmail.com",
		       role = "aut"),
    person("Kerala Agricultural University",
           role = c("cph"),
		       comment = c(url = "http://www.kau.in/")))
Description: Allows user to have graphical user interface to perform analysis of Agricultural experimental data. On using the functions in this package a Interactive User Interface will pop up. Apps Works by simple upload of files in CSV format.
License: GPL-3
Encoding: UTF-8
RoxygenNote: 7.1.1
URL: https://github.com/pratheesh3780/grapesAgri1
        https://CRAN.R-project.org/package=grapesAgri1
        https://www.kaugrapes.com/
BugReports: https://github.com/pratheesh3780/grapesAgri1/issues
Imports: shiny(>= 1.6.0), shinyWidgets(>= 0.6.0), rmarkdown(>= 2.7),
        knitr(>= 1.31), kableExtra(>= 1.3.4), magrittr(>= 2.0.1),
        summarytools(>= 0.9.9), dplyr(>= 1.0.4), pastecs(>= 1.3.21),
        ggpubr(>= 0.4.0), Hmisc(>= 4.5.0), corrplot(>= 0.84),
        ggplot2(>= 3.3.3), reshape2(>= 1.4.4), gridGraphics(>= 0.5.1),
        RColorBrewer(>= 1.1.2), desplot(>= 1.8), agricolae(>= 1.3.5),
        PairedData(>= 1.1.1), gtools(>= 3.9.2), Rdpack(>= 2.1.2)
Suggests: shinytest, testthat, datasets, grid
RdMacros: Rdpack
NeedsCompilation: no
Packaged: 2021-08-14 12:41:29 UTC; HP
Author: Pratheesh P. Gopinath [aut, cre]
    (<https://orcid.org/0000-0003-3290-0436>),
  Rajender Parsad [aut],
  Brigit Joseph [aut],
  Adarsh. V.S. [aut],
  Kerala Agricultural University [cph] (http://www.kau.in/)
Maintainer: Pratheesh P. Gopinath <grapescoa@gmail.com>
Repository: CRAN
Date/Publication: 2021-08-14 12:50:02 UTC
Built: R 4.6.0; ; 2026-05-01 03:51:46 UTC; unix

Package: grapesAgri1
Type: Package
Title: Collection of Shiny Apps for Agricultural Research Data Analysis
Version: 1.1.0
Authors@R: c(
    person(given = "Pratheesh P.", family = "Gopinath",
           email = "grapescoa@gmail.com",
           role = c("aut", "cre"),
		       comment = c(ORCID = "0000-0003-3290-0436")),
	  person(given = "Rajender", family = "Parsad", 
           email = "Rajender.Parsad@icar.gov.in",
		       role = "aut"),
    person(given = "Brigit", family = "Joseph",
           email = "brigit.joseph@kau.in",
		       role = "aut"),
		person(given = "Adarsh.", family = "V.S.",
           email = "adarshvs0007@gmail.com",
		       role = "aut"),
    person("Kerala Agricultural University",
           role = c("cph"),
		       comment = c(url = "http://www.kau.in/")))
Description: Allows user to have graphical user interface to perform analysis of Agricultural experimental data. On using the functions in this package a Interactive User Interface will pop up. Apps Works by simple upload of files in CSV format.
License: GPL-3
Encoding: UTF-8
RoxygenNote: 7.1.1
URL: https://github.com/pratheesh3780/grapesAgri1
        https://CRAN.R-project.org/package=grapesAgri1
        https://www.kaugrapes.com/
BugReports: https://github.com/pratheesh3780/grapesAgri1/issues
Imports: shiny(>= 1.6.0), shinyWidgets(>= 0.6.0), rmarkdown(>= 2.7),
        knitr(>= 1.31), kableExtra(>= 1.3.4), magrittr(>= 2.0.1),
        summarytools(>= 0.9.9), dplyr(>= 1.0.4), pastecs(>= 1.3.21),
        ggpubr(>= 0.4.0), Hmisc(>= 4.5.0), corrplot(>= 0.84),
        ggplot2(>= 3.3.3), reshape2(>= 1.4.4), gridGraphics(>= 0.5.1),
        RColorBrewer(>= 1.1.2), desplot(>= 1.8), agricolae(>= 1.3.5),
        PairedData(>= 1.1.1), gtools(>= 3.9.2), Rdpack(>= 2.1.2)
Suggests: shinytest, testthat, datasets, grid
RdMacros: Rdpack
NeedsCompilation: no
Packaged: 2021-08-14 12:41:29 UTC; HP
Author: Pratheesh P. Gopinath [aut, cre]
    (<https://orcid.org/0000-0003-3290-0436>),
  Rajender Parsad [aut],
  Brigit Joseph [aut],
  Adarsh. V.S. [aut],
  Kerala Agricultural University [cph] (http://www.kau.in/)
Maintainer: Pratheesh P. Gopinath <grapescoa@gmail.com>
Repository: CRAN
Date/Publication: 2021-08-14 12:50:02 UTC
Built: R 4.6.0; ; 2026-04-25 14:12:53 UTC; unix

# `grapesAgri1`: Collection of shiny applications for data analysis in Agriculture-Part 1 <img src="man/figures/logo.PNG" align="right" alt="logo" width="173" height = "200" style = "border: none; float: right;">
### General R-shiny based Analysis Platform Empowered by Statistics in Agriculture part-1 (grapesAgri1)

## R-Package for Data Analysis in Agriculture.
###### Version : 0.1.0; Copyright (C) 2021-2025: [Kerala Agricultural University](https://www.kaugrapes.com); License: [GPL-3](https://www.r-project.org/Licenses/) 

##### *Gopinath, P. P.<sup>1</sup>, Parsad, R.<sup>2</sup>, Joseph, B.<sup>1</sup>, Adarsh, V.S.<sup>3</sup>*

1.  Department of Agricultural Statistics, College of Agriculture, Vellayani, Kerala Agricultural Univesity.
2.  ICAR-Indian Agricultural Statistics Research Institute,
    New Delhi.
3.  Department of Agricultural Statistics, BCKV, West Bengal

---

![CRAN/METACRAN](https://img.shields.io/cran/v/grapesAgri1?style=for-the-badge)
![GitHub](https://img.shields.io/github/license/pratheesh3780/grapesAgri1)
[![CRAN\_Status\_Badge](https://www.r-pkg.org/badges/version-last-release/grapesAgri1)](https://cran.r-project.org/package=grapesAgri1)
[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.4923220.svg)](https://doi.org/10.5281/zenodo.4923220)
![GitHub release (latest by date)](https://img.shields.io/github/v/release/pratheesh3780/grapesAgri1)
![GitHub R package version](https://img.shields.io/github/r-package/v/pratheesh3780/grapesAgri1)
![GitHub language count](https://img.shields.io/github/languages/count/pratheesh3780/grapesAgri1)
![Libraries.io dependency status for GitHub repo](https://img.shields.io/librariesio/github/pratheesh3780/grapesAgri1)
![GitHub code size in bytes](https://img.shields.io/github/languages/code-size/pratheesh3780/grapesAgri1)
[![R-CMD-check](https://github.com/pratheesh3780/grapesAgri1/workflows/R-CMD-check/badge.svg)](https://github.com/pratheesh3780/grapesAgri1/actions)
[![](https://cranlogs.r-pkg.org/badges/grapesAgri1)](https://cran.r-project.org/package=grapesAgri1)
[![Build Status](https://www.travis-ci.com/pratheesh3780/grapesAgri1.svg?branch=master)](https://www.travis-ci.com/pratheesh3780/grapesAgri1)
[![DOI](https://joss.theoj.org/papers/10.21105/joss.03437/status.svg)](https://doi.org/10.21105/joss.03437)

---

## Introduction
<div align="justify">Agricultural experiments demands a wide range of statistical tools for analysis, which includes from Exploratory analysis, Design of experiments and Statistical genetics. Majority of the Agricultural scientists prefer graphical user interface for performing analysis . As R-shiny provides a platform to create interactive user interface, we have utilized it to produce interactive interfaces for commonly used analysis tools in Agrciultural experiments. grapesAgri1(General R-shiny based Analysis Platform Empowered by Statistics for data analysis in Agriculture-part1) is a collection of shiny based applications for some basic statistical analysis commonly used in agricultural research. It can be utilised by scientific community who prefers an interactive user interface. On using the functions in this package a Graphical User Interface will pop up. Apps Works by simple upload of files in CSV format. Results can be downloaded in HTML format. Plots and Graphs can be generated, which is also downloadable as .png file.</div>

## Installation
The package can be installed from CRAN as follows:

``` r
# Install from CRAN
install.packages('grapesAgri1', dependencies=TRUE)
```

The development version can be installed from github as follows:

``` r
# Install grapesAgri1 development version from Github using the code below:
if (!require('devtools')) install.packages('devtools')
devtools::install_github("pratheesh3780/grapesAgri1")
```

## usage
```r
grapesAgri1::descApp() # descriptive Statistics and Visualization 
grapesAgri1::corrApp() # Correlation Analysis
grapesAgri1::ttApp() # Compare Means
grapesAgri1::crdApp() # Completely Randomized Design
grapesAgri1::layoutApp() # Field layout of experiments
grapesAgri1::rbdApp() # Randomized Block Design 
```
## Apps included in the package

|Sl. No.| App Title | Function to call |Remark |
|:-----:| :----------- | :-----------:|:----------------|
|1|Descriptive Statistics and Visualization   | descApp()      |Summary Statistics, Summary Statistics by Group, Box plot, Histogram, Q-Q plot and Shapiro-Wilk's test|
|2|Correlation Analysis   | corrApp()      | Simple correlation, Correlation Matrix, correlogram and scatterplot|
|3|Compare Means: Small samle tests  | ttApp()      | One sample t-test, Two sample unpaired t-test, paired t-test, Two sample unpaired Welch t-test, F test, Box plot, Paired Plot|
|4|Completely Randomized Design  | crdApp()      |One-way Analysis of variance (equal and unequal replication), Multiple comparison test, boxplot and barchart with confidence interval|
|5|Field layout of experiments | layoutApp()      |Field layout of following designs can be obtained: Completely Randomized Design (CRD), Randomized Complete Block Design (RCBD), Split-plot design, Strip-plot design, Augmented RCBD|
|6|Randomized Block Design  | rbdApp()      |Two-way Analysis of variance, Multiple comparison test, boxplot and barchart with confidence interval|

## Further Reading
To know more about analysis tools included in the package see the following links
1. [Design and Analysis of experiments](http://apps.iasri.res.in/ebook/EBADAT/2-Basic%20Statistical%20Techniques/9-Fundamentals%20Of%20Designsf.pdf).
2. [Correlation Analysis](http://apps.iasri.res.in/ebook/EBADAT/2-Basic%20Statistical%20Techniques/6-Correlation_and_regression.pdf).
3. [Hypothesis Testing](http://apps.iasri.res.in/ebook/EBADAT/2-Basic%20Statistical%20Techniques/4-TEST%20OF%20HYPOTHESIS.pdf).
4. [Descriptive statistics and Exploratory data analysis](http://apps.iasri.res.in/ebook/EBADAT/2-Basic%20Statistical%20Techniques/1-Descriptive%20Statistics.pdf).
5. [Test for significance](http://apps.iasri.res.in/ebook/EBADAT/2-Basic%20Statistical%20Techniques/5-Tests%20of%20Significance-Seema.pdf).

## Glimpse to grapesAgri1 in Action!
It is very user friendly. Just upload your file in CSV format.

Note: we apologize that in grapesAgri1 version 1.0.0 in CRAN you may not be able to download model data set in crdApp()and rbdApp(). Issue will be cleared in the version 1.1.0 releasing by next month. You can instead download from github where the issue is resolved. 

Thank You

See below for some random images of GUI of grapesAgri1

![](man/figures/Corr.png) 

![](man/figures/Corr1.png)

![](man/figures/crd.png)  

![](man/figures/crd2.png)

![](man/figures/crd3.PNG)

![](man/figures/crd4.png)

![](man/figures/desc.png)

![](man/figures/layout.png)

![](man/figures/rbd.png)

![](man/figures/rbd1.png)

![](man/figures/rbd2.png)

# Community guidelines

Report Issues:

-   Questions, feedback, bug reports: please open an issue in the [issue tracker of the project](https://github.com/pratheesh3780/grapesAgri1/issues).

Contribution to the software:

-   Please open an issue in the issue tracker of the project that describes the changes you would like to make to the software and open a pull request with the changes. The description of the pull request must reference the corresponding issue.

library(rmarkdown)
library(shinyWidgets)
library(dplyr)
library(gridGraphics)
library(RColorBrewer)
library(knitr)
library(corrplot)
library(Hmisc)
library(reshape2)
library(ggplot2)
library(datasets)
library(grid)



############################### ui

ui <- fluidPage(
  setBackgroundColor(
    color = c("#bbedfc", "#ffffff"),
    gradient = "radial",
    direction = c("bottom", "right")
  ),
  tags$script("$(document).on('shiny:connected', function(event) {
var myWidth = $(window).width();
Shiny.onInputChange('shiny_width',myWidth)

});"),
  tags$script("$(document).on('shiny:connected', function(event) {
var myHeight = $(window).height();
Shiny.onInputChange('shiny_height',myHeight)

});"),
  titlePanel(
    title = tags$div(tags$b("Correlation Analysis", style = "color:#fc03f4")),
    windowTitle = "Correlation Analysis"
  ),
  sidebarPanel(
    fileInput("file1", "CSV File (upload in csv format)", accept = c("text/csv", "text/comma-separated-values,text/plain", ".csv")),
    checkboxInput("header", "Header", TRUE),
    selectInput(
      "req1", "Please select the analysis type",
      c(
        Simple_correlation = "correlation",
        Correlation_Matrix = "corrmat",
        Scatter_Plot = "scatplot",
        Correlogram = "corrplot"
      ),
      "correlation"
    ),
    uiOutput("var"),
    tags$br(),
    h5(
      tags$div(
        tags$br(),
        "Developed by:",
        tags$br(),
        tags$b("Dr.Pratheesh P. Gopinath"),
        tags$br(),
        tags$b("Assistant Professor,"),
        tags$br(),
        tags$b("Agricultural Statistics,"),
        tags$br(),
        tags$b("Kerala Agricultural University"),
        tags$br(),
        tags$br(),
        "Contribution:",
        tags$br(),
        tags$b("Adarsh V.S."),
        tags$br(),
        tags$b("MSc, Agricultural Statistics"),
        tags$br(),
        tags$br(),
        "post your queries at: pratheesh.pg@kau.in",
        style = "color:#343aeb"
      )
    )
  ),
  mainPanel(
    htmlOutput("note1"),
    uiOutput("data_set"), # for data set download

    tableOutput("correlation"),
    tags$style(type = "text/css", "#correlation th,td {border: medium solid #000000;text-align:center}"),
    tags$style(type = "text/css", "#correlation td {border: medium solid #000000;text-align:center}"),
    tableOutput("ci"),
    tags$style(type = "text/css", "#ci th,td {border: medium solid #000000;text-align:center}"),
    tags$style(type = "text/css", "#ci td {border: medium solid #000000;text-align:center}"),
    tableOutput("corrmat"),
    tags$style(type = "text/css", "#corrmat th,td {border: medium solid #000000;text-align:center}"),
    tags$style(type = "text/css", "#corrmat td {border: medium solid #000000;text-align:center}"),
    htmlOutput("note"),
    tags$br(),
    tableOutput("sigmat"),
    tags$style(type = "text/css", "#sigmat th,td {border: medium solid #000000;text-align:center}"),
    tags$style(type = "text/css", "#sigmat td {border: medium solid #000000;text-align:center}"),
    uiOutput("plot"),
    tags$br(),
    tags$br(),
    uiOutput("image_down"), # for image download
    uiOutput("var1")
  )
)
############################ SERVER
server <- function(input, output, session) {
  csvfile <- reactive({
    csvfile <- input$file1
    if (is.null(csvfile)) {
      return(NULL)
    }
    dt <- read.csv(csvfile$datapath, header = input$header, sep = ",", check.names = FALSE)
    dt
  })

  output$var <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }
    if (input$req1 == "correlation") {
      list(
        radioButtons("dvar", "Please pick 'X' Variable", choices = names(csvfile())),
        radioButtons("ivar", "Please pick 'Y' Variable", choices = names(csvfile())),
        selectInput(
          "req", "Please select the method",
          c(
            PEARSON = "pearson",
            KENDALL = "kendall",
            SPEARMAN = "spearman"
          ),
          "pearson"
        ),
        selectInput(
          "ci", "Level of Significance",
          c(
            Five_percent = 0.95,
            One_percent = 0.99,
            Ten_percent = 0.90
          ),
          0.95
        ),
        selectInput(
          "alt", "Alternative Hypotesis",
          c(
            Two_sided = "two.sided",
            Less_than_Zero = "less",
            Greater_than_Zero = "greater"
          ),
          "two.sided"
        ),
        actionBttn(
          inputId = "submit",
          label = "SUBMIT!",
          color = "danger",
          style = "jelly"
        )
      )
    }
    else if (input$req1 == "scatplot") {
      list(
        radioButtons("dvar", "Please pick 'X' Variable", choices = names(csvfile())),
        radioButtons("ivar", "Please pick 'Y' Variable", choices = names(csvfile())),
        textInput("main", "Enter required title for the plot", "main title"),
        textInput("xlab", "Enter required x-axis label", "X-axis"),
        textInput("ylab", "Enter required x-axis label", "y-axis"),
        selectInput(
          "color", "Please select point colour",
          c(
            Black = "#141413",
            Red = "#ff0d1d",
            Blue = "#0d45ff",
            Green = "#0dff0d",
            Yellow = "#ffdf0d",
            Orange = "#ff8a0d"
          ), "#141413"
        ),
        actionBttn(
          inputId = "submit1",
          label = "SUBMIT!",
          color = "danger",
          style = "jelly"
        )
      )
    }
    else if (input$req1 == "corrmat") {
      list(
        checkboxGroupInput("selvar", "Please select more than one variables", choices = names(csvfile())),
        selectInput(
          "req", "Please select the method",
          c(
            PEARSON = "pearson",
            SPEARMAN = "spearman"
          ),
          "pearson"
        ),
        actionBttn(
          inputId = "submit2",
          label = "SUBMIT!",
          color = "danger",
          style = "jelly"
        )
      )
    }
    else if (input$req1 == "corrplot") {
      list(
        checkboxGroupInput("selvar", "Please select the variables", choices = names(csvfile())),
        selectInput(
          "req2", "Please select the method",
          c(
            PEARSON = "pearson",
            SPEARMAN = "spearman"
          ),
          "pearson"
        ),
        selectInput(
          "shape", "Please select the visualization method",
          c(
            circle = "circle",
            square = "square",
            ellipse = "ellipse",
            number = "number",
            shade = "shade",
            color = "color",
            pie = "pie"
          ),
          "circle"
        ),
        selectInput(
          "layout", "Please select the correlogram layout",
          c(
            full = "full",
            upper = "upper",
            lower = "lower"
          ),
          "circle"
        ),
        selectInput(
          "style", "Please select colour pattern of your choice",
          c(
            style1 = "BrBG",
            style2 = "PiYG",
            style3 = "PRGn",
            style4 = "PuOr",
            style5 = "RdBu",
            style6 = "RdGy",
            style7 = "RdYlBu",
            style8 = "RdYlGn"
          ),
          "BrBG"
        ),
        checkboxInput(
          "remove_corr",
          "Don't show correlation coefficient", FALSE
        ),
        sliderInput("cex", "Required Font size of coefficient:",
          min = 0.5, max = 3, value = 1
        ),
        sliderInput("tlcex", "Required Font size of axis label:",
                    min = 0.5, max = 3, value = 1
        ),
        selectInput(
          "txcol", "Please select correlation coefficient colour",
          c(
            Black = "#141413",
            Transparent = "#00141413",
            Red = "#ff0d1d",
            Blue = "#0d45ff",
            Green = "#0dff0d",
            Yellow = "#ffdf0d",
            Orange = "#ff8a0d"
          ), "#141413"
        ),
        checkboxInput(
          "significance",
          "Mark non-significant correlations in the plot", FALSE
        ),
        radioButtons("sig", "Please pick significance level", choices = c("0.05", "0.01")),
        actionBttn(
          inputId = "submit3",
          label = "SUBMIT!",
          color = "danger",
          style = "jelly"
        )
      )
    }
  })

  ###################
  # correlaton
  output$correlation <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$req1)) {
        return()
      }
      if (is.null(input$submit)) {
        return()
      }
      if (input$req1 == "correlation") {
        if (input$submit > 0) {
          validate(
            need(input$dvar != input$ivar, "Both input variables selected (x and y) are same, correlation will be one.")
          )
          a <- as.vector(csvfile()[, input$dvar])
          y <- as.vector(csvfile()[, input$ivar])
          x <- cor.test(a, y,
            method = input$req, conf.level = as.numeric(input$ci),
            alternative = input$alt, exact = FALSE
          )
          t_value <- round(x$statistic, 3)
          correlation <- round(x$estimate, 3)
          df <- x$parameter
          pvalue <- round(x$p.value, 3)
          alt.Hypothesis <- x$alternative
          result <- cbind(correlation, t_value, df, pvalue, alt.Hypothesis)
          nam <- x$method
          rownames(result) <- nam
          result <- as.data.frame(result)
          result
        }
      }
    },
    rownames = TRUE,
    bordered = TRUE,
    align = "c",
    caption = ("<b>Simple Correlation </b>"),
    caption.placement = getOption("xtable.caption.placement", "top")
  )

  output$ci <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$req1)) {
        return()
      }
      if (is.null(input$submit)) {
        return()
      }
      if (input$req1 == "correlation") {
        if (input$submit > 0) {
          if (input$req == "pearson") {
            validate(
              need(input$dvar != input$ivar, "Are you confused?.
            Correlation measures linear relationship between two variables say x and y. To know more on correlation see Read me of package grapesAgri1. You can select different variables as x and y from the sidebar panel and see how it works!")
            )
            a <- as.vector(csvfile()[, input$dvar])
            y <- as.vector(csvfile()[, input$ivar])
            x <- cor.test(a, y,
              method = "pearson", conf.level = as.numeric(input$ci),
              alternative = input$alt, exact = FALSE
            )
            ci <- x$conf.int
            ci_nw <- reshape2::melt(ci, value.name = "Lower Limit and Upper limit")
            ci_nw
          }
        }
      }
    },
    rownames = FALSE,
    bordered = TRUE,
    align = "c",
    caption = ("<b>Confidence Interval</b>"),
    caption.placement = getOption("xtable.caption.placement", "top")
  )
  ##################################
  # Correlation Matrix
  output$corrmat <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$req1)) {
        return()
      }
      if (is.null(input$submit2)) {
        return()
      }
      if (input$req1 == "corrmat") {
        if (input$submit2 > 0) {
          validate(
            need(input$selvar, "No input selected, supply me some variables to cook a matrix!")
          )
          x <- as.data.frame(subset(csvfile(), select = input$selvar))
          cormat <- Hmisc::rcorr(as.matrix(x), type = input$req)
          R <- round(cormat$r, 3)
          p <- cormat$P
          ## Define notions for significance levels; spacing is important.
          mystars <- ifelse(p < .001, "*** ", ifelse(p < .01, "**  ", ifelse(p < .05, "*   ", "    ")))
          Rnew <- matrix(paste(R, mystars, sep = ""), ncol = ncol(x))
          diag(Rnew) <- paste(diag(R), " ", sep = "")
          row.names(Rnew) <- names(x)
          colnames(Rnew) <- names(x)
          Rnew
        }
      }
    },
    rownames = TRUE,
    bordered = TRUE,
    align = "c",
    caption = ("<b>Correlation Matrix</b>"),
    caption.placement = getOption("xtable.caption.placement", "top")
  )

  output$sigmat <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$req1)) {
        return()
      }
      if (is.null(input$submit2)) {
        return()
      }
      if (input$req1 == "corrmat") {
        if (input$submit2 > 0) {
          validate(
            need(input$selvar, "You can select input variables from sidebarpanel.")
          )
          x <- as.data.frame(subset(csvfile(), select = input$selvar))
          cormat <- Hmisc::rcorr(as.matrix(x), type = input$req)
          correlmat <- cormat$P
          row.names(correlmat) <- names(x)
          correlmat
        }
      }
    },
    digits = 3,
    rownames = TRUE,
    bordered = TRUE,
    align = "c",
    caption = ("<b>Matrix of P-values</b>"),
    caption.placement = getOption("xtable.caption.placement", "top")
  )

  output$note <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }
    if (is.null(input$submit2)) {
      return()
    }
    if (input$submit2 > 0) {
      if (input$req1 == "corrmat") {
        validate(
          need(input$selvar, "")
        )

        HTML(paste0("<p>*** Correlation is significant at 0.001 level (two tailed)</p>
                    <p>** Correlation is significant at 0.01 level (two tailed)</p>
                    <p>* Correlation is significant at 0.05 level (two tailed)</p>"))
      }
    }
  })


  ############################### PLOTS
  output$plot <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }
    if (input$req1 == "scatplot") {
      if (is.null(input$submit1)) {
        return()
      }
      output$scatplot <- renderPlot(
        {
          if (input$submit1 > 0) {
            x <- as.vector(csvfile()[, input$dvar])
            y <- as.vector(csvfile()[, input$ivar])
            plot(x, y,
              main = input$main,
              xlab = input$xlab, ylab = input$ylab,
              pch = 19, col = input$color, frame = FALSE
            )
          }
        },
        bg = "transparent"

      )
      plotOutput("scatplot")
    }
    else if (input$req1 == "corrplot") {
      if (is.null(input$submit3)) {
        return()
      }
      output$corrplot <- renderPlot(
        {
          if (input$submit3 > 0) {
            validate(
              need(input$selvar, "No input selected, supply me some variables to draw!")
            )
            x <- as.data.frame(subset(csvfile(), select = input$selvar))
            cormat1 <- cor(x, method = input$req2, use = "complete.obs")
            corrplot::corrplot(cormat1,
              method = input$shape,
              type = input$layout, tl.col = "#000000",
              col = brewer.pal(n = 8, name = input$style),
              addCoef.col = input$txcol, number.cex = input$cex,
              tl.cex = input$tlcex


            )

            if (input$significance > 0) {
              validate(
                need(input$selvar, "No input selected, supply me some variables to draw!")
              )
              x <- as.data.frame(subset(csvfile(), select = input$selvar))
              cormat1 <- cor(x, method = input$req2, use = "complete.obs")
              res1 <- corrplot::cor.mtest(x)
              corrplot::corrplot(cormat1,
                method = input$shape,
                type = input$layout, tl.col = "#000000",
                col = brewer.pal(n = 8, name = input$style),
                addCoef.col = input$txcol,tl.cex = input$tlcex,
                p.mat = res1$p, sig.level = as.numeric(input$sig)
              )
            }
            if (input$remove_corr > 0) {
              validate(
                need(input$selvar, "No input selected, supply me some variables to draw!")
              )
              x <- as.data.frame(subset(csvfile(), select = input$selvar))
              cormat1 <- cor(x, method = input$req2, use = "complete.obs")
              res1 <- corrplot::cor.mtest(x)
              corrplot::corrplot(cormat1,
                method = input$shape,
                type = input$layout, tl.col = "#000000",
                tl.cex = input$tlcex,
                col = brewer.pal(n = 8, name = input$style)
              )
            }

            if (input$remove_corr > 0 && input$significance > 0) {
              validate(
                need(input$selvar, "No input selected, supply me some variables to draw!")
              )
              x <- as.data.frame(subset(csvfile(), select = input$selvar))
              cormat1 <- cor(x, method = input$req2, use = "complete.obs")
              res1 <- corrplot::cor.mtest(x)
              corrplot::corrplot(cormat1,
                method = input$shape,
                type = input$layout, tl.col = "#000000",
                col = brewer.pal(n = 8, name = input$style),
                p.mat = res1$p, sig.level = as.numeric(input$sig),
                tl.cex = input$tlcex
              )
            }
          }
        },
        bg = "transparent"
      )
      plotOutput("corrplot")
    }
  })
  ##################



  ####################### download Report
  output$var1 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }
    if (input$req1 == "correlation") {
      if (is.null(input$submit)) {
        return()
      }
      if (input$submit > 0) {
        list(
          radioButtons("format", "Download report (Note: if you are changing the file name after download give '.html' extension):", c("HTML"),
            inline = TRUE
          ),
          downloadButton("downloadReport")
        )
      }
    }
    else if (input$req1 == "corrmat") {
      if (is.null(input$submit2)) {
        return()
      }
      if (input$submit2 > 0) {
        list(
          radioButtons("format", "Download report (Note: if you are changing the file name after download give '.html' extension):", c("HTML"),
            inline = TRUE
          ),
          downloadButton("downloadReport")
        )
      }
    }
  })


  output$downloadReport <- downloadHandler(
    filename = function() {
      paste("my-report", sep = ".", switch(input$format,
        HTML = "html"
      ))
    },
    content = function(file) {
      src <- normalizePath("report.Rmd")
      owd <- setwd(tempdir())
      on.exit(setwd(owd))
      file.copy(src, "report.Rmd", overwrite = TRUE)
      out <- render("report.Rmd", switch(input$format,
        HTML = html_document()
      ))
      file.rename(out, file)
    }
  )

  #############################################
  ############################### this note appear on opening
  output$note1 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return(
        HTML(paste0(" <h4> To perform analysis using your own dataset, prepare excel file in csv format by reading instruction below  </h4>
<p>
<ui>
<li>Open a new blank excel file</li>
<li>Copy and paste observations into a new sheet (use only one sheet) of a new excel file</li>
<li>Observations should be pasted as columns </li>
<li>Don't type or delete anything on other cells without data</li>
<li>You can use any names for your columns. No space is allowed in the Column name. If space is required use underscore ‘_’ or ‘.’ full stop; for example ‘Variable name’ should be written as Variable_name or Variable.name</li>
<li>Data should be arranged towards upper left corner and row above the data should not be left blank </li>
<li>Type 'NA' in the cell with no observation</li>
<li>Don't type and delete anything on other cells without data. If so select those cells, right click and click clear contents </li>
<li>Give names to all column, Don't add any unnecessary columns that is not required for analysis</li>
<li>Once all these are done, your file is ready. Now save it as CSV file. </li>
<li><b>Upload file by clicking browse in the app </b></li>
</ui>
</p>
<h5> You can download a model data set from below and test the App  </h5>
"))
      )
    }

    else {
      return()
    }
  })

  ########################################## dataset download
  output$data_set <- renderUI({
    if (is.null(input$file1$datapath)) {
      list(
        selectInput("dataset", "Choose a dataset:",
          choices = c("iris", "rock", "cars")
        ),
        downloadButton("downloadData", label = "Download csv file to test", class = "butt1")
      )
    }

    else {
      return()
    }
  })
  datasetInput <- reactive({
    switch(input$dataset,
      "iris" = iris,
      "rock" = rock,
      "cars" = cars
    )
  })

  output$downloadData <- downloadHandler(
    filename = function() {
      paste(input$dataset, ".csv", sep = "")
    },
    content = function(file) {
      write.csv(datasetInput(), file, row.names = FALSE)
    }
  )
  #######################################################

  #################################### Download Image
  output$image_down <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }

    if (input$req1 == "scatplot") {
      if (is.null(input$submit1)) {
        return()
      }
      if (input$submit1 > 0) {
        list(downloadButton("downloadImage1", label = "Download ScatterPlot", class = "butt1"))
      }
    }
    else if (input$req1 == "corrplot") {
      if (is.null(input$submit3)) {
        return()
      }
      if (input$submit3 > 0) {
        list(downloadButton("downloadImage2", label = "Download Correlogram", class = "butt1"))
      }
    }
  })
  ### plotting
  plotInput <- reactive({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }
    if (input$req1 == "scatplot") {
      if (is.null(input$submit1)) {
        return()
      }
      if (input$submit1 > 0) {
        x <- as.vector(csvfile()[, input$dvar])
        y <- as.vector(csvfile()[, input$ivar])
        plot(x, y,
          main = input$main,
          xlab = input$xlab, ylab = input$ylab,
          pch = 19, col = input$color, frame = FALSE
        )
      }
    }
    else if (input$req1 == "corrplot") {
      if (is.null(input$submit3)) {
        return()
      }
      if (input$submit3 > 0) {
        x <- as.data.frame(subset(csvfile(), select = input$selvar))
        cormat1 <- cor(x, method = input$req2, use = "complete.obs")
        corrplot::corrplot(cormat1,
          method = input$shape,
          type = input$layout, tl.col = "#000000",
          col = brewer.pal(n = 8, name = input$style),
          addCoef.col = input$txcol, number.cex = input$cex,
          tl.cex = input$tlcex
        )
        if (input$significance > 0) {
          x <- as.data.frame(subset(csvfile(), select = input$selvar))
          cormat1 <- cor(x, method = input$req2, use = "complete.obs")
          res1 <- corrplot::cor.mtest(x)
          corrplot::corrplot(cormat1,
            method = input$shape,
            type = input$layout, tl.col = "#000000",
            col = brewer.pal(n = 8, name = input$style), addCoef.col = input$txcol,
            p.mat = res1$p, sig.level = as.numeric(input$sig),tl.cex = input$tlcex
          )
        }
        if (input$remove_corr > 0) {
          x <- as.data.frame(subset(csvfile(), select = input$selvar))
          cormat1 <- cor(x, method = input$req2, use = "complete.obs")
          res1 <- corrplot::cor.mtest(x)
          corrplot::corrplot(cormat1,
            method = input$shape,
            type = input$layout, tl.col = "#000000",
            col = brewer.pal(n = 8, name = input$style),
            tl.cex = input$tlcex
          )
        }

        if (input$remove_corr > 0 && input$significance > 0) {
          x <- as.data.frame(subset(csvfile(), select = input$selvar))
          cormat1 <- cor(x, method = input$req2, use = "complete.obs")
          res1 <- corrplot::cor.mtest(x)
          corrplot::corrplot(cormat1,
            method = input$shape,
            type = input$layout, tl.col = "#000000",
            col = brewer.pal(n = 8, name = input$style),
            p.mat = res1$p, sig.level = as.numeric(input$sig),
            tl.cex = input$tlcex
          )
        }

        grid.echo()
        P1 <- grid.grab()

        grid.draw(P1)
      }
    }
  })



  ###
  output$downloadImage1 <- downloadHandler(
    filename = "scatter.png",
    content = function(file) {
      png(file,
        width = input$shiny_width,
        height = input$shiny_height,
        res = 150
      )
      plotInput()
      dev.off()
    }
  )

  output$downloadImage2 <- downloadHandler(
    filename = "corr.png",
    content = function(file) {
      png(file,
        width = input$shiny_width,
        height = input$shiny_height,
        res = 150
      )
      plotInput()
      dev.off()
    }
  )
  ###########################
}
shinyApp(ui = ui, server = server)

library(shiny)
library(shinyWidgets)
library(rmarkdown)
library(agricolae)
library(dplyr)
library(magrittr)
library(desplot)
library(knitr)

############################## Ui
ui <- fluidPage(
  setBackgroundColor(
    color = c("#fff291", "#ffffff"),
    gradient = "radial",
    direction = c("bottom", "right")
  ),
  titlePanel(
    title = tags$div(tags$b("Field Layout of experiments"), style = "color:#000000"),
    windowTitle = "Field Layout"
  ),
  sidebarPanel(
    selectInput(
      "design", tags$div(tags$b("Select the design for your experiment"),
        style = "color:#d17b02"
      ),
      c(
        "CRD" = "crd",
        "RBD" = "rbd",
        "Split Plot" = "split",
        "Augmented RCBD" = "aug",
        "Strip Plot" = "strip"
      ),
      "crd"
    ),
    h5("Note: consult a statistician before selecting proper design for your experiment"),

    ##
    uiOutput("var_crd"),
    uiOutput("var_rbd"),
    uiOutput("var_aug"),
    uiOutput("var_split"),
    uiOutput("var_strip"),
    tags$br(),
    htmlOutput("text_crd1"),
    htmlOutput("text_rbd1"),
    htmlOutput("text_aug1"),
    htmlOutput("text_split1"),
    htmlOutput("text_strip1"),
    uiOutput("var_crd1"),
    uiOutput("var_rbd1"),
    uiOutput("var_aug1"),
    uiOutput("var_split1"),
    uiOutput("var_strip1"),
    tags$br(),
    h5(" If the image is not clear you can generate a table format by clicking below"),
    uiOutput("tab_crd"),
    uiOutput("tab_rbd"),
    uiOutput("tab_aug"),
    uiOutput("tab_split"),
    uiOutput("tab_strip"),

    ##




    ##
    tags$br(),
    h5(
      tags$div(
        tags$br(),
        "Developed by:",
        tags$br(),
        tags$b("Dr.Pratheesh P. Gopinath"),
        tags$br(),
        tags$b("Assistant Professor,"),
        tags$br(),
        tags$b("Agricultural Statistics,"),
        tags$br(),
        tags$b("Kerala Agricultural University"),
        tags$br(),
        tags$br(),
        "Contribution:",
        tags$br(),
        tags$b("Adarsh V.S."),
        tags$br(),
        tags$b("MSc, Agricultural Statistics"),
        tags$br(),
        tags$br(),
        "post your queries at: pratheesh.pg@kau.in",
        style = "color:#343aeb"
      )
    )
  ),
  mainPanel(
    tableOutput("details_crd"),
    tags$style(type = "text/css", "#details_crd th,td {border: medium solid #000000;text-align:center}"),
    tags$style(type = "text/css", "#details_crd td {border: medium solid #000000;text-align:center}"),
    tableOutput("details_rbd"),
    tags$style(type = "text/css", "#details_rbd th,td {border: medium solid #000000;text-align:center}"),
    tags$style(type = "text/css", "#details_rbd td {border: medium solid #000000;text-align:center}"),
    tableOutput("details_aug"),
    tags$style(type = "text/css", "#details_aug th,td {border: medium solid #000000;text-align:center}"),
    tags$style(type = "text/css", "#details_aug td {border: medium solid #000000;text-align:center}"),
    tableOutput("details_split"),
    tags$style(type = "text/css", "#details_split th,td {border: medium solid #000000;text-align:center}"),
    tags$style(type = "text/css", "#details_split td {border: medium solid #000000;text-align:center}"),
    tableOutput("details_strip"),
    tags$style(type = "text/css", "#details_strip th,td {border: medium solid #000000;text-align:center}"),
    tags$style(type = "text/css", "#details_strip td {border: medium solid #000000;text-align:center}"),
    tags$br(),
    tableOutput("table_crd"),
    tags$style(type = "text/css", "#table_crd th,td {border: medium solid #000000;text-align:center}"),
    tags$style(type = "text/css", "#table_crd td {border: medium solid #000000;text-align:center}"),
    tableOutput("table_rbd"),
    tags$style(type = "text/css", "#table_rbd th,td {border: medium solid #000000;text-align:center}"),
    tags$style(type = "text/css", "#table_rbd td {border: medium solid #000000;text-align:center}"),
    tableOutput("table_aug"),
    tags$style(type = "text/css", "#table_aug th,td {border: medium solid #000000;text-align:center}"),
    tags$style(type = "text/css", "#table_aug td {border: medium solid #000000;text-align:center}"),
    tableOutput("table_split"),
    tags$style(type = "text/css", "#table_split th,td {border: medium solid #000000;text-align:center}"),
    tags$style(type = "text/css", "#table_split td {border: medium solid #000000;text-align:center}"),
    tableOutput("table_strip"),
    tags$style(type = "text/css", "#table_strip th,td {border: medium solid #000000;text-align:center}"),
    tags$style(type = "text/css", "#table_strip td {border: medium solid #000000;text-align:center}"),
    uiOutput("plot"),
    uiOutput("image_down1"),
    uiOutput("image_down2"),
    uiOutput("image_down3"),
    uiOutput("image_down4"),
    uiOutput("image_down5"),
    uiOutput("text_crd2"),
    uiOutput("text_rbd2"),
    uiOutput("text_aug2"),
    uiOutput("text_split2"),
    uiOutput("text_strip2"),
    tags$br(),
    uiOutput("text_crd3"),
    uiOutput("text_rbd3"),
    uiOutput("text_aug3"),
    uiOutput("text_split3"),
    uiOutput("text_strip3"),
    tags$br(),
    uiOutput("download_crd"),
    uiOutput("download_rbd"),
    uiOutput("download_aug"),
    uiOutput("download_split"),
    uiOutput("download_strip"),
    tags$br(),
    tags$br(),
    tags$br()
    ####
  )
)

server <- function(input, output, session) {

  ################### CRD
  output$var_crd <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (input$design == "crd") {
      list(numericInput("trt_crd", tags$div(tags$b("Please enter the number of treatments:"), style = "color:#a047ff"), 0, min = 2, max = 100))
    }
  })

  output$text_crd1 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$trt_crd)) {
      return()
    }
    if (input$design == "crd") {
      if (input$trt_crd >= 2) {
        t <- input$trt_crd
        minrep.req <- ((12 + t) / t)
        HTML(paste0(tags$b(" minimum number of replication
                            required is:", ceiling(minrep.req))))
      }
    }
    else {
      return()
    }
  })

  output$var_crd1 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$trt_crd)) {
      return()
    }
    if (input$design == "crd") {
      if (input$trt_crd >= 2) {
        list(
          tags$br(),
          numericInput("rep_crd", tags$div(tags$b("Please enter the number of replications:"), style = "color:#a047ff"), 0, min = 2, max = 100),
          tags$br(),
          actionBttn(
            inputId = "submit1",
            label = "Generate CRD Layout!",
            color = "success",
            style = "float"
          ),
          sliderInput("rand", "Generate random plots:",
            min = 1, max = 100, value = 1
          ),
          tags$br(),
          sliderInput("size", "Adjust label size of layout image here:",
            min = 0.1, max = 2, value = 1
          )
        )
      }
    }
  })


  output$details_crd <- renderTable(
    {
      if (is.null(input$rep_crd)) {
        return()
      }
      if (is.null(input$trt_crd)) {
        return()
      }
      if (is.null(input$design)) {
        return()
      }
      if (is.null(input$submit1)) {
        return()
      }
      if (input$design == "crd") {
        if (input$rep_crd > 0 && input$submit1 > 0) {
          Treatments <- input$trt_crd
          Replication <- input$rep_crd
          Experimental.units <- Treatments * Replication
          det <- cbind(Treatments, Replication, Experimental.units)
          det <- as.data.frame(det)
          det
        }
        else {
          return()
        }
      }
    },
    caption = ("<b> Details of the Experiment </b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = FALSE
  )

  output$text_crd2 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$rep_crd)) {
      return()
    }
    if (is.null(input$submit1)) {
      return()
    }
    if (input$design == "crd") {
      if (input$rep_crd == 0 && input$submit1 > 0) {
        HTML(paste0(tags$b("Please enter required
                            number of replications")))
      }
    }
    else {
      return()
    }
  })

  output$text_crd3 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$rep_crd)) {
      return()
    }
    if (is.null(input$trt_crd)) {
      return()
    }
    if (is.null(input$submit1)) {
      return()
    }
    if (input$design == "crd") {
      if (input$trt_crd > 0) {
        if (input$rep_crd > 0) {
          if (input$submit1 > 0) {
            HTML(paste0(tags$b("Each cell in the figure corresponds to an experimental unit ")))
          }
        }
      }
    }
  })

  ############################# END CRD

  ################### RBD
  output$var_rbd <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (input$design == "rbd") {
      list(numericInput("trt_rbd", tags$div(tags$b("Please enter the number of treatments:"), style = "color:#a047ff"), 0, min = 2, max = 100))
    }
  })

  output$text_rbd1 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$trt_rbd)) {
      return()
    }
    if (input$design == "rbd") {
      if (input$trt_rbd >= 2) {
        t <- input$trt_rbd
        minrep.req <- ((12 / (t - 1)) + 1)
        HTML(paste0(tags$b(" minimum number of blocks (replication) required is:", ceiling(minrep.req))))
      }
    }
    else {
      return()
    }
  })

  output$var_rbd1 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$trt_rbd)) {
      return()
    }
    if (input$design == "rbd") {
      if (input$trt_rbd >= 2) {
        list(
          tags$br(),
          numericInput("rep_rbd", tags$div(tags$b("Please enter the number of Blocks (replications):"), style = "color:#a047ff"), 0, min = 2, max = 100),
          tags$br(),
          actionBttn(
            inputId = "submit2",
            label = "Generate RCBD Layout!",
            color = "success",
            style = "float"
          ),
          sliderInput("rand2", "Generate random plots:",
            min = 1, max = 100, value = 1
          ),
          tags$br(),
          sliderInput("size_rbd", "Adjust label size of layout image here:",
            min = 0.1, max = 2, value = 1
          )
        )
      }
    }
  })

  output$details_rbd <- renderTable(
    {
      if (is.null(input$design)) {
        return()
      }
      if (is.null(input$rep_rbd)) {
        return()
      }
      if (is.null(input$trt_rbd)) {
        return()
      }
      if (is.null(input$submit2)) {
        return()
      }
      if (input$design == "rbd") {
        if (input$rep_rbd > 0 && input$submit2 > 0) {
          Treatments <- input$trt_rbd
          Blocks <- input$rep_rbd
          Experimental.units <- Treatments * Blocks
          det <- cbind(Treatments, Blocks, Experimental.units)
          det <- as.data.frame(det)
          det
        }
        else {
          return()
        }
      }
    },
    caption = ("<b> Details of the Experiment </b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = FALSE
  )

  output$text_rbd2 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$rep_rbd)) {
      return()
    }
    if (is.null(input$submit2)) {
      return()
    }
    if (input$design == "rbd") {
      if (input$rep_rbd == 0 && input$submit2 > 0) {
        HTML(paste0(tags$b("Please enter required
                            number of replications")))
      }
    }
    else {
      return()
    }
  })

  output$text_rbd3 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$rep_rbd)) {
      return()
    }
    if (is.null(input$trt_rbd)) {
      return()
    }
    if (is.null(input$submit2)) {
      return()
    }
    if (input$design == "rbd") {
      if (input$trt_rbd > 0) {
        if (input$rep_rbd > 0) {
          if (input$submit2 > 0) {
            HTML(paste0(tags$b("Each columns in the figure corresponds to a block ")))
          }
        }
      }
    }
  })

  ############################# END RBD

  ############################# AUGMENTED RCBD
  output$var_aug <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (input$design == "aug") {
      list(
        numericInput("check_aug",
          tags$div(tags$b("Please enter the number of Checks (Controls):"),
            style = "color:#a047ff"
          ), 0,
          min = 2, max = 100
        ),
        numericInput("trt_aug",
          tags$div(tags$b("Please enter the number of treatments (unreplicated):"),
            style = "color:#a047ff"
          ), 0,
          min = 2, max = 200
        )
      )
    }
  })


  output$text_aug1 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$check_aug)) {
      return()
    }
    if (input$design == "aug") {
      if (input$check_aug >= 2) {
        t <- input$check_aug
        minrep.req <- ((12 / (t - 1)) + 1)
        HTML(paste0(tags$b(" You should enter sufficiently large number of blocks below
                            . Number of blocks should be greater than:", ceiling(minrep.req))))
      }
    }
    else {
      return()
    }
  })

  output$var_aug1 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$check_aug)) {
      return()
    }
    if (input$design == "aug") {
      if (input$check_aug >= 2) {
        list(
          tags$br(),
          numericInput("rep_aug", tags$div(tags$b("Please enter the number of Blocks:"), style = "color:#a047ff"), 0, min = 2, max = 100),
          tags$br(),
          actionBttn(
            inputId = "submit3",
            label = "Generate Augmented RCBD Layout!",
            color = "success",
            style = "float"
          ),
          sliderInput("rand3", "Generate random plots:",
            min = 1, max = 100, value = 1
          ),
          tags$br(),
          sliderInput("size_aug", "Adjust label size of layout image here:",
            min = 0.1, max = 2, value = 1
          )
        )
      }
    }
  })

  output$text_aug2 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$rep_aug)) {
      return()
    }
    if (is.null(input$submit3)) {
      return()
    }
    if (input$design == "aug") {
      if (input$rep_aug == 0 && input$submit3 > 0) {
        HTML(paste0(tags$b("Please enter required
                            number of replications")))
      }
    }
    else {
      return()
    }
  })


  output$details_aug <- renderTable(
    {
      if (is.null(input$design)) {
        return()
      }
      if (is.null(input$rep_aug)) {
        return()
      }
      if (is.null(input$trt_aug)) {
        return()
      }
      if (is.null(input$check_aug)) {
        return()
      }
      if (is.null(input$submit3)) {
        return()
      }
      if (input$design == "aug") {
        if (input$check_aug > 0 && input$trt_aug && input$rep_aug > 0 && input$submit3 > 0) {
          Check <- input$check_aug
          Treatments <- input$trt_aug
          Blocks <- input$rep_aug
          Plots <- Check * Blocks + Treatments
          det <- cbind(Check, Treatments, Blocks, Plots)
          det <- as.data.frame(det)
          det
        }
        else {
          return()
        }
      }
    },
    caption = ("<b> Details of the Experiment)</b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = FALSE
  )

  output$text_aug3 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$rep_aug)) {
      return()
    }
    if (is.null(input$trt_aug)) {
      return()
    }
    if (is.null(input$check_aug)) {
      return()
    }
    if (is.null(input$submit3)) {
      return()
    }
    if (input$design == "aug") {
      if (input$trt_aug > 0) {
        if (input$rep_aug > 0) {
          if (input$check_aug > 0) {
            if (input$submit3 > 0) {
              HTML(paste0(tags$b("Treatment numbers are shown in cells (plots).
                                Each columns in the figure corresponds to a block ")))
            }
          }
        }
      }
    }
  })

  ############################################ SPLIT PLOT
  output$var_split <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (input$design == "split") {
      list(
        numericInput("maintrt_split",
          tags$div(tags$b("Please enter the number of Main plot treatments:"),
            style = "color:#a047ff"
          ), 0,
          min = 2, max = 100
        ),
        numericInput("subtrt_split",
          tags$div(tags$b("Please enter the number of Sub plot treatments:"),
            style = "color:#a047ff"
          ), 0,
          min = 2, max = 200
        )
      )
    }
  })


  output$text_split1 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$maintrt_split)) {
      return()
    }
    if (is.null(input$subtrt_split)) {
      return()
    }
    if (input$design == "split") {
      if (input$maintrt_split >= 2 && input$subtrt_split >= 2) {
        a <- input$maintrt_split
        b <- input$subtrt_split
        minrep.req <- ((12 / ((b - 1) * a)) + 1)
        HTML(paste0(tags$b(" minimum number of replication required is:", ceiling(minrep.req))))
      }
    }
    else {
      return()
    }
  })

  output$text_split2 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$rep_split)) {
      return()
    }
    if (is.null(input$submit4)) {
      return()
    }
    if (input$design == "split") {
      if (input$rep_split == 0 && input$submit4 > 0) {
        HTML(paste0(tags$b("Please enter required
                            number of replications")))
      }
    }
    else {
      return()
    }
  })
  output$var_split1 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$maintrt_split)) {
      return()
    }
    if (is.null(input$subtrt_split)) {
      return()
    }
    if (input$design == "split") {
      if (input$maintrt_split >= 2 && input$subtrt_split >= 2) {
        list(
          tags$br(),
          numericInput("rep_split", tags$div(tags$b("Please enter the required number of replication:"), style = "color:#a047ff"), 0, min = 2, max = 100),
          tags$br(),
          actionBttn(
            inputId = "submit4",
            label = "Generate Split Plot Layout!",
            color = "success",
            style = "float"
          ),
          sliderInput("rand4", "Generate random plots:",
            min = 1, max = 100, value = 1
          ),
          tags$br(),
          sliderInput("size_split", "Adjust label size of layout image here:",
            min = 0.1, max = 2, value = 1
          )
        )
      }
    }
  })

  output$text_split3 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$rep_split)) {
      return()
    }
    if (is.null(input$maintrt_split)) {
      return()
    }
    if (is.null(input$subtrt_split)) {
      return()
    }
    if (is.null(input$submit4)) {
      return()
    }
    if (input$design == "split") {
      if (input$maintrt_split > 0) {
        if (input$rep_split > 0) {
          if (input$subtrt_split > 0) {
            if (input$submit4 > 0) {
              HTML(paste0(tags$b("Each column corresponds to mainplot. Mainplot treatments are
                                  applied in the columns shown by corresponding colour. Subplot
                                  treatment numbers are shown in each cells shown by treatment number
                                  (sub plots).")))
            }
          }
        }
      }
    }
  })

  output$details_split <- renderTable(
    {
      if (is.null(input$design)) {
        return()
      }
      if (is.null(input$rep_split)) {
        return()
      }
      if (is.null(input$maintrt_split)) {
        return()
      }
      if (is.null(input$subtrt_split)) {
        return()
      }
      if (is.null(input$submit4)) {
        return()
      }
      if (input$design == "split") {
        if (input$maintrt_split > 0 && input$subtrt_split && input$rep_split > 0 &&
          input$submit4 > 0) {
          Main_plot_trt <- input$maintrt_split
          Sub_plot_trt <- input$subtrt_split
          Replications <- input$rep_split
          No_of_Plots <- Main_plot_trt * Sub_plot_trt * Replications
          det <- cbind(Main_plot_trt, Sub_plot_trt, Replications, No_of_Plots)
          det <- as.data.frame(det)
          det
        }
        else {
          return()
        }
      }
    },
    caption = ("<b> Details of the experiment </b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = FALSE
  )

  ############################################ STRIP PLOT
  output$var_strip <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (input$design == "strip") {
      list(
        numericInput("maintrt_strip",
          tags$div(tags$b("Please enter the number of Main plot A treatments:"),
            style = "color:#a047ff"
          ), 0,
          min = 2, max = 100
        ),
        numericInput("subtrt_strip",
          tags$div(tags$b("Please enter the number of Main plot B treatments:"),
            style = "color:#a047ff"
          ), 0,
          min = 2, max = 200
        )
      )
    }
  })


  output$text_strip1 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$maintrt_strip)) {
      return()
    }
    if (is.null(input$subtrt_strip)) {
      return()
    }
    if (input$design == "strip") {
      if (input$maintrt_strip >= 2 && input$subtrt_strip >= 2) {
        a <- input$maintrt_strip
        b <- input$subtrt_strip
        minrep.req <- ((12 / ((b - 1) * (a - 1))) + 1)
        HTML(paste0(tags$b(" minimum number of replication required is:", ceiling(minrep.req))))
      }
    }
    else {
      return()
    }
  })

  output$text_strip2 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$rep_strip)) {
      return()
    }
    if (is.null(input$submit5)) {
      return()
    }
    if (input$design == "strip") {
      if (input$rep_strip == 0 && input$submit5 > 0) {
        HTML(paste0(tags$b("Please enter required
                            number of replications")))
      }
    }
    else {
      return()
    }
  })
  output$var_strip1 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$maintrt_strip)) {
      return()
    }
    if (is.null(input$subtrt_strip)) {
      return()
    }
    if (input$design == "strip") {
      if (input$maintrt_strip >= 2 && input$subtrt_strip >= 2) {
        list(
          tags$br(),
          numericInput("rep_strip", tags$div(tags$b("Please enter the required number of replication:"), style = "color:#a047ff"), 0, min = 2, max = 100),
          tags$br(),
          actionBttn(
            inputId = "submit5",
            label = "Generate Strip Plot Layout!",
            color = "success",
            style = "float"
          ),
          sliderInput("rand5", "Generate random plots:",
            min = 1, max = 100, value = 1
          ),
          tags$br(),
          sliderInput("size_strip", "Adjust label size of layout image here:",
            min = 0.1, max = 2, value = 1
          )
        )
      }
    }
  })

  output$text_strip3 <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$rep_strip)) {
      return()
    }
    if (is.null(input$maintrt_strip)) {
      return()
    }
    if (is.null(input$subtrt_strip)) {
      return()
    }
    if (is.null(input$submit5)) {
      return()
    }
    if (input$design == "strip") {
      if (input$maintrt_strip > 0) {
        if (input$rep_strip > 0) {
          if (input$subtrt_strip > 0) {
            if (input$submit5 > 0) {
              rep <- input$rep_strip
              HTML(paste0(tags$b("Main Plot treatment A is applied in rows (shown by corresponding colour) and
                                  Main Plot treatment B is applied in columns (shown by letters).
                                  Replications are shown seperately (diagonally)")))
            }
          }
        }
      }
    }
  })

  output$details_strip <- renderTable(
    {
      if (is.null(input$design)) {
        return()
      }
      if (is.null(input$rep_strip)) {
        return()
      }
      if (is.null(input$maintrt_strip)) {
        return()
      }
      if (is.null(input$subtrt_strip)) {
        return()
      }
      if (is.null(input$submit5)) {
        return()
      }
      if (input$design == "strip") {
        if (input$maintrt_strip > 0 && input$subtrt_strip && input$rep_strip > 0 &&
          input$submit5 > 0) {
          Main_plot_A <- input$maintrt_strip
          Main_plot_B <- input$subtrt_strip
          Replications <- input$rep_strip
          No_of_Plots <- Main_plot_A * Main_plot_B * Replications
          det <- cbind(Main_plot_A, Main_plot_B, Replications, No_of_Plots)
          det <- as.data.frame(det)
          det
        }
        else {
          return()
        }
      }
    },
    caption = ("<b> Details of the experiment </b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = FALSE
  )


  ################################## Layout plots
  output$plot <- renderUI({
    if (is.null(input$design)) {
      return()
    }

    if (input$design == "crd") {
      if (is.null(input$rep_crd)) {
        return()
      }
      if (is.null(input$trt_crd)) {
        return()
      }
      if (is.null(input$submit1)) {
        return()
      }

      if (input$trt_crd > 0) {
        if (input$rep_crd > 0) {
          output$crd_layout <- renderPlot(
            {
              if (input$submit1 > 0) {
                t <- input$trt_crd
                r <- input$rep_crd
                s <- input$size
                rand <- input$rand
                trtname <- sprintf("T%d", 1:t)
                outdesign <- agricolae::design.crd(trtname, r = r, seed = rand, serie = 0, kinds = "Super-Duper", randomization = TRUE)
                CRD <- outdesign$book
                CRD <- CRD[order(CRD$r), ]
                CRD$col <- CRD$r
                CRD$row <- rep(1:t, r)
                desplot::desplot(
                  form = trtname ~ col + row, data = CRD, text = trtname, out1 = col,
                  out2 = row, out2.gpar = list(col = "black", lwd = 3),
                  cex = s, main = "Layout of Completely Randomized Design", show.key = FALSE
                )
              }
            },
            bg = "transparent"
          )
          h <- input$trt_crd * 50
          w <- input$rep_crd * 100
          plotOutput("crd_layout", width = w, height = h)
        }
      }
    }
    else if (input$design == "rbd") {
      if (is.null(input$trt_rbd)) {
        return()
      }
      if (is.null(input$submit2)) {
        return()
      }
      if (is.null(input$rep_rbd)) {
        return()
      }

      if (input$trt_rbd > 0) {
        if (input$rep_rbd > 0) {
          output$rbd_layout <- renderPlot(
            {
              if (input$submit2 > 0) {
                t <- input$trt_rbd
                rep <- input$rep_rbd
                s <- input$size_rbd
                rand <- input$rand2
                trtname <- sprintf("T%d", 1:t)
                n <- t * rep
                outdesign <- agricolae::design.rcbd(trt = trtname, r = rep, seed = rand, serie = 0, kinds = "Super-Duper", randomization = TRUE)
                RBD <- outdesign$book
                RBD <- RBD[order(RBD$block), ]
                RBD$blocks <- as.numeric(RBD$block)
                RBD$plots <- rep(1:t, rep)
                desplot::desplot(
                  form = block ~ blocks + plots, data = RBD, text = trtname, out1 = blocks,
                  out2 = plots, out2.gpar = list(col = "green"),
                  cex = s, main = "Layout of Randomized Block Design", show.key = TRUE
                )
              }
            },
            bg = "transparent"
          )

          h <- input$trt_rbd * 80
          w <- input$rep_rbd * 100
          plotOutput("rbd_layout", width = w, height = h)
        }
      }
    }

    else if (input$design == "aug") {
      if (is.null(input$trt_aug)) {
        return()
      }
      if (is.null(input$submit3)) {
        return()
      }
      if (is.null(input$rep_aug)) {
        return()
      }
      if (is.null(input$check_aug)) {
        return()
      }

      if (input$check_aug > 0) {
        if (input$trt_aug > 0) {
          if (input$rep_aug > 0) {
            output$aug_layout <- renderPlot(
              {
                if (input$submit3 > 0) {
                  NC <- input$check_aug # no. of check
                  blk <- input$rep_aug # no: of Blocks
                  trt <- input$trt_aug # no.of trt
                  s <- input$size_aug
                  rand <- input$rand3
                  T1 <- sprintf("C%d", 1:NC) # checks
                  T2 <- sprintf("T%d", 1:trt) # treatments
                  outdesign <- agricolae::design.dau(T1, T2, r = blk, seed = rand, serie = 0, randomization = TRUE)
                  aug <- outdesign$book
                  aug <- aug[order(aug$block), ]
                  aug$blocks <- as.numeric(aug$block)
                  x <- aug %>%
                    group_by(block) %>%
                    mutate(row = row_number())
                  aug1 <- as.data.frame(cbind(aug, row = x$row))
                  desplot::desplot(
                    form = block ~ blocks + row, data = aug1, text = trt, out1 = blocks, out2 = row,
                    cex = s, main = "Layout of Augmented Randomized Block Design", show.key = FALSE
                  )
                }
              },
              bg = "transparent"
            )

            h <- ((input$trt_aug / input$rep_aug) * 80)
            w <- input$rep_aug * 70
            plotOutput("aug_layout", width = w, height = h)
          }
        }
      }
    }

    else if (input$design == "strip") {
      if (is.null(input$maintrt_strip)) {
        return()
      }
      if (is.null(input$submit5)) {
        return()
      }
      if (is.null(input$rep_strip)) {
        return()
      }
      if (is.null(input$subtrt_strip)) {
        return()
      }

      if (input$maintrt_strip > 0) {
        if (input$subtrt_strip > 0) {
          if (input$rep_strip > 0) {
            output$strip_layout <- renderPlot(
              {
                if (input$submit5 > 0) {
                  a <- input$maintrt_strip
                  b <- input$subtrt_strip
                  rep <- input$rep_strip
                  s <- input$size_strip
                  rand <- input$rand5
                  main1 <- sprintf("A%d", 1:a)
                  main2 <- sprintf("B%d", 1:b)
                  outdesign <- agricolae::design.strip(main1, main2, r = rep, serie = 0, seed = rand, kinds = "Super-Duper", randomization = TRUE)
                  strip <- outdesign$book
                  strip$block2 <- strip$block
                  v1 <- do.call(paste, as.data.frame(t(apply(strip[4:5], 1, sort))))
                  strip$row <- match(v1, unique(v1))
                  v2 <- do.call(paste, as.data.frame(t(apply(strip[2:3], 1, sort))))
                  strip$column <- match(v2, unique(v2))
                  desplot::desplot(
                    form = main1 ~ row + column, data = strip, text = main2, out1 = column,
                    out2 = row, out2.gpar = list(col = "#a83232"),
                    cex = s, main = "Layout of Strip-Plot Design", show.key = TRUE
                  )
                }
              },
              bg = "transparent"
            )

            plotOutput("strip_layout")
          }
        }
      }
    }

    else if (input$design == "split") {
      if (is.null(input$maintrt_split)) {
        return()
      }
      if (is.null(input$submit4)) {
        return()
      }
      if (is.null(input$rep_split)) {
        return()
      }
      if (is.null(input$subtrt_split)) {
        return()
      }

      if (input$maintrt_split > 0) {
        if (input$subtrt_split > 0) {
          if (input$rep_split > 0) {
            output$split_layout <- renderPlot(
              {
                if (input$submit4 > 0) {
                  a <- input$maintrt_split
                  b <- input$subtrt_split
                  rep <- input$rep_split
                  s <- input$size_split
                  rand <- input$rand4
                  main <- sprintf("A%d", 1:a)
                  sub <- sprintf("b%d", 1:b)
                  outdesign <- agricolae::design.split(main, sub, r = rep, serie = 0, seed = rand, kinds = "Super-Duper", randomization = TRUE)
                  split <- outdesign$book
                  split <- split[order(split$plots), ]
                  split$plots <- split$plots
                  split$plots <- as.numeric(split$plots)
                  split$splots <- as.numeric(split$splots)
                  desplot::desplot(
                    form = main ~ plots + splots, data = split, col = main, text = sub, out1 = plots, out2 = splots,
                    cex = s, main = "Layout of Split-Plot Design", show.key = TRUE
                  )
                }
              },
              bg = "transparent"
            )

            plotOutput("split_layout")
          }
        }
      }
    }
  })
  ########### layout end

  ############################# table output
  #### tab
  output$tab_crd <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (input$design == "crd") {
      if (is.null(input$trt_crd)) {
        return()
      }
      if (input$trt_crd >= 2) {
        list(actionBttn(
          inputId = "table_butt1",
          label = "Create layout in table format!",
          color = "success",
          style = "stretch"
        ))
      }
    }
  })

  output$tab_rbd <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (input$design == "rbd") {
      if (is.null(input$trt_rbd)) {
        return()
      }
      if (input$trt_rbd >= 2) {
        list(actionBttn(
          inputId = "table_butt2",
          label = "Create layout in table format!",
          color = "success",
          style = "stretch"
        ))
      }
    }
  })


  output$tab_aug <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (input$design == "aug") {
      if (is.null(input$check_aug)) {
        return()
      }
      if (input$check_aug >= 2) {
        list(actionBttn(
          inputId = "table_butt3",
          label = "Create layout in table format!",
          color = "success",
          style = "stretch"
        ))
      }
    }
  })

  output$tab_split <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (input$design == "split") {
      if (is.null(input$maintrt_split)) {
        return()
      }
      if (input$maintrt_split >= 2) {
        list(actionBttn(
          inputId = "table_butt4",
          label = "Create layout in table format!",
          color = "success",
          style = "stretch"
        ))
      }
    }
  })

  output$tab_strip <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (input$design == "strip") {
      if (is.null(input$maintrt_strip)) {
        return()
      }
      if (input$maintrt_strip >= 2) {
        list(actionBttn(
          inputId = "table_butt5",
          label = "Create layout in table format!",
          color = "success",
          style = "stretch"
        ))
      }
    }
  })

  ##### table layout

  output$table_crd <- renderTable(
    {
      if (is.null(input$design)) {
        return()
      }
      if (is.null(input$trt_crd)) {
        return()
      }
      if (is.null(input$table_butt1)) {
        return()
      }
      if (is.null(input$rep_crd)) {
        return()
      }
      if (input$design == "crd") {
        if (input$table_butt1 > 0) {
          t <- input$trt_crd
          r <- input$rep_crd
          n <- t * r
          trtname <- sprintf("T%d", 1:t)
          outdesign <- agricolae::design.crd(trtname, r = r, seed = input$rand, serie = 0, kinds = "Super-Duper", randomization = TRUE)
          CRD <- outdesign$book
          CRD <- CRD[order(CRD$r), ]
          CRD$exp <- rep(1:n)
          final <- as.data.frame(cbind(Experimental.Unit = CRD$exp, Treatments = as.character(CRD$trtname)))
          final
        }
      }
    },
    caption = ("<b> Treatment allocation (random)</b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = FALSE
  )

  output$table_rbd <- renderTable(
    {
      if (is.null(input$design)) {
        return()
      }
      if (is.null(input$trt_rbd)) {
        return()
      }
      if (is.null(input$rep_rbd)) {
        return()
      }
      if (is.null(input$table_butt2)) {
        return()
      }
      if (input$design == "rbd") {
        if (input$table_butt2 > 0) {
          t <- input$trt_rbd
          rep <- input$rep_rbd
          trtname <- sprintf("T%d", 1:t)
          n <- t * rep
          outdesign <- agricolae::design.rcbd(trt = trtname, r = rep, seed = input$rand2, serie = 0, kinds = "Super-Duper", randomization = TRUE)
          RBD <- outdesign$book
          RBD <- RBD[order(RBD$block), ]
          RBD$plot <- rep(1:t, rep)
          final <- as.data.frame(cbind(Block = RBD$block, Plot = RBD$plot, Treatment = as.character(RBD$trtname)))
          final
        }
      }
    },
    caption = ("<b> Treatment allocation (random)</b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = FALSE
  )

  output$table_aug <- renderTable(
    {
      if (is.null(input$trt_aug)) {
        return()
      }
      if (is.null(input$submit3)) {
        return()
      }
      if (is.null(input$rep_aug)) {
        return()
      }
      if (is.null(input$check_aug)) {
        return()
      }
      if (is.null(input$table_butt3)) {
        return()
      }
      if (input$design == "aug") {
        if (input$table_butt3 > 0) {
          NC <- input$check_aug # no. of check
          blk <- input$rep_aug # no: of Blocks
          trt <- input$trt_aug # no.of trt
          s <- input$size_aug
          T1 <- sprintf("C%d", 1:NC) # checks
          T2 <- sprintf("T%d", 1:trt) # treatments
          outdesign <- agricolae::design.dau(T1, T2, r = blk, seed = input$rand3, serie = 0, randomization = TRUE)
          aug <- outdesign$book
          aug <- aug[order(aug$block), ]
          x1 <- aug %>%
            group_by(block) %>%
            mutate(Plot = row_number())
          final <- as.data.frame(cbind(Block = x1$block, Plot = x1$Plot, Treatment = as.character(x1$trt)))
          final
        }
      }
    },
    caption = ("<b> Treatment allocation (random)</b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = FALSE
  )

  output$table_split <- renderTable(
    {
      if (is.null(input$design)) {
        return()
      }
      if (is.null(input$rep_split)) {
        return()
      }
      if (is.null(input$maintrt_split)) {
        return()
      }
      if (is.null(input$subtrt_split)) {
        return()
      }
      if (is.null(input$submit4)) {
        return()
      }
      if (is.null(input$table_butt4)) {
        return()
      }
      if (input$design == "split") {
        if (input$table_butt4 > 0) {
          a <- input$maintrt_split
          b <- input$subtrt_split
          rep <- input$rep_split
          s <- input$size_split
          main <- sprintf("A%d", 1:a)
          sub <- sprintf("b%d", 1:b)
          outdesign <- agricolae::design.split(main, sub, r = rep, serie = 0, seed = input$rand4, kinds = "Super-Duper", randomization = TRUE)
          split <- outdesign$book
          split <- split[order(split$plots), ]
          final <- as.data.frame(cbind(
            Main_plot = split$plots, Sub_plot = split$splots,
            Replication = split$block, Main_treatment = as.character(split$main), Sub_treatment = as.character(split$sub)
          ))
          final
        }
      }
    },
    caption = ("<b> Treatment allocation (random)</b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = FALSE
  )

  output$table_strip <- renderTable(
    {
      if (is.null(input$design)) {
        return()
      }
      if (is.null(input$rep_strip)) {
        return()
      }
      if (is.null(input$maintrt_strip)) {
        return()
      }
      if (is.null(input$subtrt_strip)) {
        return()
      }
      if (is.null(input$submit5)) {
        return()
      }
      if (is.null(input$table_butt5)) {
        return()
      }
      if (input$design == "strip") {
        if (input$table_butt5 > 0) {
          a <- input$maintrt_strip
          b <- input$subtrt_strip
          rep <- input$rep_strip
          s <- input$size_strip
          main1 <- sprintf("A%d", 1:a)
          main2 <- sprintf("B%d", 1:b)
          outdesign <- agricolae::design.strip(main1, main2, r = rep, serie = 0, seed = input$rand5, kinds = "Super-Duper", randomization = TRUE)
          strip <- outdesign$book
          strip$block2 <- strip$block
          v1 <- do.call(paste, as.data.frame(t(apply(strip[4:5], 1, sort))))
          strip$row <- match(v1, unique(v1))
          v2 <- do.call(paste, as.data.frame(t(apply(strip[2:3], 1, sort))))
          strip$column <- match(v2, unique(v2))
          final <- as.data.frame(cbind(
            Replication = strip$block, Horizontal_row_No. = strip$row,
            Treatment_A = as.character(strip$main1),
            Vertical_row_No. = strip$column,
            Treatment_B = as.character(strip$main2)
          ))
          final
        }
      }
    },
    caption = ("<b> Treatment allocation (random)</b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = FALSE
  )
  ############ table end

  ####################### download Report
  output$download_crd <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$rep_crd)) {
      return()
    }
    if (is.null(input$trt_crd)) {
      return()
    }
    if (is.null(input$submit1)) {
      return()
    }
    if (input$design == "crd") {
      if (input$trt_crd > 0) {
        if (input$rep_crd > 0) {
          if (input$submit1 > 0) {
            list(
              radioButtons("format", "Download report:", c("HTML"),
                inline = TRUE
              ),
              downloadButton("downloadReport")
            )
          }
        }
      }
    }
  })

  output$download_rbd <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$rep_rbd)) {
      return()
    }
    if (is.null(input$trt_rbd)) {
      return()
    }
    if (is.null(input$submit2)) {
      return()
    }
    if (input$design == "rbd") {
      if (input$trt_rbd > 0) {
        if (input$rep_rbd > 0) {
          if (input$submit2 > 0) {
            list(
              radioButtons("format", "Download report:", c("HTML"),
                inline = TRUE
              ),
              downloadButton("downloadReport")
            )
          }
        }
      }
    }
  })

  output$download_aug <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$rep_aug)) {
      return()
    }
    if (is.null(input$trt_aug)) {
      return()
    }
    if (is.null(input$check_aug)) {
      return()
    }
    if (is.null(input$submit3)) {
      return()
    }
    if (input$design == "aug") {
      if (input$trt_aug > 0) {
        if (input$rep_aug > 0) {
          if (input$check_aug > 0) {
            if (input$submit3 > 0) {
              list(
                radioButtons("format", "Download report:", c("HTML"),
                  inline = TRUE
                ),
                downloadButton("downloadReport")
              )
            }
          }
        }
      }
    }
  })

  output$download_split <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$rep_split)) {
      return()
    }
    if (is.null(input$maintrt_split)) {
      return()
    }
    if (is.null(input$subtrt_split)) {
      return()
    }
    if (is.null(input$submit4)) {
      return()
    }
    if (input$design == "split") {
      if (input$maintrt_split > 0) {
        if (input$rep_split > 0) {
          if (input$subtrt_split > 0) {
            if (input$submit4 > 0) {
              list(
                radioButtons("format", "Download report:", c("HTML"),
                  inline = TRUE
                ),
                downloadButton("downloadReport")
              )
            }
          }
        }
      }
    }
  })

  output$download_strip <- renderUI({
    if (is.null(input$design)) {
      return()
    }
    if (is.null(input$rep_strip)) {
      return()
    }
    if (is.null(input$maintrt_strip)) {
      return()
    }
    if (is.null(input$subtrt_strip)) {
      return()
    }
    if (is.null(input$submit5)) {
      return()
    }
    if (input$design == "strip") {
      if (input$maintrt_strip > 0) {
        if (input$rep_strip > 0) {
          if (input$subtrt_strip > 0) {
            if (input$submit5 > 0) {
              list(
                radioButtons("format", "Download report:", c("HTML"),
                  inline = TRUE
                ),
                downloadButton("downloadReport")
              )
            }
          }
        }
      }
    }
  })

  output$downloadReport <- downloadHandler(
    filename = function() {
      paste("my-report", sep = ".", switch(input$format,
        HTML = "html"
      ))
    },
    content = function(file) {
      src <- normalizePath("report.Rmd")
      owd <- setwd(tempdir())
      on.exit(setwd(owd))
      file.copy(src, "report.Rmd", overwrite = TRUE)
      out <- render("report.Rmd", switch(input$format,
        HTML = html_document()
      ))
      file.rename(out, file)
    }
  )
}
shinyApp(ui = ui, server = server)

library(shiny)
library(shinyWidgets)
library(datasets)
library(rmarkdown)
library(dplyr)
library(ggplot2)
library(pastecs)
library(ggpubr)
library(PairedData)
library(reshape2)
############################### Ui
ui <- fluidPage(
  setBackgroundColor(
    color = c("#ffb9b3", "#ffffff"),
    gradient = "radial",
    direction = c("bottom", "right")
  ),
  titlePanel(title = tags$div(
    tags$b("Compare means: Small sample tests", style = "color:#000000")
  ), windowTitle = "Compare means"),
  sidebarPanel(
    fileInput(
      "file1",
      "CSV File (upload in csv format)",
      accept = c("text/csv", "text/comma-separated-values,text/plain", ".csv")
    ),
    checkboxInput("header", "Header", TRUE),
    selectInput(
      "req1",
      "Please select the analysis type",
      c(
        "Two sample t-test" = "ttest",
        "Paired t-test" = "pttest",
        "One sample t-test" = "ottest",
        "Welch two sample t-test" = "wttest",
        "Test Homogenity of variance" = "ftest",
        "Box Plot" = "boxplot",
        "Paired plot" = "pplot"
      ),
      "ttest"
    ),
    uiOutput("var"),
    tags$br(),
    tags$br(),
    h5(
      tags$div(
        tags$br(),
        "Developed by:",
        tags$br(),
        tags$b("Dr.Pratheesh P. Gopinath"),
        tags$br(),
        tags$b("Assistant Professor,"),
        tags$br(),
        tags$b("Agricultural Statistics,"),
        tags$br(),
        tags$b("Kerala Agricultural University"),
        tags$br(),
        tags$br(),
        "Contribution:",
        tags$br(),
        tags$b("Adarsh V.S."),
        tags$br(),
        tags$b("MSc, Agricultural Statistics"),
        tags$br(),
        tags$br(),
        "post your queries at: pratheesh.pg@kau.in",
        style = "color:#343aeb"
      )
    )
  ),
  mainPanel(
    uiOutput("start_note"),
    tableOutput("summary1"),
    # summary
    tags$style(
      type = "text/css",
      "#summary1 th,td {border: medium solid #000000;text-align:center}"
    ),
    tags$style(
      type = "text/css",
      "#summary1 td {border: medium solid #000000;text-align:center}"
    ),
    tableOutput("ttest"),
    # two sample ttest
    tags$style(
      type = "text/css",
      "#ttest th,td {border: medium solid #000000;text-align:center}"
    ),
    tags$style(
      type = "text/css",
      "#ttest td {border: medium solid #000000;text-align:center}"
    ),
    htmlOutput("note1"),
    tableOutput("summary2"),
    # summary
    tags$style(
      type = "text/css",
      "#summary2 th,td {border: medium solid #000000;text-align:center}"
    ),
    tags$style(
      type = "text/css",
      "#summary2 td {border: medium solid #000000;text-align:center}"
    ),
    tableOutput("wttest"),
    # welch sample ttest
    tags$style(
      type = "text/css",
      "#wttest th,td {border: medium solid #000000;text-align:center}"
    ),
    tags$style(
      type = "text/css",
      "#wttest td {border: medium solid #000000;text-align:center}"
    ),
    htmlOutput("note2"),
    tableOutput("summary3"),
    # summary
    tags$style(
      type = "text/css",
      "#summary3 th,td {border: medium solid #000000;text-align:center}"
    ),
    tags$style(
      type = "text/css",
      "#summary3 td {border: medium solid #000000;text-align:center}"
    ),
    tableOutput("ottest"),
    # one sample ttest
    tags$style(
      type = "text/css",
      "#ottest th,td {border: medium solid #000000;text-align:center}"
    ),
    tags$style(
      type = "text/css",
      "#ottest td {border: medium solid #000000;text-align:center}"
    ),
    htmlOutput("note3"),
    tableOutput("summary4"),
    # summary
    tags$style(
      type = "text/css",
      "#summary4 th,td {border: medium solid #000000;text-align:center}"
    ),
    tags$style(
      type = "text/css",
      "#summary4 td {border: medium solid #000000;text-align:center}"
    ),
    tableOutput("ftest"),
    # Homogenity of variance
    tags$style(
      type = "text/css",
      "#ftest th,td {border: medium solid #000000;text-align:center}"
    ),
    tags$style(
      type = "text/css",
      "#ftest td {border: medium solid #000000;text-align:center}"
    ),
    htmlOutput("note4"),
    tableOutput("summary5"),
    # summary
    tags$style(
      type = "text/css",
      "#summary5 th,td {border: medium solid #000000;text-align:center}"
    ),
    tags$style(
      type = "text/css",
      "#summary5 td {border: medium solid #000000;text-align:center}"
    ),
    tableOutput("pttest"),
    # Homogenity of variance
    tags$style(
      type = "text/css",
      "#pttest th,td {border: medium solid #000000;text-align:center}"
    ),
    tags$style(
      type = "text/css",
      "#pttest td {border: medium solid #000000;text-align:center}"
    ),
    htmlOutput("note5"),
    uiOutput("plot"),
    tags$br(),
    uiOutput("slider"),
    tags$br(),
    uiOutput("image_down"),
    # for image download
    uiOutput("var1"),
    uiOutput("var2"),
    uiOutput("var3"),
    uiOutput("var4"),
    uiOutput("var5"),
    uiOutput("data_set"),
    # for data set download
    tags$br(),
    tags$br(),
    tags$br()
  )
)
########################### Server
server <- function(input, output, session) {
  csvfile <- reactive({
    csvfile <- input$file1
    if (is.null(csvfile)) {
      return(NULL)
    }
    dt <-
      read.csv(csvfile$datapath,
        header = input$header,
        sep = ",", check.names = FALSE
      )
    dt
  })

  output$var <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }
    if (input$req1 == "ttest") {
      list(
        radioButtons("dvar", "Please pick 'Group A' ", choices = names(csvfile())),
        radioButtons("ivar", "Please pick 'Group B'", choices = names(csvfile())),
        selectInput(
          "alt",
          "Alternative Hypotesis",
          c(
            "Two sided" = "two.sided",
            "Less than" = "less",
            "Greater than" = "greater"
          ),
          "two.sided"
        ),
        actionBttn(
          inputId = "submit1",
          label = "SUBMIT!",
          color = "danger",
          style = "jelly"
        )
      )
    }
    else if (input$req1 == "ottest") {
      list(
        radioButtons("dvar", "Please pick 'Group' ",
          choices = names(csvfile())
        ),
        numericInput("mu", "Enter population mean to compare:", value = 0),
        selectInput(
          "alt",
          "Alternative Hypotesis",
          c(
            "Two sided" = "two.sided",
            "Less than" = "less",
            "Greater than" = "greater"
          ),
          "two.sided"
        ),
        actionBttn(
          inputId = "submit3",
          label = "SUBMIT!",
          color = "danger",
          style = "jelly"
        )
      )
    }
    else if (input$req1 == "ftest") {
      list(
        radioButtons("dvar", "Please pick 'Group A' ", choices = names(csvfile())),
        radioButtons("ivar", "Please pick 'Group B'", choices = names(csvfile())),
        selectInput(
          "alt",
          "Alternative Hypotesis",
          c(
            "Two sided" = "two.sided",
            "Less than" = "less",
            "Greater than" = "greater"
          ),
          "two.sided"
        ),
        actionBttn(
          inputId = "submit4",
          label = "SUBMIT!",
          color = "danger",
          style = "jelly"
        )
      )
    }
    else if (input$req1 == "pttest") {
      list(
        radioButtons("dvar", "Please pick 'Group A' ", choices = names(csvfile())),
        radioButtons("ivar", "Please pick 'Group B'", choices = names(csvfile()), selected = NULL),
        selectInput(
          "alt",
          "Alternative Hypotesis",
          c(
            "Two sided" = "two.sided",
            "Less than" = "less",
            "Greater than" = "greater"
          ),
          "two.sided"
        ),
        actionBttn(
          inputId = "submit5",
          label = "SUBMIT!",
          color = "danger",
          style = "jelly"
        )
      )
    }
    else if (input$req1 == "wttest") {
      list(
        radioButtons("dvar", "Please pick 'Group A' ", choices = names(csvfile())),
        radioButtons("ivar", "Please pick 'Group B'", choices = names(csvfile())),
        selectInput(
          "alt",
          "Alternative Hypotesis",
          c(
            "Two sided" = "two.sided",
            "Less than" = "less",
            "Greater than" = "greater"
          ),
          "two.sided"
        ),
        actionBttn(
          inputId = "submit2",
          label = "SUBMIT!",
          color = "danger",
          style = "jelly"
        )
      )
    }
    else if (input$req1 == "boxplot") {
      list(
        radioButtons("dvar", "Please pick 'Group A' ", choices = names(csvfile())),
        radioButtons("ivar", "Please pick 'Group B'", choices = names(csvfile())),
        textInput("xlab", "Enter required x-axis label", "X-axis"),
        textInput("ylab", "Enter required y-axis label", "Y-axis"),
        selectInput(
          "col1",
          "Colour of first box",
          c(
            "green" = "#00AFBB",
            "blue" = "#3bbeff",
            "red" = "#bf0003",
            "yellow" = "#E7B800"
          ),
          "#00AFBB"
        ),
        selectInput(
          "col2",
          "Colour of Second box",
          c(
            "green" = "#00AFBB",
            "blue" = "#3bbeff",
            "red" = "#bf0003",
            "yellow" = "#E7B800"
          ),
          "#E7B800"
        ),
        actionBttn(
          inputId = "submit6",
          label = "SUBMIT!",
          color = "danger",
          style = "jelly"
        )
      )
    }
    else if (input$req1 == "pplot") {
      list(
        radioButtons("dvar", "Please pick 'Group A' ", choices = names(csvfile())),
        radioButtons("ivar", "Please pick 'Group B'", choices = names(csvfile())),
        actionBttn(
          inputId = "submit7",
          label = "SUBMIT!",
          color = "danger",
          style = "jelly"
        )
      )
    }
  })
  # two sample ttest
  output$ttest <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$req1)) {
        return()
      }
      if (is.null(input$submit1)) {
        return()
      }
      if (input$req1 == "ttest") {
        if (input$submit1 > 0) {
          x <- as.vector(csvfile()[, input$dvar])
          y <- as.vector(csvfile()[, input$ivar])
          t <- t.test(
            x,
            y,
            alternative = input$alt,
            var.equal = TRUE,
            paired = FALSE,
            na.omit = TRUE
          )
          t_value <- round(t$statistic, 3)
          df <- t$parameter
          Pvalue <- round(t$p.value, 6)
          alt.Hypothesis <- t$alternative
          result <- cbind(t_value, df, Pvalue, alt.Hypothesis)
          result <- as.data.frame(result)
          result
        }
      }
    },
    rownames = FALSE,
    bordered = TRUE,
    align = "c",
    caption = ("<b>Two sample unpaired t-test </b>"),
    caption.placement = getOption("xtable.caption.placement", "top")
  )

  # note1
  output$note1 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }
    if (is.null(input$submit1)) {
      return()
    }
    if (input$req1 == "ttest") {
      if (input$submit1 > 0) {
        x <- as.vector(csvfile()[, input$dvar])
        y <- as.vector(csvfile()[, input$ivar])
        t <- t.test(
          x,
          y,
          alternative = input$alt,
          var.equal = TRUE,
          paired = FALSE,
          na.omit = TRUE
        )

        if (t$p.value <= 0.05) {
          HTML(
            paste0(
              "Since P-value is < 0.05 we reject the null hypothesis at 5% level of significance
                    (here null hypothesis is: Population mean of group A = Population mean of group B) "
            )
          )
        }
        else if (t$p.value > 0.05) {
          HTML(
            paste0(
              "Since P-value is > 0.05 we don't have enough evidence to
                     reject the null hypothesis at 5% level of significance
                     (here null hypothesis is: Population mean of group A = Population mean of group B)"
            )
          )
        }
      }
    }
  })
  output$summary1 <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$req1)) {
        return()
      }
      if (is.null(input$submit1)) {
        return()
      }
      if (input$req1 == "ttest") {
        if (input$submit1 > 0) {
          grp1 <- subset(csvfile(), select = input$dvar)
          grp2 <- subset(csvfile(), select = input$ivar)
          final <- cbind(grp1, grp2)
          res <- pastecs::stat.desc(final)
          result <- as.data.frame(res)
          rownames(result)[rownames(result) == "nbr.val"] <-
            "Number of Obs."
          rownames(result)[rownames(result) == "nbr.null"] <-
            "null values"
          rownames(result)[rownames(result) == "nbr.na"] <- "NA"
          round(result, 3)
        }
      }
    },
    digits = 3,
    caption = ("<b> Summary Statistics </b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = TRUE
  )
  # Weltch ttest
  output$wttest <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$req1)) {
        return()
      }
      if (is.null(input$submit2)) {
        return()
      }
      if (input$req1 == "wttest") {
        if (input$submit2 > 0) {
          x <- as.vector(csvfile()[, input$dvar])
          y <- as.vector(csvfile()[, input$ivar])
          t <- t.test(
            x,
            y,
            alternative = input$alt,
            var.equal = FALSE,
            paired = FALSE,
            na.omit = TRUE
          )
          t_value <- round(t$statistic, 3)
          df <- round(t$parameter, 2)
          Pvalue <- round(t$p.value, 6)
          alt.Hypothesis <- t$alternative
          result <- cbind(t_value, df, Pvalue, alt.Hypothesis)
          result <- as.data.frame(result)
          result
        }
      }
    },
    rownames = FALSE,
    bordered = TRUE,
    align = "c",
    caption = ("<b>Two sample unpaired t-test </b>"),
    caption.placement = getOption("xtable.caption.placement", "top")
  )
  # note2
  output$note2 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }
    if (is.null(input$submit2)) {
      return()
    }
    if (input$req1 == "wttest") {
      if (input$submit2 > 0) {
        x <- as.vector(csvfile()[, input$dvar])
        y <- as.vector(csvfile()[, input$ivar])
        t <- t.test(
          x,
          y,
          alternative = input$alt,
          var.equal = FALSE,
          paired = FALSE,
          na.omit = TRUE
        )

        if (t$p.value <= 0.05) {
          HTML(
            paste0(
              "Since P-value is < 0.05 we reject the null hypothesis at 5% level of significance
                    (here null hypothesis is: Population mean of group A = Population mean of group B) "
            )
          )
        }
        else if (t$p.value > 0.05) {
          HTML(
            paste0(
              "Since P-value is > 0.05 we don't have enough evidence to
                     reject the null hypothesis at 5% level of significance
                     (here null hypothesis is: Population mean of group A = Population mean of group B)"
            )
          )
        }
      }
    }
  })
  output$summary2 <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$req1)) {
        return()
      }
      if (is.null(input$submit2)) {
        return()
      }
      if (input$req1 == "wttest") {
        if (input$submit2 > 0) {
          grp1 <- subset(csvfile(), select = input$dvar)
          grp2 <- subset(csvfile(), select = input$ivar)
          final <- cbind(grp1, grp2)
          res <- stat.desc(final)
          result <- as.data.frame(res)
          rownames(result)[rownames(result) == "nbr.val"] <-
            "Number of Obs."
          rownames(result)[rownames(result) == "nbr.null"] <-
            "null values"
          rownames(result)[rownames(result) == "nbr.na"] <- "NA"
          round(result, 3)
        }
      }
    },
    digits = 3,
    caption = ("<b> Summary Statistics </b>"),
    bordered = TRUE,
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = TRUE
  )
  # one sample ttest
  output$ottest <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$req1)) {
        return()
      }
      if (is.null(input$submit3)) {
        return()
      }
      if (input$req1 == "ottest") {
        if (input$submit3 > 0) {
          x <- as.vector(csvfile()[, input$dvar])
          t <- t.test(
            x,
            y = NULL,
            alternative = input$alt,
            mu = input$mu,
            na.omit = TRUE
          )
          t_value <- round(t$statistic, 3)
          df <- round(t$parameter, 2)
          Pvalue <- round(t$p.value, 6)
          alt.Hypothesis <- t$alternative
          result <- cbind(t_value, df, Pvalue, alt.Hypothesis)
          result <- as.data.frame(result)
          result
        }
      }
    },
    rownames = FALSE,
    bordered = TRUE,
    align = "c",
    caption = ("<b>One sample t-test </b>"),
    caption.placement = getOption("xtable.caption.placement", "top")
  )

  # note3
  output$note3 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }
    if (is.null(input$submit3)) {
      return()
    }
    if (input$req1 == "ottest") {
      if (input$submit3 > 0) {
        x <- as.vector(csvfile()[, input$dvar])
        t <- t.test(
          x,
          y = NULL,
          alternative = input$alt,
          mu = input$mu,
          na.omit = TRUE
        )
        mu <- as.numeric(input$mu)

        if (t$p.value <= 0.05) {
          HTML(paste0(
            sprintf(
              "Since P-value is < 0.05 we can reject the null hypothesis at 5 percent level of significance.
                    (Here null hypothesis: Population mean= %s)",
              mu
            )
          ))
        }
        else if (t$p.value > 0.05) {
          HTML(paste0(
            sprintf(
              "Since P-value is > 0.05 we don't have enough evidence to reject null hypothesis at 5 percent level of significance.
                    (Here null hypothesis: Population mean= %s)",
              mu
            )
          ))
        }
      }
    }
  })

  output$summary3 <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$req1)) {
        return()
      }
      if (is.null(input$submit3)) {
        return()
      }
      if (input$req1 == "ottest") {
        if (input$submit3 > 0) {
          grp1 <- subset(csvfile(), select = input$dvar)
          final <- grp1
          res <- stat.desc(final)
          result <- as.data.frame(res)
          rownames(result)[rownames(result) == "nbr.val"] <-
            "Number of Obs."
          rownames(result)[rownames(result) == "nbr.null"] <-
            "null values"
          rownames(result)[rownames(result) == "nbr.na"] <- "NA"
          round(result, 3)
        }
      }
    },
    digits = 3,
    caption = ("<b> Summary Statistics </b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = TRUE
  )
  # Ftest homogenity
  output$ftest <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$req1)) {
        return()
      }
      if (is.null(input$submit4)) {
        return()
      }
      if (input$req1 == "ftest") {
        if (input$submit4 > 0) {
          x <- as.vector(csvfile()[, input$dvar])
          y <- as.vector(csvfile()[, input$ivar])
          f <- var.test(x, y,
            ratio = 1,
            alternative = input$alt
          )
          F_value <- round(f$statistic, 3)
          df <- as.data.frame(f$parameter)
          Pvalue <- round(f$p.value, 6)
          alt.Hypothesis <- f$alternative
          result <- cbind(F_value, t(df), Pvalue, alt.Hypothesis)
          result <- as.data.frame(result)
          result
        }
      }
    },
    rownames = FALSE,
    bordered = TRUE,
    align = "c",
    caption = ("<b>F test for Homogenity of Variance </b>"),
    caption.placement = getOption("xtable.caption.placement", "top")
  )

  # note4
  output$note4 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }
    if (is.null(input$submit4)) {
      return()
    }
    if (input$req1 == "ftest") {
      if (input$submit4 > 0) {
        x <- as.vector(csvfile()[, input$dvar])
        y <- as.vector(csvfile()[, input$ivar])
        f <- var.test(x, y,
          ratio = 1,
          alternative = input$alt
        )

        if (f$p.value <= 0.05) {
          HTML(
            paste0(
              "Since P-value is < 0.05 we can reject the null hypothesis at 5 percent level of significance.
                    (Here null hypothesis: Variances are Homogenous)"
            )
          )
        }
        else if (f$p.value > 0.05) {
          HTML(
            paste0(
              "Since P-value is > 0.05 we don't have enough evidence to reject null hypothesis at 5 percent level of significance. Variance is homogenous.
                    (Here null hypothesis: Variances are Homogenous)"
            )
          )
        }
      }
    }
  })
  output$summary4 <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$req1)) {
        return()
      }
      if (is.null(input$submit4)) {
        return()
      }
      if (input$req1 == "ftest") {
        if (input$submit4 > 0) {
          grp1 <- subset(csvfile(), select = input$dvar)
          grp2 <- subset(csvfile(), select = input$ivar)
          final <- cbind(grp1, grp2)
          res <- pastecs::stat.desc(final)
          result <- as.data.frame(res)
          rownames(result)[rownames(result) == "nbr.val"] <-
            "Number of Obs."
          rownames(result)[rownames(result) == "nbr.null"] <-
            "null values"
          rownames(result)[rownames(result) == "nbr.na"] <- "NA"
          round(result, 3)
        }
      }
    },
    digits = 3,
    caption = ("<b> Summary Statistics </b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = TRUE
  )
  # Paired t test
  output$pttest <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$req1)) {
        return()
      }
      if (is.null(input$submit5)) {
        return()
      }
      if (input$req1 == "pttest") {
        if (input$submit5 > 0) {
          grp1 <- subset(csvfile(), select = input$dvar)
          grp2 <- subset(csvfile(), select = input$ivar)
          final <- cbind(grp1, grp2)
          ttest <-
            t.test(final[, 1],
              final[, 2],
              paired = TRUE,
              alternative = input$alt
            )
          tvalue <- round(ttest$statistic, 3)
          df <- ttest$parameter
          pvalue <- round(ttest$p.value, 6)
          meandiff <- round(ttest$estimate, 3)
          result1 <- cbind(tvalue, df, pvalue, meandiff)
          row.names(result1) <- NULL
          result1
        }
      }
    },
    caption = ("<b> Paired ttest </b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = FALSE
  )

  output$note5 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }
    if (is.null(input$submit5)) {
      return()
    }
    if (input$req1 == "pttest") {
      if (input$submit5 > 0) {
        validate(
          need(input$dvar != input$ivar, "Both input variables selected (Group A and Group B) are same. Choose different input variables for meaningful result")
        )
        x <- as.vector(csvfile()[, input$dvar])
        y <- as.vector(csvfile()[, input$ivar])
        t <- t.test(
          x,
          y,
          alternative = input$alt,
          var.equal = FALSE,
          paired = TRUE,
          na.omit = TRUE
        )

        if (t$p.value <= 0.05) {
          HTML(
            paste0(
              "Since P-value is < 0.05 we reject the null hypothesis at 5% level of significance
                    (here null hypothesis is: Population mean of group A = Population mean of group B) "
            )
          )
        }
        else if (t$p.value > 0.05) {
          HTML(
            paste0(
              "Since P-value is > 0.05 we don't have enough evidence to
                     reject the null hypothesis at 5% level of significance
                     (here null hypothesis is: Population mean of group A = Population mean of group B)"
            )
          )
        }
      }
    }
  })
  output$summary5 <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$req1)) {
        return()
      }
      if (is.null(input$submit5)) {
        return()
      }
      if (input$req1 == "pttest") {
        if (input$submit5 > 0) {
          grp1 <- subset(csvfile(), select = input$dvar)
          grp2 <- subset(csvfile(), select = input$ivar)
          final <- cbind(grp1, grp2)
          res <- pastecs::stat.desc(final)
          result <- as.data.frame(res)
          rownames(result)[rownames(result) == "nbr.val"] <-
            "Number of Obs."
          rownames(result)[rownames(result) == "nbr.null"] <-
            "null values"
          rownames(result)[rownames(result) == "nbr.na"] <- "NA"
          result <- round(result, 3)
          result
        }
      }
    },
    digits = 3,
    caption = ("<b> Summary Statistics </b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = TRUE
  )
  # Plots
  output$plot <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }

    if (input$req1 == "boxplot") {
      if (is.null(input$submit6)) {
        return()
      }
      output$boxplot <- renderPlot(
        {
          if (input$submit6 > 0) {
            x <- as.matrix(csvfile()[, input$dvar])
            y <- as.matrix(csvfile()[, input$ivar])
            g_1 <- rep(input$dvar, each = nrow(x))
            g_2 <- rep(input$ivar, each = nrow(y))
            my_data <- data.frame(
              group = c(g_1, g_2),
              obs = c(x, y)
            )

            colnames(my_data) <- c("group", "obs")
            ggpubr::ggboxplot(
              my_data,
              x = "group",
              y = "obs",
              color = "group",
              palette = c(input$col1, input$col2),
              ylab = input$ylab,
              xlab = input$xlab,
              size = input$size
            )
          }
        },
        bg = "transparent"
      )
      plotOutput("boxplot")
    }

    else if (input$req1 == "pplot") {
      if (is.null(input$submit7)) {
        return()
      }
      output$pplot <- renderPlot(
        {
          if (input$submit7 > 0) {
            group1 <- subset(csvfile(), select = input$dvar)
            group2 <- subset(csvfile(), select = input$ivar)
            pd <- paired(group1, group2)
            plot(pd, type = "profile") + theme_bw()
          }
        },
        bg = "transparent"
      )
      plotOutput("pplot")
    }
  })

  # slider input for boxplot
  output$slider <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }
    if (is.null(input$submit6)) {
      return()
    }
    if (input$req1 == "boxplot") {
      if (input$submit6 > 0) {
        list(sliderInput(
          "size",
          "Required width of the line:",
          min = 0.5,
          max = 2,
          value = 0.5
        ))
      }
    }
  })
  # Download Image
  output$image_down <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }

    if (input$req1 == "boxplot") {
      if (is.null(input$submit6)) {
        return()
      }
      if (input$submit6 > 0) {
        list(downloadButton("downloadImage1", label = "Download Boxplot", class = "butt1"))
      }
    }
    else if (input$req1 == "pplot") {
      if (is.null(input$submit7)) {
        return()
      }
      if (input$submit7 > 0) {
        list(
          downloadButton("downloadImage2", label = "Download Paired Plot", class = "butt1")
        )
      }
    }
  })
  # plotting
  plotInput <- reactive({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }

    if (input$req1 == "boxplot") {
      if (is.null(input$submit6)) {
        return()
      }
      if (input$submit6 > 0) {
        x <- as.matrix(csvfile()[, input$dvar])
        y <- as.matrix(csvfile()[, input$ivar])
        g_1 <- rep(input$dvar, each = nrow(x))
        g_2 <- rep(input$ivar, each = nrow(y))
        my_data <- data.frame(
          group = c(g_1, g_2),
          obs = c(x, y)
        )

        colnames(my_data) <- c("group", "obs")
        ggboxplot(
          my_data,
          x = "group",
          y = "obs",
          color = "group",
          palette = c(input$col1, input$col2),
          ylab = input$ylab,
          xlab = input$xlab,
          size = input$size
        )
      }
    }

    else if (input$req1 == "pplot") {
      if (is.null(input$submit7)) {
        return()
      }
      if (input$submit7 > 0) {
        group1 <- subset(csvfile(), select = input$dvar)
        group2 <- subset(csvfile(), select = input$ivar)
        pd <- paired(group1, group2)
        plot(pd, type = "profile") + theme_bw()
      }
    }
  })



  ###
  output$downloadImage1 <- downloadHandler(
    filename = "boxplot.png",
    content = function(file) {
      device <- function(..., width, height) {
        grDevices::png(
          ...,
          width = width,
          height = height,
          res = 500,
          units = "in"
        )
      }
      ggsave(file, plot = plotInput(), device = device)
    }
  )

  output$downloadImage2 <- downloadHandler(
    filename = "paired.png",
    content = function(file) {
      device <- function(..., width, height) {
        grDevices::png(
          ...,
          width = width,
          height = height,
          res = 500,
          units = "in"
        )
      }
      ggsave(file, plot = plotInput(), device = device)
    }
  )



  # download Report
  output$var1 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }
    if (is.null(input$submit1)) {
      return()
    }
    if (input$req1 == "ttest") {
      if (input$submit1 > 0) {
        list(
          radioButtons(
            "format",
            "Download report (Note: if you are changing the file name after download give '.html' extension):",
            c("HTML"),
            inline = TRUE
          ),
          downloadButton("downloadReport")
        )
      }
    }
  })

  output$var2 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }
    if (is.null(input$submit2)) {
      return()
    }
    if (input$req1 == "wttest") {
      if (input$submit2 > 0) {
        list(
          radioButtons(
            "format",
            "Download report (Note: if you are changing the file name after download give '.html' extension):",
            c("HTML"),
            inline = TRUE
          ),
          downloadButton("downloadReport")
        )
      }
    }
  })

  output$var3 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }
    if (is.null(input$submit3)) {
      return()
    }
    if (input$req1 == "ottest") {
      if (input$submit3 > 0) {
        list(
          radioButtons(
            "format",
            "Download report (Note: if you are changing the file name after download give '.html' extension):",
            c("HTML"),
            inline = TRUE
          ),
          downloadButton("downloadReport")
        )
      }
    }
  })

  output$var4 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }
    if (is.null(input$submit4)) {
      return()
    }
    if (input$req1 == "ftest") {
      if (input$submit4 > 0) {
        list(
          radioButtons(
            "format",
            "Download report (Note: if you are changing the file name after download give '.html' extension):",
            c("HTML"),
            inline = TRUE
          ),
          downloadButton("downloadReport")
        )
      }
    }
  })

  output$var5 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req1)) {
      return()
    }
    if (is.null(input$submit5)) {
      return()
    }
    if (input$req1 == "pttest") {
      if (input$submit5 > 0) {
        list(
          radioButtons(
            "format",
            "Download report (Note: if you are changing the file name after download give '.html' extension):",
            c("HTML"),
            inline = TRUE
          ),
          downloadButton("downloadReport")
        )
      }
    }
  })

  output$downloadReport <- downloadHandler(
    filename = function() {
      paste("my-report", sep = ".", switch(input$format,
        HTML = "html"
      ))
    },
    content = function(file) {
      src <- normalizePath("report.Rmd")
      owd <- setwd(tempdir())
      on.exit(setwd(owd))
      file.copy(src, "report.Rmd", overwrite = TRUE)
      out <- render("report.Rmd", switch(input$format,
        HTML = html_document()
      ))
      file.rename(out, file)
    }
  )

  # this note appear on opening
  output$start_note <- renderUI({
    if (is.null(input$file1$datapath)) {
      return(HTML(
        paste0(
          " <h4> To perform analysis using your own dataset, prepare excel file in csv format by reading instruction below  </h4>
<p>
<ui>
<li>Open a new blank excel file</li>
<li>Copy and paste observations into a new sheet (use only one sheet) of a new excel file</li>
<li>Groups to be compared should be pasted as columns </li>
<li>Don't type or delete anything on other cells without data</li>
<li>You can use any names for your columns. No space is allowed in the Column name. If space is required use underscore ‘_’ or ‘.’ full stop; for example ‘Variable name’ should be written as Variable_name or Variable.name</li>
<li>Data should be arranged towards upper left corner and row above the data should not be left blank </li>
<li>Type 'NA' in the cell with no observation</li>
<li>Don't type and delete anything on other cells without data. If so select those cells, right click and click clear contents </li>
<li>Give names to all column, Don't add any unnecessary columns that is not required for analysis</li>
<li>Once all these are done, your file is ready. Now save it as CSV file. </li>
<li><b>Upload file by clicking browse in the app </b></li>
</ui>
</p>
<p>
<b> Things to remember while doing t-test</b>
<li>Note that, unpaired two-samples t-test can be used only under certain conditions: </li>
<li>First condition: each of the two groups of samples being compared, should be normally distributed. This can be checked using Shapiro-Wilk test and other data visualization techniques [use grapes::descApp()]</li>
<li>Second condition: Variances of the two groups should be equal.
This can be checked using Homogenity of variance test (F test) available
with in the app. </li>
<li>If the variances of the two groups being compared are different (heteroscedasticity), it’s possible to use the Welch t test, an adaptation of Student t-test. </li>
<li>Welch t test and F-test are available within the app</li>
</p>
<b> You can download a model data set from below and test the App  </b>
"
        )
      ))
    }

    else {
      return()
    }
  })


  ########################################## dataset download
  output$data_set <- renderUI({
    if (is.null(input$file1$datapath)) {
      list(
        selectInput(
          "dataset",
          "Choose a dataset:",
          choices = c("iris", "rock", "pressure")
        ),
        downloadButton("downloadData", label = "Download csv file to test", class = "butt1")
      )
    }

    else {
      return()
    }
  })
  datasetInput <- reactive({
    switch(input$dataset,
      "iris" = iris,
      "rock" = rock,
      "pressure" = pressure
    )
  })

  output$downloadData <- downloadHandler(
    filename = function() {
      paste(input$dataset, ".csv", sep = "")
    },
    content = function(file) {
      write.csv(datasetInput(), file, row.names = FALSE)
    }
  )
  #######################################################
}
shinyApp(ui = ui, server = server)

library(shiny)
library(shinyWidgets)
library(rmarkdown)
library(dplyr)
library(ggplot2)
###############
library(Hmisc)
library(agricolae)
library(RColorBrewer)
library(ggpubr)
library(gtools)


ui <- fluidPage(

  ######## BACKGROUND
  setBackgroundColor(
    color = c("#fffacc", "#ffffff"),
    gradient = "radial",
    direction = c("bottom", "right")
  ),

  ########
  titlePanel(
    title = tags$div(tags$b("Completely Randomized Design (One-way ANOVA)", style = "color:#000000")),
    windowTitle = "Completely Randomized Design"
  ),
  sidebarPanel(
    fileInput("file1", "CSV File (upload in csv format)", accept = c("text/csv", "text/comma-separated-values,text/plain", ".csv")),
    checkboxInput("header", "Header", TRUE),
    uiOutput("var"),
    tags$br(),
    conditionalPanel(
      "$('#trtmeans').hasClass('recalculating')",
      tags$div(tags$b("Loading ...please wait while we are calculating in the background.....please dont press submit button again "), style = "color:green")
    ),
    tags$br(),
    h5(
      tags$div(
        tags$br(),
        "Developed by:",
        tags$br(),
        tags$b("Dr.Pratheesh P. Gopinath"),
        tags$br(),
        tags$b("Assistant Professor,"),
        tags$br(),
        tags$b("Agricultural Statistics,"),
        tags$br(),
        tags$b("Kerala Agricultural University"),
        tags$br(),
        tags$br(),
        "Contribution:",
        tags$br(),
        tags$b("Adarsh V.S."),
        tags$br(),
        tags$b("MSc, Agricultural Statistics"),
        tags$br(),
        tags$br(),
        "post your queries at: pratheesh.pg@kau.in",
        style = "color:#343aeb"
      )
    )
  ),
  mainPanel(
    tabsetPanel(
      type = "tab",
      tabPanel(
        "Analysis.Results",
        conditionalPanel(
          "$('#trtmeans').hasClass('recalculating')",
          tags$div(tags$b("Loading ...please wait while we are calculating in the background.....please dont press submit button again "), style = "color:green")
        ),
        tableOutput("trtmeans"),
        tags$style(type = "text/css", "#trtmeans th,td {border: medium solid #000000;text-align:center}"),
        tags$style(type = "text/css", "#trtmeans td {border: medium solid #000000;text-align:center}"),
        tableOutput("aovSummary"),
        tags$style(type = "text/css", "#aovSummary th,td {border: medium solid #000000;text-align:center}"),
        tags$style(type = "text/css", "#aovSummary td {border: medium solid #000000;text-align:center}"),
        tableOutput("SEM"),
        tags$style(type = "text/css", "#SEM th,td {border: medium solid #000000;text-align:center}"),
        tags$style(type = "text/css", "#SEM td {border: medium solid #000000;text-align:center}"),
        h3(""),
        htmlOutput("text"),
        h3(""),
        uiOutput("inference"),
        tableOutput("multi"),
        tags$style(type = "text/css", "#multi th,td {border: medium solid #000000;text-align:center}"),
        tags$style(type = "text/css", "#multi td {border: medium solid #000000;text-align:center}"),
        tableOutput("unequal"),
        tags$style(type = "text/css", "#unequal th,td {border: medium solid #000000;text-align:center}"),
        tags$style(type = "text/css", "#unequal td {border: medium solid #000000;text-align:center}"),
        tableOutput("group"),
        tags$style(type = "text/css", "#group th,td {border: medium solid #000000;text-align:center}"),
        tags$style(type = "text/css", "#group td {border: medium solid #000000;text-align:center}"),
        uiOutput("var1"),
        uiOutput("start_note"),
        tags$br(),
        uiOutput("data_set"), # data set to test,
        tags$br(),
        uiOutput("start_note2"),
        tags$br(),
        tags$br()
      ),
      tabPanel(
        "Plots & Graphs",
        uiOutput("varplot"),
        uiOutput("varboxplot"),
        tags$br(),
        tags$br(),
        uiOutput("start_note3"),
        plotOutput("boxplot"),
        uiOutput("plot_note3"),
        tags$br(),
        tags$br(),
        uiOutput("image_down"), # image to download
        tags$br(),
        tags$br(),
        tags$br(),
        tags$br()
      )
    )
  )
)


################## server
server <- function(input, output, session) {
  csvfile <- reactive({
    csvfile <- input$file1
    if (is.null(csvfile)) {
      return(NULL)
    }
    dt <- read.csv(csvfile$datapath, header = input$header, sep = ",", check.names = FALSE)
    dt
  })

  ################ appear after uploading file
  output$var <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    else {
      list(
        selectInput(
          "filerepli", "Replication",
          c(
            Equal.replication = "equal",
            Unequal.replication = "unequal"
          ),
          "equal"
        ),
        numericInput("trt", "Number of Treatments:", 0, min = 2, max = 100),
        radioButtons("treatment", "Please pick the name given for Treatment column in your file", choices = names(csvfile())),
        radioButtons("yield", "Please pick the name given for variable of interest in your file", choices = names(csvfile())),
        actionBttn(
          inputId = "submit",
          label = "SUBMIT!",
          color = "danger",
          style = "jelly"
        )
      )
    }
  })
  ################################### Download Button

  output$var1 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$submit)) {
      return()
    }
    if (input$submit > 0) {
      list(
        radioButtons("format", "Download report (Note: if you are changing the file name after download give '.html' extension):", c("HTML"),
          inline = TRUE
        ),
        downloadButton("downloadReport")
      )
    }
  })

  ################### Trt means
  output$trtmeans <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$submit)) {
        return()
      }
      if (input$submit > 0) {
        validate(
          need(input$treatment != input$yield, "Warning 1: Both input variables selected (Treatment and response) are same. Choose Treatment and response correctly for meaningful result")
        )
        input$reload
        Sys.sleep(2)
        d <- as.data.frame(csvfile())
        t <- as.numeric(input$trt)
        response <- d[, input$yield]
        treatment <- d[, input$treatment]
        treatment <- factor(treatment)
        anvaTable <- lm(response ~ treatment)
        result <- as.data.frame(stats::anova(anvaTable))
        out <- agricolae::LSD.test(csvfile()[, input$yield], csvfile()[, input$treatment], result[2, 1], result[2, 3])
        trtmeans <- out$means
        trtmeans <- trtmeans[ gtools::mixedsort(row.names(trtmeans)), ]
        colnames(trtmeans)[1] <- "Treatment_means"
        drops <- c("r", "Q25", "Q50", "Q75")
        trtmeans[, !(names(trtmeans) %in% drops)]
      }
    },
    digits = 3,
    caption = ("<b> Treatment means & other statistics </b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = TRUE
  )

  ##################################### ANOVA TABLE
  output$aovSummary <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$submit)) {
        return()
      }
      if (input$submit > 0) {
        validate(
          need(input$trt != 0, "Warning 2: Please enter the number of treatments correctly")
        )
        validate(
          need(input$treatment != input$yield, "")
        )
        d <- as.data.frame(csvfile())
        t <- as.numeric(input$trt)
        response <- d[, input$yield]
        treatment <- d[, input$treatment]
        treatment <- factor(treatment)
        anvaTable <- lm(response ~ treatment)
        result <- as.data.frame(stats::anova(anvaTable))
        SoV <- c("Treatment", "Error")
        final <- cbind(SoV, result)
        final
      }
    },
    digits = 3,
    caption = ("<b> ANOVA TABLE </b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top")
  )

  ########################################## SEM CD CV etc
  output$SEM <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$submit)) {
        return()
      }
      if (is.null(input$filerepli)) {
        return()
      }
      if (input$submit > 0) {
        validate(
          need(input$treatment != input$yield, "")
        )
        d <- as.data.frame(csvfile())
        t <- as.numeric(input$trt)
        response <- d[, input$yield]
        treatment <- d[, input$treatment]
        treatment <- factor(treatment)
        anvaTable <- lm(response ~ treatment)
        result <- as.data.frame(stats::anova(anvaTable))
        out <- agricolae::LSD.test(csvfile()[, input$yield], csvfile()[, input$treatment], result[2, 1], result[2, 3])
        colnam <- c("MSE", "SE(d)", "SE(m)", "CV(%)")
        stat <- out$statistics
        repl <- out$means
        r <- repl[1, 3]
        MSE <- stat[1, 1]
        SED <- sqrt((2 * MSE) / r)
        SEM <- sqrt(MSE / r)
        CV <- stat[1, 4]
        Result <- cbind(MSE, SED, SEM, CV)
        colnames(Result) <- colnam
        Result
      }
      else {
        return()
      }
    },
    digits = 3,
    caption = ("<b> Other important statistics </b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = FALSE
  )

  ####################################
  output$text <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$submit)) {
      return()
    }
    if (input$submit > 0) {
      validate(
        need(input$treatment != input$yield, "")
      )
      d <- as.data.frame(csvfile())
      t <- as.numeric(input$trt)
      response <- d[, input$yield]
      treatment <- d[, input$treatment]
      treatment <- factor(treatment)
      anvaTable <- lm(response ~ treatment)
      result <- as.data.frame(stats::anova(anvaTable))
      if (result[1, 5] <= 0.05) {
        HTML(paste0("<b>", "Since the P-value in ANOVA table is < 0.05, there is a significant difference between atleast
                    a pair of treatments, so multiple comparison is required to identify best treatment(s) ", "</b>"))
      }
      else {
        HTML(paste0("<b>", "Treatment means are not significantly different"))
      }
    }
  })
  #####################################
  output$inference <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$submit)) {
      return()
    }
    if (input$submit > 0) {
      validate(
        need(input$treatment != input$yield, "")
      )
      d <- as.data.frame(csvfile())
      t <- as.numeric(input$trt)
      response <- d[, input$yield]
      treatment <- d[, input$treatment]
      treatment <- factor(treatment)
      anvaTable <- lm(response ~ treatment)
      result <- as.data.frame(stats::anova(anvaTable))
      if (result[1, 5] <= 0.05) {
        list(selectInput(
          "req", "Please select multiple comparison method (alpha =0.05)",
          c(
            LSD = "lsd",
            DMRT = "dmrt",
            TUKEY = "tukey"
          ),
          "lsd"
        ))
      }
      else {
        return()
      }
    }
  })
  ################################## MUlTIPLE COMPARISON
  output$multi <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$submit)) {
        return()
      }
      if (is.null(input$req)) {
        return()
      }
      if (is.null(input$filerepli)) {
        return()
      }
      if (input$submit > 0) {
        if (input$filerepli == "equal") {
          if (input$req == "lsd") {
            validate(
              need(input$treatment != input$yield, "")
            )
            d <- as.data.frame(csvfile())
            t <- as.numeric(input$trt)
            response <- d[, input$yield]
            treatment <- d[, input$treatment]
            treatment <- factor(treatment)
            anvaTable <- lm(response ~ treatment)
            result <- as.data.frame(stats::anova(anvaTable))
            if (result[1, 5] <= 0.05) {
              out <- agricolae::LSD.test(d[, input$yield], d[, input$treatment], result[2, 1], result[2, 3])
              out$statistics
            }
          }
          else if (input$req == "dmrt") {
            validate(
              need(input$treatment != input$yield, "")
            )
            d <- as.data.frame(csvfile())
            t <- as.numeric(input$trt)
            response <- d[, input$yield]
            treatment <- d[, input$treatment]
            treatment <- factor(treatment)
            anvaTable <- lm(response ~ treatment)
            result <- as.data.frame(stats::anova(anvaTable))
            if (result[1, 5] <= 0.05) {
              out <- agricolae::duncan.test(d[, input$yield], d[, input$treatment], result[2, 1], result[2, 3], alpha = 0.05, group = TRUE, main = NULL, console = FALSE)
              out$duncan
            }
          }
          else if (input$req == "tukey") {
            validate(
              need(input$treatment != input$yield, "")
            )
            d <- as.data.frame(csvfile())
            t <- as.numeric(input$trt)
            response <- d[, input$yield]
            treatment <- d[, input$treatment]
            treatment <- factor(treatment)
            anvaTable <- lm(response ~ treatment)
            result <- as.data.frame(stats::anova(anvaTable))
            if (result[1, 5] <= 0.05) {
              out <- agricolae::HSD.test(d[, input$yield], d[, input$treatment], result[2, 1], result[2, 3], alpha = 0.05, group = TRUE, main = NULL, unbalanced = FALSE, console = FALSE)
              out$statistics
            }
          }
        }
        else if (input$filerepli == "unequal") {
          if (input$req == "lsd") {
            validate(
              need(input$treatment != input$yield, "")
            )
            d <- as.data.frame(csvfile())
            t <- as.numeric(input$trt)
            response <- d[, input$yield]
            treatment <- d[, input$treatment]
            treatment <- factor(treatment)
            anvaTable <- lm(response ~ treatment)
            result <- as.data.frame(stats::anova(anvaTable))
            if (result[1, 5] <= 0.05) {
              out <- agricolae::LSD.test(d[, input$yield], d[, input$treatment], result[2, 1], result[2, 3])
              out$statistics
            }
          }
        }
      }
    },
    digits = 3,
    caption = "alpha =0.05",
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "bottom")
  )

  ############################################# Matrix of CD in case of unequal replication
  output$unequal <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$submit)) {
        return()
      }
      if (is.null(input$req)) {
        return()
      }
      if (is.null(input$filerepli)) {
        return()
      }
      if (input$submit > 0) {
        if (input$filerepli == "unequal") {
          if (input$req == "lsd") {
            validate(
              need(input$treatment != input$yield, "")
            )
            d <- as.data.frame(csvfile())
            t <- as.numeric(input$trt)
            response <- d[, input$yield]
            treatment <- d[, input$treatment]
            treatment <- factor(treatment)
            anvaTable <- lm(response ~ treatment)
            result <- as.data.frame(stats::anova(anvaTable))
            if (result[1, 5] <= 0.05) {
              count <- table(d[, input$treatment]) # count the number of replications of treatment
              t <- (result[1, 1] + 1) # no.of treatments
              repli <- as.data.frame(count)
              reciproc <- 1 / repli[, 2] # 1/ri
              npw <- choose(t, 2) # number of pairwise combinations
              sumres <- as.vector(apply(combn(reciproc, 2), 2, sum)) # all pairwise sum of reciprocals (1/ri+1/rj)
              ems <- as.vector(replicate(npw, (result[2, 3])))
              SE_D <- sqrt((ems * sumres)) # standard error of difference
              tvalue <- qt(0.975, result[2, 1]) # tvalue
              vect <- replicate(npw, tvalue) # vector of t value
              CD <- vect * SE_D # critical difference
              means <- aggregate(response, list(treatment), mean)
              std <- aggregate(response, list(treatment), sd)
              finalmean <- cbind(means, std[, 2])
              rownames(finalmean) <- NULL
              colnam <- c("Treatment", "mean", "std")
              colnames(finalmean) <- colnam
              b <- matrix(0, t, t)
              b[upper.tri(b, diag = FALSE)] <- CD
              b[lower.tri(b, diag = FALSE)] <- CD
              name <- finalmean$Treatment
              colnames(b) <- name
              row.names(b) <- name
              b
            }
          }
        }
      }
    },
    digits = 3,
    rownames = TRUE,
    caption = "Matrix of CD values",
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top")
  )


  ######################################### Treatment Grouping
  output$group <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$submit)) {
        return()
      }
      if (is.null(input$req)) {
        return()
      }
      if (input$submit > 0) {
        if (input$req == "lsd") {
          validate(
            need(input$treatment != input$yield, "")
          )
          d <- as.data.frame(csvfile())
          t <- as.numeric(input$trt)
          response <- d[, input$yield]
          treatment <- d[, input$treatment]
          treatment <- factor(treatment)
          anvaTable <- lm(response ~ treatment)
          result <- as.data.frame(stats::anova(anvaTable))
          if (result[1, 5] <= 0.05) {
            out <- agricolae::LSD.test(d[, input$yield], d[, input$treatment], result[2, 1], result[2, 3])
            outgroup <- out$groups
            colnames(outgroup) <- c("trt_mean", "grouping")
            outgroup
          }
        }
        else if (input$req == "dmrt") {
          validate(
            need(input$treatment != input$yield, "")
          )
          d <- as.data.frame(csvfile())
          t <- as.numeric(input$trt)
          response <- d[, input$yield]
          treatment <- d[, input$treatment]
          treatment <- factor(treatment)
          anvaTable <- lm(response ~ treatment)
          result <- as.data.frame(stats::anova(anvaTable))
          if (result[1, 5] <= 0.05) {
            out <- agricolae::duncan.test(d[, input$yield], d[, input$treatment], result[2, 1], result[2, 3], alpha = 0.05, group = TRUE, main = NULL, console = FALSE)
            outgroup <- out$groups
            colnames(outgroup) <- c("trt_mean", "grouping")
            outgroup
          }
        }
        else if (input$req == "tukey") {
          validate(
            need(input$treatment != input$yield, "")
          )
          d <- as.data.frame(csvfile())
          t <- as.numeric(input$trt)
          response <- d[, input$yield]
          treatment <- d[, input$treatment]
          treatment <- factor(treatment)
          anvaTable <- lm(response ~ treatment)
          result <- as.data.frame(stats::anova(anvaTable))
          if (result[1, 5] <= 0.05) {
            out <- agricolae::HSD.test(d[, input$yield], d[, input$treatment], result[2, 1], result[2, 3], alpha = 0.05, group = TRUE, main = NULL, unbalanced = FALSE, console = FALSE)
            outgroup <- out$groups
            colnames(outgroup) <- c("trt_mean", "grouping")
            outgroup
          }
        }
      }
    },
    digits = 3,
    caption = "Treatments with same letters are not significantly different",
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "bottom"),
    rownames = TRUE
  )

  ######################################### plots

  ########################## Plot UI
  output$varplot <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$submit)) {
      return()
    }
    if (input$submit > 0) {
      list(selectInput(
        "plotreq", "Please select the required plot",
        c(
          "Barchart" = "barchart",
          "Barchart with grouping" = "bcg",
          "Boxplot" = "boxplot"
        ),
        "barchart"
      ))
    }
  })
  ########################################### PLOTS
  output$boxplot <- renderPlot(
    {
      plotInput()
    },
    bg = "transparent"
  )

  ############## interactive for plots
  output$varboxplot <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$submit)) {
      return()
    }
    if (is.null(input$plotreq)) {
      return()
    }
    if (input$plotreq == "boxplot") {
      if (input$submit > 0) {
        list(
          textInput("xlab", "Enter required x-axis label", "X-axis"),
          textInput("ylab", "Enter required y-axis label", "Y-axis"),
          selectInput(
            "col1", "Line colour pattern",
            c(
              "Pattern 1" = "Dark2",
              "Pattern 2" = "Set2",
              "Pattern 3" = "Set3",
              "Pattern 4" = "Accent",
              "Pattern 5" = "Set1"
            ),
            "Dark2"
          ),
          sliderInput("size", "Required width of the line:",
            min = 0.5, max = 2, value = 0.5
          ),
          sliderInput("size1", "X-axis label size:",
            min = 10, max = 20, value = 10
          ),
          sliderInput("size2", "Y-axis label size:",
            min = 10, max = 20, value = 10
          ),
          checkboxInput(
            "grey_box",
            "Convert the plot to grey scale", FALSE
          ),
          actionBttn(
            inputId = "submit1",
            label = "Click here to Draw",
            color = "success",
            style = "stretch"
          )
        )
      }
    }
    else if (input$plotreq == "barchart" ) {
      if (input$submit > 0) {
        list(
          textInput("xlab", "Enter required x-axis label", "X-axis"),
          textInput("ylab", "Enter required y-axis label", "Y-axis"),
          textInput("title", "Enter required Title", "title"),
          selectInput(
            "col1", "Select colour pattern",
            c(
              "Pattern 1" = "Dark2",
              "Pattern 2" = "Set2",
              "Pattern 3" = "Set3",
              "Pattern 4" = "Accent",
              "Pattern 5" = "Set1"
            ),
            "Dark2"
          ),
          sliderInput("width1", "Required width of the bar:",
                      min = 0.1, max = 1, value = 0.5
          ),
          sliderInput("width2", "Required width of error bar:",
                      min = 0.1, max = 1, value = 0.2
          ),
          sliderInput("width3", "X-axis label size:",
                      min = 10, max = 20, value = 10
          ),
          sliderInput("width4", "Y-axis label size:",
                      min = 10, max = 20, value = 10
          ),
          sliderInput("trans", "colour Transparency of bar:",
                      min = 0.1, max = 1, value = 1
          ),
          sliderInput("trans1", "colour Transparency of error bar:",
                      min = 0, max = 1, value = 1
          ),
          checkboxInput(
            "grey",
            "Convert the plot to grey scale", FALSE
          ),
          actionBttn(
            inputId = "submit1",
            label = "Click here to draw",
            color = "success",
            style = "stretch"
          )
        )
      }
    }
    else if (input$plotreq == "bcg") {
      if (input$submit > 0) {
        list(
          textInput("xlab", "Enter required x-axis label", "X-axis"),
          textInput("ylab", "Enter required y-axis label", "Y-axis"),
          textInput("title", "Enter required Title", "title"),
          selectInput(
            "col1", "Select colour pattern",
            c(
              "Pattern 1" = "Dark2",
              "Pattern 2" = "Set2",
              "Pattern 3" = "Set3",
              "Pattern 4" = "Accent",
              "Pattern 5" = "Set1"
            ),
            "Dark2"
          ),
          sliderInput("width1", "Required width of the bar:",
                      min = 0.1, max = 1, value = 0.5
          ),
          sliderInput("width2", "Required width of error bar:",
                      min = 0.1, max = 1, value = 0.2
          ),
          sliderInput("width3", "X-axis label size:",
                      min = 10, max = 20, value = 10
          ),
          sliderInput("width4", "Y-axis label size:",
                      min = 10, max = 20, value = 10
          ),
          sliderInput("trans", "colour Transparency of bar:",
                      min = 0.1, max = 1, value = 1
          ),
          sliderInput("trans1", "colour Transparency of error bar:",
                      min = 0, max = 1, value = 1
          ),
          sliderInput("width5", "Font label size of grouping letters:",
                      min = 1.5, max = 6.5, value = 3.5
          ),
          checkboxInput(
            "grey",
            "Convert the plot to grey scale", FALSE
          ),
          actionBttn(
            inputId = "submit1",
            label = "Click here to draw",
            color = "success",
            style = "stretch"
          )
        )
      }
    }
  })


  ############################################

  output$downloadReport <- downloadHandler(
    filename = function() {
      paste("my-report", sep = ".", switch(input$format,
        HTML = "html"
      ))
    },
    content = function(file) {
      src <- normalizePath("report.Rmd")
      owd <- setwd(tempdir())
      on.exit(setwd(owd))
      file.copy(src, "report.Rmd", overwrite = TRUE)
      out <- render("report.Rmd", switch(input$format,
        HTML = html_document()
      ))
      file.rename(out, file)
    }
  )

  #################################### Download Image
  #################################### Download Image
  output$image_down <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$plotreq)) {
      return()
    }
    if (is.null(input$submit1)) {
      return()
    }
    if (input$plotreq == "boxplot") {
      if (input$submit1 > 0) {
        list(downloadButton("downloadImage1",
                            label = "Download BoxPlot", class = "butt1"
        ))
      }
    }

    else if (input$plotreq == "barchart" || input$plotreq == "bcg") {
      if (input$submit1 > 0) {
        list(downloadButton("downloadImage2",
                            label = "Download Barchart", class = "butt1"
        ))
      }
    }
  })

  ### plotting
  plotInput <- reactive({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$plotreq)) {
      return()
    }
    if (is.null(input$submit1)) {
      return()
    }

    if (input$plotreq == "boxplot" && input$submit1 > 0) {
      nb.cols <- as.numeric(input$trt + 2)
      x <- as.matrix(csvfile()[, input$treatment])
      y <- as.matrix(csvfile()[, input$yield])
      my_data <- data.frame(
        group = x,
        obs = y
      )

      colnames(my_data) <- c("Treatments", "obs")
      #sorting x label
      my_data$Treatments<-factor(my_data$Treatments, levels = unique(my_data$Treatments))
      mycolors <- colorRampPalette(brewer.pal(8, input$col1))(nb.cols)
      if (input$grey_box > 0) {
        p <- ggplot2::ggplot(
          my_data,
          aes(
            x = Treatments, y = obs,
            fill = Treatments
          )
        ) +
          scale_x_discrete(labels=unique(my_data$Treatments))+
          geom_boxplot(lwd = input$size) +
          scale_fill_grey(start = 0.3, end = .9) +
          theme_bw() +
          labs(x = input$xlab, y = input$ylab) +
          theme(
            axis.text.x = element_text(
              angle = 90,
              size = input$size1,
              hjust = 1
            ),
            axis.text.y = element_text(size = input$size2)
          )
        p
      }
      else {
        p <- ggplot2::ggplot(
          my_data,
          aes(
            x = Treatments, y = obs,
            fill = Treatments
          )
        ) +
          scale_x_discrete(labels=unique(my_data$Treatments))+
          geom_boxplot(lwd = input$size) +
          scale_fill_manual(values = mycolors) +
          theme_bw() +
          labs(x = input$xlab, y = input$ylab) +
          theme(
            axis.text.x = element_text(
              angle = 90,
              size = input$size1,
              hjust = 1
            ),
            axis.text.y = element_text(size = input$size2)
          )
        p
      }
    }

    else if (input$plotreq == "barchart" && input$submit1 > 0) {

      d <- as.data.frame(csvfile())
      t <- as.numeric(input$trt)
      response <- d[, input$yield]
      treatment <- d[, input$treatment]
      treatment <- factor(treatment)
      anvaTable <- lm(response ~ treatment)
      result <- as.data.frame(stats::anova(anvaTable))
      out <- agricolae::LSD.test(
        d[, input$yield],
        d[, input$treatment],
        result[2, 1], result[2, 3]
      )
      d1 <- out$means
      alpha <- 0.05
      t <- qt(alpha / 2, result[2, 1], lower.tail = FALSE) # tvalue
      d1$std_er <- d1$std / (sqrt(d1$r))
      drops <- c(
        "r", "Q25", "Q50", "Q75",
        "Max", "Min", "LCL", "UCL", "r", "std"
      )
      d1 <- d1[, !(names(d1) %in% drops)]
      d2 <- out$groups
      d <- merge(d1, d2, by = 0, all = TRUE)
      d <- d[-4]
      d$ic <- t * d$std_er
      colnames(d) <- c(
        "treatment", "Response", "std.er",
        "group", "ic"
      )
      # arrange treatments inorder during plotting
      d <- d[gtools::mixedorder(d$treatment), ]
      Treatments <- factor(d$treatment, levels = d$treatment)
      nb.cols <- as.numeric(input$trt + 2)
      mycolors <- colorRampPalette(brewer.pal(8, input$col1))(nb.cols)

      if (input$grey > 0) {
        p <- ggplot(d, aes(x = as.factor(treatment), y = Response, fill = Treatments)) +
          geom_bar(
            stat = "identity",
            position = position_dodge(width = 1),
            alpha = input$trans, width = input$width1
          ) +
          geom_errorbar(aes(ymin = Response - ic, ymax = Response + ic),
                        width = input$width2, colour = "black", alpha = input$trans1,
                        size = 0.5
          ) + scale_x_discrete(labels=unique(d$treatment))+
          labs(x = input$xlab, y = input$ylab) +
          ggtitle(input$title) +
          scale_fill_grey(start = 0.3, end = .9) +
          scale_y_continuous(expand = expansion(mult = c(0, .3))) +
          theme_bw() +
          theme(
            plot.title = element_text(size = 22, hjust = 0.5),
            axis.text.x = element_text(angle = 90, hjust = 1, size = input$width3),
            axis.text.y = element_text(size = input$width4)
          )
        p
      }
      else {

        p <- ggplot(d, aes(x = as.factor(treatment), y = Response, fill = Treatments)) +
          geom_bar(
            stat = "identity",
            position = position_dodge(width = 1),
            alpha = input$trans, width = input$width1
          ) +
          geom_errorbar(aes(ymin = Response - ic, ymax = Response + ic),
                        width = input$width2, colour = "black", alpha = input$trans1,
                        size = 0.5
          ) +  scale_x_discrete(labels = unique(d$treatment))+
          labs(x = input$xlab, y = input$ylab) +
          ggtitle(input$title) +
          scale_fill_manual(values = mycolors) +
          scale_y_continuous(expand = expansion(mult = c(0, .3))) +
          theme_bw() +
          theme(
            plot.title = element_text(size = 22, hjust = 0.5),
            axis.text.x = element_text(angle = 90, hjust = 1, size = input$width3),
            axis.text.y = element_text(size = input$width4)
          )


        p
      }
    }
    else if (input$plotreq == "bcg" && input$submit1>0) {
      d <- as.data.frame(csvfile())
      t <- as.numeric(input$trt)
      response <- d[, input$yield]
      treatment <- d[, input$treatment]
      treatment <- factor(treatment)
      anvaTable <- lm(response ~ treatment)
      result <- as.data.frame(stats::anova(anvaTable))
      out <- agricolae::LSD.test(
        d[, input$yield],
        d[, input$treatment],
        result[2, 1], result[2, 3]
      )
      d1 <- out$means
      alpha <- 0.05
      t <- qt(alpha / 2, result[2, 1], lower.tail = FALSE) # tvalue
      d1$std_er <- d1$std / (sqrt(d1$r))
      drops <- c(
        "r", "Q25", "Q50", "Q75",
        "Max", "Min", "LCL", "UCL", "r", "std"
      )
      d1 <- d1[, !(names(d1) %in% drops)]
      d2 <- out$groups
      d <- merge(d1, d2, by = 0, all = TRUE)
      d <- d[-4]
      d$ic <- t * d$std_er
      colnames(d) <- c(
        "treatment", "Response", "std.er",
        "group", "ic"
      )
      d <- d[gtools::mixedorder(d$treatment), ]
      Treatments <- factor(d$treatment, levels = d$treatment)
      nb.cols <- as.numeric(input$trt + 2)
      mycolors <- colorRampPalette(brewer.pal(8, input$col1))(nb.cols)

      # plotting
      if (input$grey > 0) {
        p <- ggplot(d, aes(x = as.factor(treatment), y = Response, fill = Treatments)) +
          geom_bar(
            stat = "identity",
            position = position_dodge(width = 1),
            alpha = input$trans, width = input$width1
          ) +
          geom_errorbar(aes(ymin = Response - ic, ymax = Response + ic),
                        width = input$width2, colour = "black", alpha = input$trans1,
                        size = 0.5
          ) +
          scale_x_discrete(labels = unique(d$treatment))+
          geom_text(aes(label = group, y = Response + ic), vjust = -0.5,
                    size=input$width5) +
          labs(x = input$xlab, y = input$ylab) +
          ggtitle(input$title) +
          scale_fill_grey(start = 0.3, end = .9) +
          scale_y_continuous(expand = expansion(mult = c(0, .3))) +
          theme_bw() +
          theme(
            plot.title = element_text(size = 22, hjust = 0.5),
            axis.text.x = element_text(angle = 90, hjust = 1, size = input$width3),
            axis.text.y = element_text(size = input$width4)
          )


        p
      }

      else {
        p <- ggplot(d, aes(x = as.factor(treatment), y = Response, fill = Treatments)) +
          geom_bar(
            stat = "identity",
            position = position_dodge(width = 1),
            alpha = input$trans, width = input$width1
          ) +
          geom_errorbar(aes(ymin = Response - ic, ymax = Response + ic),
                        width = input$width2, colour = "black", alpha = input$trans1,
                        size = 0.5
          ) +
          scale_x_discrete(labels = unique(d$treatment))+
          geom_text(aes(label = group, y = Response + ic), vjust = -0.5,
                    size=input$width5) +
          labs(x = input$xlab, y = input$ylab) +
          ggtitle(input$title) +
          scale_fill_manual(values = mycolors) +
          scale_y_continuous(expand = expansion(mult = c(0, .3))) +
          theme_bw() +
          theme(
            plot.title = element_text(size = 22, hjust = 0.5),
            axis.text.x = element_text(angle = 90, hjust = 1, size = input$width3),
            axis.text.y = element_text(size = input$width4)
          )


        p
      }
    }
  })

  ###
  output$downloadImage1 <- downloadHandler(
    filename = "boxplot.png",
    content = function(file) {
      device <- function(..., width, height) {
        grDevices::png(...,
          width = width, height = height,
          res = 500, units = "in"
        )
      }
      ggsave(file, plot = plotInput(), device = device)
    }
  )

  output$downloadImage2 <- downloadHandler(
    filename = "barchart.png",
    content = function(file) {
      device <- function(..., width, height) {
        grDevices::png(...,
          width = width, height = height,
          res = 500, units = "in"
        )
      }
      ggsave(file, plot = plotInput(), device = device)
    }
  )

  ########################### end image download

  ############################## download data set
  output$data_set <- renderUI({
    if (is.null(input$file1$datapath)) {
      list(
        selectInput("dataset", "Choose a dataset:",
          choices = c("equal_replication", "unequal_replication", "mango_data")
        ),
        downloadButton("downloadData", label = "Download csv file to test", class = "butt1")
      )
    }

    else {
      return()
    }
  })
  datasetInput <- reactive({
    equal <- read.csv(system.file("extdata/crd_data",
      "equal_replication.csv",
      package = "grapesAgri1"
    ))
    unequal <- read.csv(system.file("extdata/crd_data",
      "unequal_replication.csv",
      package = "grapesAgri1"
    ))
    mango <- read.csv(system.file("extdata/crd_data",
      "mango.csv",
      package = "grapesAgri1"
    ))
    switch(input$dataset,
      "equal_replication" = equal,
      "unequal_replication" = unequal,
      "mango_data" = mango
    )
  })

  output$downloadData <- downloadHandler(
    filename = function() {
      paste(input$dataset, ".csv", sep = "")
    },
    content = function(file) {
      write.csv(datasetInput(), file, row.names = FALSE)
    }
  )
  ######################### end data set download

  ############################### this note appear on opening
  output$start_note <- renderUI({
    if (is.null(input$file1$datapath)) {
      return(
        HTML(paste0(
          " <h4> To perform analysis using your own dataset, prepare excel file in csv format by reading instruction below </h4>
<p>
<ui>
<li>Open a new blank excel file</li>
<li>Copy and paste observations into a new sheet (use only one sheet) of a new excel file</li>
<li>Two columns are required Treatment and Response. </li>
<li>You can use any names for your columns</li>
<li>You can also add more than one response as columns</li>
<li>No space is allowed in the treatment name. </li>
<li>If space is required use underscore ‘_’ or ‘.’ full stop; for example ‘Treatment name’ should be written as Treatment_name or Treatment.name</li>
<li>No need to add replication column, system will automatically identifies replication. </li>
<li>Don't type and delete anything on other cells without data. If so select those cells, right click and click clear contents. </li>
<li>Give names to all column, Don't add any unnecessary columns that is not required for analysis</li>
<li>Data should be arranged towards upper left corner and row above the data should not be left blank. </li>
<li>Once all these are done, your file is ready. Now save it as CSV file. </li>
<li><b>Upload file by clicking browse in the app </b></li>
</ui>
</p>
<b> You can download a model data set from below and test the App  </b>

"
        ))
      )
    }

    else {
      return()
    }
  })

  output$start_note2 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return(
        HTML(paste0(
          "<li> <b>Note</b>: Don't forget to enter
        treatment number while doing analysis</li>"
        ))
      )
    }

    else {
      return()
    }
  })

  output$start_note3 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return(
        HTML(paste0(
          "<b>Plots will appear here once you upload the csv file by
        clicking 'Browse' and click submit</b>
        "
        ))
      )
    }

    else {
      return()
    }
  })


  output$plot_note3 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$plotreq)) {
      return()
    }
    if (is.null(input$submit1)) {
      return()
    }
    if (input$plotreq == "bcg") {
      if (input$submit1 > 0) {
        return(
          HTML(paste0(
            "<b>Note:</b> Grouping is based on LSD test.
            <p>Treatments with same letters are not significantly different at 5% level.</p>
        "
          ))
        )
      }
    }
  })


  }

shinyApp(ui = ui, server = server)

library(shiny)
library(ggplot2)
library(Hmisc)
library(agricolae)
library(shinyWidgets)
library(dplyr)
library(rmarkdown)
library(RColorBrewer)
library(gtools)

ui <- fluidPage(
  setBackgroundColor(
    color = c("#ffb9b3", "#ffffff"),
    gradient = "radial",
    direction = c("bottom", "right")
  ),
  titlePanel(
    title = tags$div(tags$b("Two-way Analysis of Variance", style = "color:#000000")),
    windowTitle = "Randomized Block Design"
  ),
  sidebarPanel(
    fileInput("file1", "CSV File (upload in csv format)", accept = c("text/csv", "text/comma-separated-values,text/plain", ".csv")),
    checkboxInput("header", "Header", TRUE),
    uiOutput("var"),
    tags$br(),
    conditionalPanel(
      "$('#trtmeans').hasClass('recalculating')",
      tags$div(tags$b("Loading ...please wait while we are calculating in the background.....please dont press submit button again "), style = "color:green")
    ),
    tags$br(),
    h5(
      tags$div(
        tags$br(),
        "Developed by:",
        tags$br(),
        tags$b("Dr.Pratheesh P. Gopinath"),
        tags$br(),
        tags$b("Assistant Professor,"),
        tags$br(),
        tags$b("Agricultural Statistics,"),
        tags$br(),
        tags$b("Kerala Agricultural University"),
        tags$br(),
        tags$br(),
        "Contribution:",
        tags$br(),
        tags$b("Adarsh V.S."),
        tags$br(),
        tags$b("MSc, Agricultural Statistics"),
        tags$br(),
        tags$br(),
        "post your queries at: pratheesh.pg@kau.in",
        style = "color:#343aeb"
      )
    )
  ),
  mainPanel(
    tabsetPanel(
      type = "tab",
      tabPanel(
        "Analysis.Results",
        tableOutput("trtmeans"),
        conditionalPanel(
          "$('#trtmeans').hasClass('recalculating')",
          tags$div(tags$b("Loading ...please wait while we are calculating in the background.....please dont press submit button again "), style = "color:green")
        ),
        tags$style(type = "text/css", "#trtmeans th,td {border: medium solid #000000;text-align:center}"),
        tags$style(type = "text/css", "#trtmeans td {border: medium solid #000000;text-align:center}"),
        tableOutput("aovSummary"),
        tags$style(type = "text/css", "#aovSummary th,td {border: medium solid #000000;text-align:center}"),
        tags$style(type = "text/css", "#aovSummary td {border: medium solid #000000;text-align:center}"),
        tableOutput("SEM"),
        tags$style(type = "text/css", "#SEM th,td {border: medium solid #000000;text-align:center}"),
        tags$style(type = "text/css", "#SEM td {border: medium solid #000000;text-align:center}"),
        htmlOutput("text"),
        h3(""),
        uiOutput("inference"),
        tableOutput("multi"),
        tags$style(type = "text/css", "#multi th,td {border: medium solid #000000;text-align:center}"),
        tags$style(type = "text/css", "#multi td {border: medium solid #000000;text-align:center}"),
        tableOutput("group"),
        tags$style(type = "text/css", "#group th,td {border: medium solid #000000;text-align:center}"),
        tags$style(type = "text/css", "#group td {border: medium solid #000000;text-align:center}"),
        uiOutput("var1"),
        uiOutput("start_note"),
        tags$br(),
        uiOutput("data_set"), # data set to test,
        tags$br(),
        uiOutput("start_note2"),
        tags$br(),
        tags$br()
      ),
      tabPanel(
        "Plots & Graphs",
        uiOutput("varplot"),
        uiOutput("varboxplot"),
        tags$br(),
        uiOutput("start_note3"),
        plotOutput("boxplot"),
        tags$br(),
        tags$br(),
        uiOutput("image_down"), # image to download
        tags$br(),
        tags$br(),
        tags$br(),
        tags$br()
      )
    )
  )
)
####################
server <- function(input, output, session) {
  csvfile <- reactive({
    csvfile <- input$file1
    if (is.null(csvfile)) {
      return(NULL)
    }
    dt <- read.csv(csvfile$datapath, header = input$header, sep = ",")
    dt
  })

  output$var <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    else {
      list(
        numericInput("trt", "Number of Treatments:", 0, min = 2, max = 100),
        numericInput("rep", "Number of Replications:", 0, min = 2, max = 100),
        radioButtons("treatment", "Please pick the name given for Treatment column in your file", choices = names(csvfile())),
        radioButtons("Replication", "Please pick the name given for Replication column in your file", choices = names(csvfile())),
        radioButtons("yield", "Please pick the name given for variable of interest in your file", choices = names(csvfile())),
        tags$br(),
        actionBttn(
          inputId = "submit",
          label = "Run Analysis!",
          color = "danger",
          style = "jelly"
        )
      )
    }
  })

  output$var1 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$submit)) {
      return()
    }
    if (input$submit > 0) {
      list(
        radioButtons("format", "Download report:", c("HTML"),
          inline = TRUE
        ),
        downloadButton("downloadReport")
      )
    }
  })

  ##################################### TRT means
  output$trtmeans <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$submit)) {
        return()
      }
      if (input$submit > 0) {
        validate(
          need(input$treatment != input$yield, "Warning 1: Both input variables selected (Treatment and response) are same. Choose Treatment and response correctly for meaningful result")
        )
        validate(
          need(input$treatment != input$Replication, "Warning 1: Both input variables selected (Treatment and Replication) are same. Choose Treatment and Replication correctly for meaningful result")
        )
        validate(
          need(input$yield != input$Replication, "Warning 1: Both input variables selected (Replication and response) are same. Choose Replication and response correctly for meaningful result")
        )
        validate(
          need(input$trt != 0, "Please enter number of treatments")
        )
        validate(
          need(input$rep != 0, "Please enter number of replications")
        )
        input$reload
        Sys.sleep(2)
        d <- as.data.frame(csvfile())
        r <- as.numeric(input$rep)
        t <- as.numeric(input$trt)
        response <- d[, input$yield]
        treatment <- d[, input$treatment]
        replication <- d[, input$Replication]
        treatment <- factor(treatment)
        replication <- factor(replication)
        anvaTable <- lm(response ~ treatment + replication)
        result <- as.data.frame(anova(anvaTable))
        out <- agricolae::LSD.test(csvfile()[, input$yield], csvfile()[, input$treatment], result[3, 1], result[3, 3])
        trtmeans <- out$means
        trtmeans <- trtmeans[gtools::mixedsort(row.names(trtmeans)), ]
        colnames(trtmeans)[1] <- "Treatment_means"
        drops <- c("r", "Q25", "Q50", "Q75")
        trtmeans[, !(names(trtmeans) %in% drops)]
      }
    },
    digits = 3,
    caption = ("<b> Treatment means & other statistics </b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top"),
    rownames = TRUE
  )

  ################################## ANOVA
  output$aovSummary <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$submit)) {
        return()
      }
      if (input$submit > 0) {
        validate(
          need(input$treatment != input$yield, "")
        )
        validate(
          need(input$treatment != input$Replication, "")
        )
        validate(
          need(input$yield != input$Replication, "")
        )
        validate(
          need(input$trt != 0, "")
        )
        validate(
          need(input$rep != 0, "")
        )
        d <- as.data.frame(csvfile())
        r <- as.numeric(input$rep)
        t <- as.numeric(input$trt)
        response <- d[, input$yield]
        treatment <- d[, input$treatment]
        replication <- d[, input$Replication]
        treatment <- factor(treatment)
        replication <- factor(replication)
        anvaTable <- lm(response ~ treatment + replication)
        result <- as.data.frame(anova(anvaTable))
        SoV <- c("Treatment", "Replication", "Error")
        final <- cbind(SoV, result)
        final
      }
    },
    digits = 3,
    caption = ("<b> ANOVA TABLE </b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top")
  )


  ######################## SEM & other values
  output$SEM <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$submit)) {
        return()
      }
      if (input$submit > 0) {
        validate(
          need(input$treatment != input$yield, "")
        )
        validate(
          need(input$treatment != input$Replication, "")
        )
        validate(
          need(input$yield != input$Replication, "")
        )
        validate(
          need(input$trt != 0, "")
        )
        validate(
          need(input$rep != 0, "")
        )
        d <- as.data.frame(csvfile())
        r <- as.numeric(input$rep)
        t <- as.numeric(input$trt)
        response <- d[, input$yield]
        treatment <- d[, input$treatment]
        replication <- d[, input$Replication]
        treatment <- factor(treatment)
        replication <- factor(replication)
        anvaTable <- lm(response ~ treatment + replication)
        result <- as.data.frame(anova(anvaTable))
        out <- agricolae::LSD.test(d[, input$yield], d[, input$treatment], result[3, 1], result[3, 3])
        colnam <- c("MSE", "SE(d)", "SE(m)", "CV(%)")
        stat <- out$statistics
        MSE <- stat[1, 1]
        SED <- sqrt((2 * MSE) / r)
        SEM <- sqrt(MSE / r)
        CV <- stat[1, 4]
        Result <- cbind(MSE, SED, SEM, CV)
        colnames(Result) <- colnam
        Result
      }
    },
    digits = 3,
    caption = ("<b> SEM & Other statistics </b>"),
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "top")
  )

  ################################## Inference on p value text
  output$text <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$submit)) {
      return()
    }
    if (input$submit > 0) {
      validate(
        need(input$treatment != input$yield, "")
      )
      validate(
        need(input$treatment != input$Replication, "")
      )
      validate(
        need(input$yield != input$Replication, "")
      )
      validate(
        need(input$trt != 0, "")
      )
      validate(
        need(input$rep != 0, "")
      )
      d <- as.data.frame(csvfile())
      r <- as.numeric(input$rep)
      t <- as.numeric(input$trt)
      response <- d[, input$yield]
      treatment <- d[, input$treatment]
      replication <- d[, input$Replication]
      treatment <- factor(treatment)
      replication <- factor(replication)
      anvaTable <- lm(response ~ treatment + replication)
      result <- as.data.frame(anova(anvaTable))
      if (result[1, 5] <= 0.05) {
        HTML(paste0("<b>", "Since the P-value in ANOVA table is < 0.05, there is a significant difference between atleast
                    a pair of treatments, so multiple comparison is required to identify best treatment(s) ", "</b>"))
      }
      else {
        HTML(paste0("<b>", "Treatment means are not significantly different"))
      }
    }
  })

  ################# Multiple comparison options
  output$inference <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$submit)) {
      return()
    }
    if (input$submit > 0) {
      validate(
        need(input$treatment != input$yield, "")
      )
      validate(
        need(input$treatment != input$Replication, "")
      )
      validate(
        need(input$yield != input$Replication, "")
      )
      validate(
        need(input$trt != 0, "")
      )
      validate(
        need(input$rep != 0, "")
      )
      d <- as.data.frame(csvfile())
      r <- as.numeric(input$rep)
      t <- as.numeric(input$trt)
      response <- d[, input$yield]
      treatment <- d[, input$treatment]
      replication <- d[, input$Replication]
      treatment <- factor(treatment)
      replication <- factor(replication)
      anvaTable <- lm(response ~ treatment + replication)
      result <- as.data.frame(anova(anvaTable))
      if (result[1, 5] <= 0.05) {
        list(selectInput(
          "req", "Please select multiple comparison method (alpha =0.05)",
          c(
            LSD = "lsd",
            DMRT = "dmrt",
            TUKEY = "tukey"
          ),
          "lsd"
        ))
      }
      else {
        return()
      }
    }
  })

  ################## SEM, CD, CV etc
  output$multi <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$submit)) {
        return()
      }
      if (is.null(input$req)) {
        return()
      }
      if (input$submit > 0) {
        if (input$req == "lsd") {
          validate(
            need(input$treatment != input$yield, "")
          )
          validate(
            need(input$treatment != input$Replication, "")
          )
          validate(
            need(input$yield != input$Replication, "")
          )
          validate(
            need(input$trt != 0, "")
          )
          validate(
            need(input$rep != 0, "")
          )
          d <- as.data.frame(csvfile())
          r <- as.numeric(input$rep)
          t <- as.numeric(input$trt)
          response <- d[, input$yield]
          treatment <- d[, input$treatment]
          replication <- d[, input$Replication]
          treatment <- factor(treatment)
          replication <- factor(replication)
          anvaTable <- lm(response ~ treatment + replication)
          result <- as.data.frame(anova(anvaTable))
          if (result[1, 5] <= 0.05) {
            out <- agricolae::LSD.test(d[, input$yield], d[, input$treatment], result[3, 1], result[3, 3])
            colnam <- c("MSE", "SE(d)", "SE(m)", "CD", "t value", "CV(%)")
            stat <- out$statistics
            MSE <- stat[1, 1]
            SED <- sqrt((2 * MSE) / r)
            SEM <- sqrt(MSE / r)
            CD <- stat[1, 6]
            t <- stat[1, 5]
            CV <- stat[1, 4]
            Result <- cbind(MSE, SED, SEM, CD, t, CV)
            colnames(Result) <- colnam
            Result
          }
        }
        else if (input$req == "dmrt") {
          validate(
            need(input$treatment != input$yield, "")
          )
          validate(
            need(input$treatment != input$Replication, "")
          )
          validate(
            need(input$yield != input$Replication, "")
          )
          validate(
            need(input$trt != 0, "")
          )
          validate(
            need(input$rep != 0, "")
          )
          d <- as.data.frame(csvfile())
          r <- as.numeric(input$rep)
          t <- as.numeric(input$trt)
          response <- d[, input$yield]
          treatment <- d[, input$treatment]
          replication <- d[, input$Replication]
          treatment <- factor(treatment)
          replication <- factor(replication)
          anvaTable <- lm(response ~ treatment + replication)
          result <- as.data.frame(anova(anvaTable))
          if (result[1, 5] <= 0.05) {
            out <- agricolae::duncan.test(d[, input$yield], d[, input$treatment], result[3, 1], result[3, 3], alpha = 0.05, group = TRUE, main = NULL, console = FALSE)
            out$duncan
          }
        }
        else if (input$req == "tukey") {
          validate(
            need(input$treatment != input$yield, "")
          )
          validate(
            need(input$treatment != input$Replication, "")
          )
          validate(
            need(input$yield != input$Replication, "")
          )
          validate(
            need(input$trt != 0, "")
          )
          validate(
            need(input$rep != 0, "")
          )
          d <- as.data.frame(csvfile())
          r <- as.numeric(input$rep)
          t <- as.numeric(input$trt)
          response <- d[, input$yield]
          treatment <- d[, input$treatment]
          replication <- d[, input$Replication]
          treatment <- factor(treatment)
          replication <- factor(replication)
          anvaTable <- lm(response ~ treatment + replication)
          result <- as.data.frame(anova(anvaTable))
          if (result[1, 5] <= 0.05) {
            out <- agricolae::HSD.test(d[, input$yield], d[, input$treatment], result[3, 1], result[3, 3], alpha = 0.05, group = TRUE, main = NULL, unbalanced = FALSE, console = FALSE)
            out$statistics
          }
        }
      }
    },
    digits = 3,
    caption = "alpha =0.05",
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "bottom")
  )

  ############################# grouping
  output$group <- renderTable(
    {
      if (is.null(input$file1$datapath)) {
        return()
      }
      if (is.null(input$submit)) {
        return()
      }
      if (is.null(input$req)) {
        return()
      }
      if (input$submit > 0) {
        if (input$req == "lsd") {
          validate(
            need(input$treatment != input$yield, "")
          )
          validate(
            need(input$treatment != input$Replication, "")
          )
          validate(
            need(input$yield != input$Replication, "")
          )
          validate(
            need(input$trt != 0, "")
          )
          validate(
            need(input$rep != 0, "")
          )
          d <- as.data.frame(csvfile())
          r <- as.numeric(input$rep)
          t <- as.numeric(input$trt)
          response <- d[, input$yield]
          treatment <- d[, input$treatment]
          replication <- d[, input$Replication]
          treatment <- factor(treatment)
          replication <- factor(replication)
          anvaTable <- lm(response ~ treatment + replication)
          result <- as.data.frame(anova(anvaTable))
          if (result[1, 5] <= 0.05) {
            out <- agricolae::LSD.test(d[, input$yield], d[, input$treatment], result[3, 1], result[3, 3])
            outgroup <- out$groups
            colnames(outgroup) <- c("trt_mean", "grouping")
            outgroup
          }
        }
        else if (input$req == "dmrt") {
          validate(
            need(input$treatment != input$yield, "")
          )
          validate(
            need(input$treatment != input$Replication, "")
          )
          validate(
            need(input$yield != input$Replication, "")
          )
          validate(
            need(input$trt != 0, "")
          )
          validate(
            need(input$rep != 0, "")
          )
          d <- as.data.frame(csvfile())
          r <- as.numeric(input$rep)
          t <- as.numeric(input$trt)
          response <- d[, input$yield]
          treatment <- d[, input$treatment]
          replication <- d[, input$Replication]
          treatment <- factor(treatment)
          replication <- factor(replication)
          anvaTable <- lm(response ~ treatment + replication)
          result <- as.data.frame(anova(anvaTable))
          if (result[1, 5] <= 0.05) {
            out <- agricolae::duncan.test(d[, input$yield], d[, input$treatment], result[3, 1], result[3, 3], alpha = 0.05, group = TRUE, main = NULL, console = FALSE)
            outgroup <- out$groups
            colnames(outgroup) <- c("trt_mean", "grouping")
            outgroup
          }
        }
        else if (input$req == "tukey") {
          validate(
            need(input$treatment != input$yield, "")
          )
          validate(
            need(input$treatment != input$Replication, "")
          )
          validate(
            need(input$yield != input$Replication, "")
          )
          validate(
            need(input$trt != 0, "")
          )
          validate(
            need(input$rep != 0, "")
          )
          d <- as.data.frame(csvfile())
          r <- as.numeric(input$rep)
          t <- as.numeric(input$trt)
          response <- d[, input$yield]
          treatment <- d[, input$treatment]
          replication <- d[, input$Replication]
          treatment <- factor(treatment)
          replication <- factor(replication)
          anvaTable <- lm(response ~ treatment + replication)
          result <- as.data.frame(anova(anvaTable))
          if (result[1, 5] <= 0.05) {
            out <- agricolae::HSD.test(d[, input$yield], d[, input$treatment], result[3, 1], result[3, 3], alpha = 0.05, group = TRUE, main = NULL, unbalanced = FALSE, console = FALSE)
            outgroup <- out$groups
            colnames(outgroup) <- c("trt_mean", "grouping")
            outgroup
          }
        }
      }
    },
    digits = 3,
    caption = "Treatments with same letters are not significantly different",
    bordered = TRUE,
    align = "c",
    caption.placement = getOption("xtable.caption.placement", "bottom"),
    rownames = TRUE
  )


  ######################### Interactive for plots
  output$varplot <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$submit)) {
      return()
    }
    if (input$submit > 0) {
      validate(
        need(input$treatment != input$yield, "Warning 1: Both input variables selected (Treatment and response) are same. Choose Treatment and response correctly for meaningful result")
      )
      validate(
        need(input$treatment != input$Replication, "Warning 1: Both input variables selected (Treatment and Replication) are same. Choose Treatment and Replication correctly for meaningful result")
      )
      validate(
        need(input$yield != input$Replication, "Warning 1: Both input variables selected (Replication and response) are same. Choose Replication and response correctly for meaningful result")
      )
      validate(
        need(input$trt != 0, "Please enter number of treatments")
      )
      validate(
        need(input$rep != 0, "Please enter number of replications")
      )

      list(selectInput(
        "plotreq", "Please select the required plot",
        c(
          "Barchart" = "barchart",
          "Barchart with grouping" = "bcg",
          "Boxplot" = "boxplot"
        ),
        "barchart"
      ))
    }
  })

  output$varboxplot <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$submit)) {
      return()
    }
    if (is.null(input$plotreq)) {
      return()
    }
    if (input$plotreq == "boxplot") {
      if (input$submit > 0) {
        list(
          textInput("xlab", "Enter required x-axis label", "X-axis"),
          textInput("ylab", "Enter required y-axis label", "Y-axis"),
          selectInput(
            "col1", "Line colour pattern",
            c(
              "Pattern 1" = "Dark2",
              "Pattern 2" = "Set2",
              "Pattern 3" = "Set3",
              "Pattern 4" = "Accent",
              "Pattern 5" = "Set1"
            ),
            "Dark2"
          ),
          sliderInput("size", "Required width of the line:",
            min = 0.5, max = 2, value = 0.5
          ),
          sliderInput("size1", "X-axis label size:",
            min = 10, max = 20, value = 10
          ),
          sliderInput("size2", "Y-axis label size:",
            min = 10, max = 20, value = 10
          ),
          checkboxInput(
            "grey_box",
            "Convert the plot to grey scale", FALSE
          ),
          actionBttn(
            inputId = "submit1",
            label = "Click here to Draw",
            color = "success",
            style = "stretch"
          )
        )
      }
    }
    else if (input$plotreq == "barchart") {
      if (input$submit > 0) {
        list(
          textInput("xlab", "Enter required x-axis label", "X-axis"),
          textInput("ylab", "Enter required y-axis label", "Y-axis"),
          textInput("title", "Enter required Title", "title"),
          selectInput(
            "col1", "Select colour pattern",
            c(
              "Pattern 1" = "Dark2",
              "Pattern 2" = "Set2",
              "Pattern 3" = "Set3",
              "Pattern 4" = "Accent",
              "Pattern 5" = "Set1"
            ),
            "Dark2"
          ),
          sliderInput("width1", "Required width of the bar:",
            min = 0.1, max = 1, value = 0.5
          ),
          sliderInput("width2", "Required width of error bar:",
            min = 0.1, max = 1, value = 0.2
          ),
          sliderInput("width3", "X-axis label size:",
            min = 10, max = 20, value = 10
          ),
          sliderInput("width4", "Y-axis label size:",
            min = 10, max = 20, value = 10
          ),
          sliderInput("trans", "colour Transparency of bar:",
            min = 0.1, max = 1, value = 1
          ),
          sliderInput("trans1", "colour Transparency of error bar:",
            min = 0, max = 1, value = 1
          ),
          checkboxInput(
            "grey",
            "Convert the plot to grey scale", FALSE
          ),
          actionBttn(
            inputId = "submit1",
            label = "Click here to draw",
            color = "success",
            style = "stretch"
          )
        )
      }
    }
    else if (input$plotreq == "bcg") {
      if (input$submit > 0) {
        list(
          textInput("xlab", "Enter required x-axis label", "X-axis"),
          textInput("ylab", "Enter required y-axis label", "Y-axis"),
          textInput("title", "Enter required Title", "title"),
          selectInput(
            "col1", "Select colour pattern",
            c(
              "Pattern 1" = "Dark2",
              "Pattern 2" = "Set2",
              "Pattern 3" = "Set3",
              "Pattern 4" = "Accent",
              "Pattern 5" = "Set1"
            ),
            "Dark2"
          ),
          sliderInput("width1", "Required width of the bar:",
            min = 0.1, max = 1, value = 0.5
          ),
          sliderInput("width2", "Required width of error bar:",
            min = 0.1, max = 1, value = 0.2
          ),
          sliderInput("width3", "X-axis label size:",
            min = 10, max = 20, value = 10
          ),
          sliderInput("width4", "Y-axis label size:",
            min = 10, max = 20, value = 10
          ),
          sliderInput("trans", "colour Transparency of bar:",
            min = 0.1, max = 1, value = 1
          ),
          sliderInput("trans1", "colour Transparency of error bar:",
            min = 0, max = 1, value = 1
          ),
          sliderInput("width5", "Font label size of grouping letters:",
            min = 1.5, max = 6.5, value = 3.5
          ),
          checkboxInput(
            "grey",
            "Convert the plot to grey scale", FALSE
          ),
          actionBttn(
            inputId = "submit1",
            label = "Click here to draw",
            color = "success",
            style = "stretch"
          )
        )
      }
    }
  })

  ####################################### PLots and Graphs
  output$boxplot <- renderPlot(
    {
      plotInput()
    },
    bg = "transparent"
  )


  ############################# Download Report


  output$downloadReport <- downloadHandler(
    filename = function() {
      paste("my-report", sep = ".", switch(input$format,
        HTML = "html"
      ))
    },
    content = function(file) {
      src <- normalizePath("report.Rmd")
      owd <- setwd(tempdir())
      on.exit(setwd(owd))
      file.copy(src, "report.Rmd", overwrite = TRUE)
      out <- render("report.Rmd", switch(input$format,
        HTML = html_document()
      ))
      file.rename(out, file)
    }
  )


  ######################## Download Image
  output$image_down <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$plotreq)) {
      return()
    }
    if (is.null(input$submit1)) {
      return()
    }
    if (input$plotreq == "boxplot") {
      if (input$submit1 > 0) {
        list(downloadButton("downloadImage1",
          label = "Download BoxPlot", class = "butt1"
        ))
      }
    }

    else if (input$plotreq == "barchart" || input$plotreq == "bcg") {
      if (input$submit1 > 0) {
        list(downloadButton("downloadImage2",
          label = "Download Barchart", class = "butt1"
        ))
      }
    }
  })


  ### plotting
  plotInput <- reactive({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$plotreq)) {
      return()
    }
    if (is.null(input$submit1)) {
      return()
    }

    if (input$plotreq == "boxplot") {
      if (input$submit1 > 0) {
        nb.cols <- as.numeric(input$trt + 2)
        x <- as.matrix(csvfile()[, input$treatment])
        y <- as.matrix(csvfile()[, input$yield])
        my_data <- data.frame(
          group = x,
          obs = y
        )

        colnames(my_data) <- c("Treatments", "obs")
        mycolors <- colorRampPalette(brewer.pal(8, input$col1))(nb.cols)
        if (input$grey_box > 0) {
          p <- ggplot2::ggplot(
            my_data,
            aes(
              x = Treatments, y = obs,
              fill = Treatments
            )
          ) +
            geom_boxplot(lwd = input$size) +
            scale_fill_grey(start = 0.3, end = .9) +
            theme_bw() +
            labs(x = input$xlab, y = input$ylab) +
            theme(
              axis.text.x = element_text(
                angle = 90,
                size = input$size1,
                hjust = 1
              ),
              axis.text.y = element_text(size = input$size2)
            )
          p
        }
        else {
          p <- ggplot2::ggplot(
            my_data,
            aes(
              x = Treatments, y = obs,
              fill = Treatments
            )
          ) +
            geom_boxplot(lwd = input$size) +
            scale_fill_manual(values = mycolors) +
            theme_bw() +
            labs(x = input$xlab, y = input$ylab) +
            theme(
              axis.text.x = element_text(
                angle = 90,
                size = input$size1,
                hjust = 1
              ),
              axis.text.y = element_text(size = input$size2)
            )
          p
        }
      }
    }

    else if (input$plotreq == "barchart") {
      if (input$submit1 > 0) {
        d <- as.data.frame(csvfile())
        r <- as.numeric(input$rep)
        t <- as.numeric(input$trt)
        response <- d[, input$yield]
        treatment <- d[, input$treatment]
        replication <- d[, input$Replication]
        treatment <- factor(treatment)
        replication <- factor(replication)
        anvaTable <- lm(response ~ treatment + replication)
        result <- as.data.frame(stats::anova(anvaTable))
        out <- agricolae::LSD.test(
          d[, input$yield],
          d[, input$treatment],
          result[3, 1], result[3, 3]
        )
        d1 <- out$means
        alpha <- 0.05
        t <- qt(alpha / 2, result[3, 1], lower.tail = FALSE) # tvalue
        d1$std_er <- d1$std / (sqrt(d1$r))
        drops <- c(
          "r", "Q25", "Q50", "Q75",
          "Max", "Min", "LCL", "UCL", "r", "std"
        )
        d1 <- d1[, !(names(d1) %in% drops)]
        d2 <- out$groups
        d <- merge(d1, d2, by = 0, all = TRUE)
        d <- d[-4]
        d$ic <- t * d$std_er
        colnames(d) <- c(
          "treatment", "Response", "std.er",
          "group", "ic"
        )
        # arrange treatments inorder during plotting
        d <- d[gtools::mixedorder(d$treatment), ]
        Treatments <- factor(d$treatment, levels = d$treatment)
        nb.cols <- as.numeric(input$trt + 2)
        mycolors <- colorRampPalette(brewer.pal(8, input$col1))(nb.cols)


        if (input$grey > 0) {
          p <- ggplot(d, aes(x = as.factor(treatment), y = Response, fill = Treatments)) +
            geom_bar(
              stat = "identity",
              position = position_dodge(width = 1),
              alpha = input$trans, width = input$width1
            ) +
            geom_errorbar(aes(ymin = Response - ic, ymax = Response + ic),
              width = input$width2, colour = "black", alpha = input$trans1,
              size = 0.5
            ) +
            scale_x_discrete(labels=unique(d$treatment))+
            ggtitle(input$title) +
            scale_fill_grey(start = 0.3, end = .9) +
            scale_y_continuous(expand = expansion(mult = c(0, .3))) +
            theme_bw() +
            theme(
              plot.title = element_text(size = 22, hjust = 0.5),
              axis.text.x = element_text(angle = 90, hjust = 1, size = input$width3),
              axis.text.y = element_text(size = input$width4)
            )


          p
        }
        else {
          p <- ggplot(d, aes(x = as.factor(treatment), y = Response, fill = Treatments)) +
            geom_bar(
              stat = "identity",
              position = position_dodge(width = 1),
              alpha = input$trans, width = input$width1
            ) +
            scale_x_discrete(labels=unique(d$treatment))+
            geom_errorbar(aes(ymin = Response - ic, ymax = Response + ic),
              width = input$width2, colour = "black", alpha = input$trans1,
              size = 0.5
            ) +
            labs(x = input$xlab, y = input$ylab) +
            ggtitle(input$title) +
            scale_fill_manual(values = mycolors) +
            scale_y_continuous(expand = expansion(mult = c(0, .3))) +
            theme_bw() +
            theme(
              plot.title = element_text(size = 22, hjust = 0.5),
              axis.text.x = element_text(angle = 90, hjust = 1, size = input$width3),
              axis.text.y = element_text(size = input$width4)
            )


          p
        }
      }
    }
    else if (input$plotreq == "bcg") {
      if (input$submit1 > 0) {
        d <- as.data.frame(csvfile())
        r <- as.numeric(input$rep)
        t <- as.numeric(input$trt)
        response <- d[, input$yield]
        treatment <- d[, input$treatment]
        replication <- d[, input$Replication]
        treatment <- factor(treatment)
        replication <- factor(replication)
        anvaTable <- lm(response ~ treatment + replication)
        result <- as.data.frame(stats::anova(anvaTable))
        out <- agricolae::LSD.test(
          d[, input$yield],
          d[, input$treatment],
          result[3, 1], result[3, 3]
        )
        d1 <- out$means
        alpha <- 0.05
        t <- qt(alpha / 2, result[3, 1], lower.tail = FALSE) # tvalue
        d1$std_er <- d1$std / (sqrt(d1$r))
        drops <- c(
          "r", "Q25", "Q50", "Q75",
          "Max", "Min", "LCL", "UCL", "r", "std"
        )
        d1 <- d1[, !(names(d1) %in% drops)]
        d2 <- out$groups
        d <- merge(d1, d2, by = 0, all = TRUE)
        d <- d[-4]
        d$ic <- t * d$std_er
        colnames(d) <- c(
          "treatment", "Response", "std.er",
          "group", "ic"
        )
        d <- d[gtools::mixedorder(d$treatment), ]
        Treatments <- factor(d$treatment, levels = d$treatment)
        nb.cols <- as.numeric(input$trt + 2)
        mycolors <- colorRampPalette(brewer.pal(8, input$col1))(nb.cols)

        # plotting
        if (input$grey > 0) {
          p <- ggplot(d, aes(x = as.factor(treatment), y = Response, fill = Treatments)) +
            geom_bar(
              stat = "identity",
              position = position_dodge(width = 1),
              alpha = input$trans, width = input$width1
            ) +
            geom_errorbar(aes(ymin = Response - ic, ymax = Response + ic),
              width = input$width2, colour = "black", alpha = input$trans1,
              size = 0.5
            ) +
            scale_x_discrete(labels = unique(d$treatment))+
            geom_text(aes(label = group, y = Response + ic), vjust = -0.5,
                      size=input$width5) +
            labs(x = input$xlab, y = input$ylab) +
            ggtitle(input$title) +
            scale_fill_grey(start = 0.3, end = .9) +
            scale_y_continuous(expand = expansion(mult = c(0, .3))) +
            theme_bw() +
            theme(
              plot.title = element_text(size = 22, hjust = 0.5),
              axis.text.x = element_text(angle = 90, hjust = 1, size = input$width3),
              axis.text.y = element_text(size = input$width4)
            )


          p
        }

        else {
          p <- ggplot(d, aes(x = as.factor(treatment), y = Response, fill = Treatments)) +
            geom_bar(
              stat = "identity",
              position = position_dodge(width = 1),
              alpha = input$trans, width = input$width1
            ) +
            geom_errorbar(aes(ymin = Response - ic, ymax = Response + ic),
              width = input$width2, colour = "black", alpha = input$trans1,
              size = 0.5
            ) +
            scale_x_discrete(labels = unique(d$treatment))+
            geom_text(aes(label = group, y = Response + ic), vjust = -0.5,
                      size=input$width5) +
            labs(x = input$xlab, y = input$ylab) +
            ggtitle(input$title) +
            scale_fill_manual(values = mycolors) +
            scale_y_continuous(expand = expansion(mult = c(0, .3))) +
            theme_bw() +
            theme(
              plot.title = element_text(size = 22, hjust = 0.5),
              axis.text.x = element_text(angle = 90, hjust = 1, size = input$width3),
              axis.text.y = element_text(size = input$width4)
            )


          p
        }
      }
    }
  })

  ###
  output$downloadImage1 <- downloadHandler(
    filename = "boxplot.png",
    content = function(file) {
      device <- function(..., width, height) {
        grDevices::png(...,
          width = width, height = height,
          res = 500, units = "in"
        )
      }
      ggsave(file, plot = plotInput(), device = device)
    }
  )

  output$downloadImage2 <- downloadHandler(
    filename = "barchart.png",
    content = function(file) {
      device <- function(..., width, height) {
        grDevices::png(...,
          width = width, height = height,
          res = 500, units = "in"
        )
      }
      ggsave(file, plot = plotInput(), device = device)
    }
  )

  ########################### end image download

  ############################## download data set
  output$data_set <- renderUI({
    if (is.null(input$file1$datapath)) {
      list(
        selectInput("dataset", "Choose a dataset:",
          choices = c("mango data", "feed data", "sample data")
        ),
        downloadButton("downloadData", label = "Download csv file to test", class = "butt1")
      )
    }

    else {
      return()
    }
  })
  datasetInput <- reactive({
    mango <- read.csv(system.file("extdata/rbd_data",
      "mango_rbd.csv",
      package = "grapesAgri1"
    ))
    feed <- read.csv(system.file("extdata/rbd_data",
      "feed_rbd.csv",
      package = "grapesAgri1"
    ))
    sample1 <- read.csv(system.file("extdata/rbd_data",
      "sample_rbd.csv",
      package = "grapesAgri1"
    ))
    switch(input$dataset,
      "mango data" = mango,
      "feed data" = feed,
      "sample data" = sample1
    )
  })

  output$downloadData <- downloadHandler(
    filename = function() {
      paste(input$dataset, ".csv", sep = "")
    },
    content = function(file) {
      write.csv(datasetInput(), file, row.names = FALSE)
    }
  )
  ######################### end data set download
  ############################### this note appear on opening
  output$start_note <- renderUI({
    if (is.null(input$file1$datapath)) {
      return(
        HTML(paste0(
          " <h4> To perform analysis using your own dataset, prepare excel file in csv format by reading instruction below </h4>
<p>
<ui>
<li>Open a new blank excel file</li>
<li>Copy and paste observations into a new sheet (use only one sheet) of a new excel file</li>
<li>Three columns are required Treatment, Replication and Response. </li>
<li>You can use any names for your columns</li>
<li>You can also add more than one response as columns</li>
<li>No space is allowed in the treatment name. </li>
<li>If space is required use underscore ‘_’ or ‘.’ full stop; for example ‘Treatment name’ should be written as Treatment_name or Treatment.name</li>
<li>Don't type and delete anything on other cells without data. If so select those cells, right click and click clear contents. </li>
<li>Give names to all column, Don't add any unnecessary columns that is not required for analysis</li>
<li>Data should be arranged towards upper left corner and row above the data should not be left blank. </li>
<li>Once all these are done, your file is ready. Now save it as CSV file. </li>
<li><b>Upload file by clicking browse in the app </b></li>
</ui>
</p>
<b> You can download a model data set from below and test the App  </b>

"
        ))
      )
    }

    else {
      return()
    }
  })

  output$start_note2 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return(
        HTML(paste0(
          "<li> <b>Note</b>: Don't forget to enter
        Treatment number and Replication number
          while doing analysis</li>"
        ))
      )
    }

    else {
      return()
    }
  })

  output$start_note3 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return(
        HTML(paste0(
          "<b>Plots will appear here once you upload the csv file by
        clicking 'Browse' and click submit</b>
        "
        ))
      )
    }

    else {
      return()
    }
  })
}

shinyApp(ui = ui, server = server)

library(shiny)
library(shinyWidgets)
library(rmarkdown)
library(knitr)
library(dplyr)
library(magrittr)
library(gridGraphics)
library(kableExtra)
library(pastecs)
library(ggpubr)
library(summarytools)
library(ggplot2)
library(datasets)
library(grid)
############################### ui
ui <- fluidPage(
  setBackgroundColor(
    color = c("#faf1d2", "#ffffff"),
    gradient = "radial",
    direction = c("bottom", "right")
  ),
  tags$script("$(document).on('shiny:connected', function(event) {
var myWidth = $(window).width();
Shiny.onInputChange('shiny_width',myWidth)

});"),
  tags$script("$(document).on('shiny:connected', function(event) {
var myHeight = $(window).height();
Shiny.onInputChange('shiny_height',myHeight)

});"),
  titlePanel(
    title = tags$b("Descriptive Statistics & Visualization"),
    windowTitle = "Descriptive Statistics"
  ),
  sidebarPanel(
    fileInput("file1", "CSV File (upload in csv format)",
      accept = c("text/csv", "text/comma-separated-values,text/plain", ".csv")
    ),
    checkboxInput("header", "Header", TRUE),
    selectInput(
      "req", "Please select the analysis type",
      c(
        SUMMARY = "summary",
        SUMMARY_by_Group = "sumbygrp",
        BOX_PLOT = "boxplot",
        Histogram = "histogram",
        QQ_Plot = "qqplot",
        Normality_Test = "nt"
      ),
      "summary"
    ),
    uiOutput("var"),
    tags$br(),
    h5(
      tags$div(
        tags$br(),
        "Developed by:",
        tags$br(),
        tags$b("Dr.Pratheesh P. Gopinath"),
        tags$br(),
        tags$b("Assistant Professor,"),
        tags$br(),
        tags$b("Agricultural Statistics,"),
        tags$br(),
        tags$b("Kerala Agricultural University"),
        tags$br(),
        tags$br(),
        "Contribution:",
        tags$br(),
        tags$b("Adarsh V.S."),
        tags$br(),
        tags$b("MSc, Agricultural Statistics"),
        tags$br(),
        tags$br(),
        "post your queries at: pratheesh.pg@kau.in",
        style = "color:#343aeb"
      )
    )
  ),
  mainPanel(
    htmlOutput("note"),
    uiOutput("data_set"), # for data set download
    tableOutput("summaryout"),
    verbatimTextOutput("nort"),
    htmlOutput("text3"),
    tableOutput("bygroup"),
    uiOutput("var1"),
    uiOutput("var2"),
    uiOutput("plot"),
    tags$br(),
    uiOutput("image_down")
  )
)

#################################### SERVER
server <- function(input, output, session) {
  csvfile <- reactive({
    csvfile <- input$file1
    if (is.null(csvfile)) {
      return(NULL)
    }
    dt <- read.csv(csvfile$datapath, header = input$header, sep = ",", check.names = FALSE)
    dt
  })

  output$var <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req)) {
      return()
    }
    if (input$req == "boxplot") {
      list(
        checkboxGroupInput("variable", HTML("Please select the variable for box plot"), choices = names(csvfile())),
        textInput("xlab", "Enter required x-axis label", "X-axis"),
        selectInput(
          "color", "Please select the border colour",
          c(
            Black = "#141413",
            Red = "#ff0d1d",
            Blue = "#0d45ff",
            Green = "#0dff0d",
            Yellow = "#ffdf0d",
            Orange = "#ff8a0d"
          ),
          "#141413"
        ),
        selectInput(
          "colorbox", "Please select the box colour",
          c(
            white = "#faf9f7",
            Red = "#ffa299",
            Blue = "#c1cff7",
            Green = "#d0f7b2",
            Yellow = "#f7f7ad",
            Orange = "#f5c084"
          ),
          "#faf9f7"
        ),
        actionBttn(
          inputId = "submit1",
          label = "SUBMIT!",
          color = "danger",
          style = "jelly"
        )
      )
    }
    else if (input$req == "histogram") {
      list(
        selectInput("variable", HTML("Please select the variable for histogram"), choices = names(csvfile())),
        textInput("xlab", "Enter required x-axis label", "X-axis"),
        selectInput(
          "color", "Please select the border colour",
          c(
            Black = "#141413",
            Red = "#ff0d1d",
            Blue = "#0d45ff",
            Green = "#0dff0d",
            Yellow = "#ffdf0d",
            Orange = "#ff8a0d"
          ),
          "#141413"
        ),
        selectInput(
          "colorbox", "Please select the box colour",
          c(
            white = "#faf9f7",
            Red = "#ffa299",
            Blue = "#c1cff7",
            Green = "#d0f7b2",
            Yellow = "#f7f7ad",
            Orange = "#f5c084"
          ),
          "#faf9f7"
        ),
        actionBttn(
          inputId = "submit2",
          label = "SUBMIT!",
          color = "danger",
          style = "jelly"
        )
      )
    }
    else if (input$req == "qqplot") {
      list(
        selectInput("variable", HTML("Please select the variable for Q-Q plot"), choices = names(csvfile())),
        radioButtons("style", HTML("Please select the required style"), choices = c("Style 1", "Style 2")),
        selectInput(
          "color", "Select the line colour",
          c(
            Black = "#141413",
            Red = "#ff0d1d",
            Blue = "#0d45ff",
            Green = "#0dff0d",
            Yellow = "#ffdf0d",
            Orange = "#ff8a0d"
          ),
          "#141413"
        ),
        actionBttn(
          inputId = "submit3",
          label = "SUBMIT!",
          color = "danger",
          style = "jelly"
        )
      )
    }
    else if (input$req == "summary") {
      list(
        checkboxGroupInput("var", HTML("Please select the variables <br/> (Quantitative variables only)"), choices = names(csvfile())),
        actionBttn(
          inputId = "submit4",
          label = "SUBMIT!",
          color = "danger",
          style = "jelly"
        )
      )
    }
    else if (input$req == "sumbygrp") {
      list(
        checkboxGroupInput("var", HTML("Please select the variables <br/> (Quantitative variables only)"), choices = names(csvfile())),
        radioButtons("group", HTML("Please select the group if any <br/> (Qualitative variables if any)"), choices = names(csvfile())),
        actionBttn(
          inputId = "submit5",
          label = "SUBMIT!",
          color = "danger",
          style = "jelly"
        )
      )
    }
    else if (input$req == "nt") {
      list(
        radioButtons("var", HTML("Please select the variables <br/> (Quantitative variables only)"), choices = names(csvfile())),
        actionBttn(
          inputId = "submit",
          label = "SUBMIT!",
          color = "danger",
          style = "jelly"
        )
      )
    }
  })


  output$var1 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req)) {
      return()
    }
    if (is.null(input$submit4)) {
      return()
    }
    if (input$req == "summary") {
      if (input$submit4 > 0) {
        list(
          radioButtons("format", "Download report (Note: if you are changing the file name after download give '.html' extension):", c("HTML"),
            inline = TRUE
          ),
          downloadButton("downloadReport")
        )
      }
    }
  })

  output$var2 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req)) {
      return()
    }
    if (is.null(input$submit5)) {
      return()
    }
    if (input$req == "sumbygrp") {
      if (input$submit5 > 0) {
        list(
          radioButtons("format", "Download report (Note: if you are changing the file name after download give '.html' extension):", c("HTML"),
            inline = TRUE
          ),
          downloadButton("downloadReport")
        )
      }
    }
  })

  ############################# Summary
  output$summaryout <- function() {
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req)) {
      return()
    }
    if (is.null(input$submit4)) {
      return()
    }
    if (input$req == "summary") {
      if (input$submit4 > 0) {
        y <- subset(csvfile(), select = input$var)
        final <-
          summarytools::descr(y) %>%
          summarytools::tb(order = 3) %>%
          knitr::kable(digits = 2, caption = "Summary Statistics") %>%
          kableExtra::kable_styling("bordered", full_width = F) %>%
          kableExtra::collapse_rows(columns = 1, valign = "top")
        final
      }
    }
  }
  ####################################### Shapiro Wilk's Test
  output$nort <- renderPrint({
    if (is.null(input$file1$datapath)) {
      return(invisible())
    }
    if (is.null(input$req)) {
      return(invisible())
    }
    if (is.null(input$submit)) {
      return(invisible())
    }
    if (input$req == "nt") {
      if (input$submit > 0) {
        y <- subset(csvfile(), select = input$var)
        data <- as.data.frame(y)
        colnames(data) <- "variable_under_study"
        test <- stats::shapiro.test(data$variable_under_study)
        test
      }
    }
  })
  ############################# Summary by group
  output$bygroup <- function() {
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req)) {
      return()
    }
    if (is.null(input$submit5)) {
      return()
    }
    if (input$req == "sumbygrp") {
      if (input$submit5 > 0) {
        y1 <- subset(csvfile(), select = input$var)
        y2 <- subset(csvfile(), select = input$group)
        final <-
          summarytools::stby(y1, y2, descr) %>%
          summarytools::tb(order = 1) %>%
          knitr::kable(digits = 2, caption = "Summary Statistics by Group") %>%
          kableExtra::kable_styling("bordered", full_width = F) %>%
          kableExtra::collapse_rows(columns = 1, valign = "top")
        final
      }
    }
  }
  ###################### text of shapiro wilk's
  output$text3 <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req)) {
      return()
    }
    if (is.null(input$submit)) {
      return()
    }
    if (input$submit > 0) {
      if (input$req == "nt") {
        y <- subset(csvfile(), select = input$var)
        data <- as.data.frame(y)
        colnames(data) <- "variable_under_study"
        test <- shapiro.test(data$variable_under_study)
        if (test$p.value <= 0.05) {
          HTML(paste0(" Here <b>p-value is < 0.05</b>; <b>Null hypothesis</b>: data follows a normal distribution is <b>rejected </b> at
                    5% level of significance. In other words data does not follows normal distribution"))
        }
        else {
          HTML(paste0(" Here <b>p-value is > 0.05</b>; We don't have enough evidence
                      to reject the <b>Null hypothesis</b>: Data follows a normal distribution
                      at 5% level of significance; we assume that data is normal in this case</b>."))
        }
      }
    }
  })
  ########################################## plots
  output$plot <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req)) {
      return()
    }
    if (input$req == "boxplot") {
      if (is.null(input$submit1)) {
        return()
      }
      output$boxplot <- renderPlot(
        {
          if (input$submit1 > 0) {
            graphics::boxplot(csvfile()[, input$variable],
              xlab = input$xlab,
              col = input$colorbox,
              border = input$color
            )
          }
        },
        bg = "transparent"
      )
      plotOutput("boxplot")
    }
    else if (input$req == "histogram") {
      if (is.null(input$submit2)) {
        return()
      }
      output$histogram <- renderPlot(
        {
          if (input$submit2 > 0) {
            graphics::hist(csvfile()[, input$variable],
              main = "Histogram",
              xlab = input$xlab,
              col = input$colorbox,
              border = input$color,
              freq = TRUE
            )
          }
        },
        bg = "transparent"
      )
      plotOutput("histogram")
    }

    else if (input$req == "qqplot") {
      if (is.null(input$submit3)) {
        return()
      }
      output$qqplot <- renderPlot(
        {
          if (input$style == "Style 1" && input$submit3 > 0) {
            stats::qqnorm(csvfile()[, input$variable],
              pch = 3,
              frame = FALSE
            )
            stats::qqline(csvfile()[, input$variable],
              col = input$color,
              lwd = 2
            )
          }
          else if (input$style == "Style 2" && input$submit3 > 0) {
            ggpubr::ggqqplot(csvfile()[, input$variable], color = input$color)
          }
        },
        bg = "transparent"
      )
      plotOutput("qqplot")
    }
  })


  ############################### this note appear on opening
  output$note <- renderUI({
    if (is.null(input$file1$datapath)) {
      return(
        HTML(paste0(" <h4> To perform analysis using your own dataset prepare excel file in csv format by reading instruction below  </h4>
<p>
<ui>
<li>Open a new blank excel file</li>
<li>Copy and paste observations into a new sheet (use only one sheet) of a new excel file</li>
<li>Observations should be pasted as columns </li>
<li>Don't type or delete anything on other cells without data</li>
<li>You can use any names for your columns. No space is allowed in the Column name. If space is required use underscore ‘_’ or ‘.’ full stop; for example ‘Variable name’ should be written as Variable_name or Variable.name</li>
<li>Data should be arranged towards upper left corner and row above the data should not be left blank </li>
<li>Don't type and delete anything on other cells without data. If so select those cells, right click and click clear contents </li>
<li>Give names to all column, Don't add any unnecessary columns that is not required for analysis</li>
<li>Once all these are done, your file is ready. Now save it as CSV file. </li>
<li><b>Upload file by clicking browse in the app </b></li>
</ui>
</p>
<h5> You can download a model data set from below and test the App  </h5>
"))
      )
    }

    else {
      return()
    }
  })

  ########################################## dataset download
  output$data_set <- renderUI({
    if (is.null(input$file1$datapath)) {
      list(
        selectInput("dataset", "Choose a dataset:",
          choices = c("iris", "pressure", "cars")
        ),
        downloadButton("downloadData", label = "Download csv file to test", class = "butt1")
      )
    }

    else {
      return()
    }
  })
  datasetInput <- reactive({
    switch(input$dataset,
      "iris" = iris,
      "pressure" = pressure,
      "cars" = cars
    )
  })

  output$downloadData <- downloadHandler(
    filename = function() {
      paste(input$dataset, ".csv", sep = "")
    },
    content = function(file) {
      write.csv(datasetInput(), file, row.names = FALSE)
    }
  )

  ################### download Report
  output$downloadReport <- downloadHandler(
    filename = function() {
      paste("my-report", sep = ".", switch(input$format,
        HTML = "html"
      ))
    },
    content = function(file) {
      src <- normalizePath("report.Rmd")
      owd <- setwd(tempdir())
      on.exit(setwd(owd))
      file.copy(src, "report.Rmd", overwrite = TRUE)

      out <- render("report.Rmd", switch(input$format,
        HTML = html_document()
      ))
      file.rename(out, file)
    }
  )

  #################################### Download Image
  output$image_down <- renderUI({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req)) {
      return()
    }
    if (input$req == "boxplot") {
      if (is.null(input$submit1)) {
        return()
      }
      if (input$submit1 > 0) {
        list(downloadButton("downloadImage1",
          label = "Download BoxPlot", class = "butt1"
        ))
      }
    }

    else if (input$req == "histogram") {
      if (is.null(input$submit2)) {
        return()
      }
      if (input$submit2 > 0) {
        list(downloadButton("downloadImage2",
          label = "Download Histogram", class = "butt1"
        ))
      }
    }
    else if (input$req == "qqplot") {
      if (is.null(input$submit3)) {
        return()
      }

      if (input$submit3 > 0) {
        list(downloadButton("downloadImage3",
          label = "Download Q-Q plot", class = "butt1"
        ))
      }
    }
  })

  ### plotting
  plotInput <- reactive({
    if (is.null(input$file1$datapath)) {
      return()
    }
    if (is.null(input$req)) {
      return()
    }
    if (input$req == "boxplot") {
      if (is.null(input$submit1)) {
        return()
      }
      if (input$submit1 > 0) {
        graphics::boxplot(csvfile()[, input$variable],
          xlab = input$xlab,
          col = input$colorbox,
          border = input$color
        )
        grid.echo()
        P1 <- grid.grab()
        grid.draw(P1)
      }
    }
    else if (input$req == "histogram") {
      if (is.null(input$submit2)) {
        return()
      }
      if (input$submit2 > 0) {
        graphics::hist(csvfile()[, input$variable],
          main = "Histogram",
          xlab = input$xlab,
          col = input$colorbox,
          border = input$color,
          freq = TRUE
        )
        grid.echo()
        P1 <- grid.grab()
        grid.draw(P1)
      }
    }
    else if (input$req == "qqplot") {
      if (is.null(input$submit3)) {
        return()
      }
      if (input$style == "Style 1" && input$submit3 > 0) {
        stats::qqnorm(csvfile()[, input$variable],
          pch = 3,
          frame = FALSE
        )
        stats::qqline(csvfile()[, input$variable],
          col = input$color,
          lwd = 2
        )
      }
      else if (input$style == "Style 2" && input$submit3 > 0) {
        ggpubr::ggqqplot(csvfile()[, input$variable], color = input$color)
      }
    }
  })

  ###
  output$downloadImage1 <- downloadHandler(
    filename = "boxplot.png",
    content = function(file) {
      png(file,
        width = input$shiny_width,
        height = input$shiny_height,
        res = 150, bg = "transparent"
      )
      plotInput()
      dev.off()
    }
  )

  output$downloadImage2 <- downloadHandler(
    filename = "histogram.png",
    content = function(file) {
      png(file,
        width = input$shiny_width,
        height = input$shiny_height,
        res = 150, bg = "transparent"
      )
      plotInput()
      dev.off()
    }
  )

  output$downloadImage3 <- downloadHandler(
    filename = "qqplot.png",
    content = function(file) {
      if (input$style == "Style 1" && input$submit3 > 0) {
        png(file,
          width = input$shiny_width,
          height = input$shiny_height,
          res = 150, bg = "transparent"
        )
        plotInput()
        dev.off()
      }
      else if (input$style == "Style 2" && input$submit3 > 0) {
        device <- function(..., width, height) {
          grDevices::png(...,
            width = width, height = height,
            res = 500, units = "in"
          )
        }
        ggsave(file, plot = plotInput(), device = device)
      }
    }
  )

  ###########################
}
shinyApp(ui = ui, server = server)

---
title: "Completely Randomized Design"
output: html_document
---


```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = FALSE)
library(knitr)
library(Hmisc)
library(agricolae)
library(dplyr)
library(magrittr)
library(kableExtra)
library(gtools)
```
## RESULT
CRD ANALYSIS

```{r, echo = FALSE}
csvfile <- reactive({
  csvfile <- input$file1
  if (is.null(csvfile)) {
    return(NULL)
  }
  dt <- read.csv(csvfile$datapath, header = input$header, sep = ",", check.names = FALSE)
  dt
})
################################ trt means
if (input$submit > 0) {
  input$reload
  Sys.sleep(2)
  d <- as.data.frame(csvfile())
  t <- as.numeric(input$trt)
  response <- d[, input$yield]
  treatment <- d[, input$treatment]
  treatment <- factor(treatment)
  anvaTable <- lm(response ~ treatment)
  result <- as.data.frame(anova(anvaTable))
  out <- LSD.test(csvfile()[, input$yield], csvfile()[, input$treatment], result[2, 1], result[2, 3])
  trtmeans <- out$means
  trtmeans <- trtmeans[ gtools::mixedsort(row.names(trtmeans)), ]
  colnames(trtmeans)[1] <- "Treatment_means"
  drops <- c("r", "Q25", "Q50", "Q75")
  result <- trtmeans[, !(names(trtmeans) %in% drops)]
  kable(result, digits = 3, caption = "Treatment mean and other statistics", align = "c", row.names = TRUE) %>% kable_styling() %>% kable_paper("hover", full_width = F)
}
################ finish
tags$br()
################################ ANOVA TABLE
if (input$submit > 0) {
  d <- as.data.frame(csvfile())
  t <- as.numeric(input$trt)
  response <- d[, input$yield]
  treatment <- d[, input$treatment]
  treatment <- factor(treatment)
  anvaTable <- lm(response ~ treatment)
  result <- as.data.frame(anova(anvaTable))
  SoV <- c("Treatment", "Error")
  final <- cbind(SoV, result)
  kable(final, digits = 3, caption = "ANOVA TABLE", align = "c", row.names = FALSE) %>% kable_styling() %>% kable_paper("hover", full_width = F)
}
############################# finish
tags$br()
###################### SEM
if (input$submit > 0) {
  if (input$filerepli == "equal") {
    d <- as.data.frame(csvfile())
    t <- as.numeric(input$trt)
    response <- d[, input$yield]
    treatment <- d[, input$treatment]
    treatment <- factor(treatment)
    anvaTable <- lm(response ~ treatment)
    result <- as.data.frame(anova(anvaTable))
    out <- LSD.test(csvfile()[, input$yield], csvfile()[, input$treatment], result[2, 1], result[2, 3])
    colnam <- c("MSE", "SE(d)", "SE(m)", "CV(%)")
    stat <- out$statistics
    repl <- out$means
    r <- repl[1, 3]
    MSE <- stat[1, 1]
    SED <- sqrt((2 * MSE) / r)
    SEM <- sqrt(MSE / r)
    CV <- stat[1, 4]
    Result <- cbind(MSE, SED, SEM, CV)
    colnames(Result) <- colnam
    kable(Result, digits = 3, caption = "Other important Statistics", align = "c", row.names = FALSE) %>% kable_styling() %>% kable_paper("hover", full_width = F)
  }
}
#################################### finish
tags$br()
########################### TEXT INFERENCE
if (input$submit > 0) {
  d <- as.data.frame(csvfile())
  t <- as.numeric(input$trt)
  response <- d[, input$yield]
  treatment <- d[, input$treatment]
  treatment <- factor(treatment)
  anvaTable <- lm(response ~ treatment)
  result <- as.data.frame(anova(anvaTable))
  if (result[1, 5] <= 0.05) {
    cat("Since the P-value in ANOVA table is < 0.05,\nthere is a significant difference between atleast a pair of treatments,\nso multiple comparison is required to identify best treatment(s)")
  }
  if (result[1, 5] > 0.05) {
    cat("Treatment means are not significantly different")
  }
}
#########################
tags$br()
################################### Multi
if (input$submit > 0) {
  if (input$filerepli == "equal") {
    d <- as.data.frame(csvfile())
    t <- as.numeric(input$trt)
    response <- d[, input$yield]
    treatment <- d[, input$treatment]
    treatment <- factor(treatment)
    anvaTable <- lm(response ~ treatment)
    result <- as.data.frame(anova(anvaTable))
    if (result[1, 5] > 0.05) {
      return("Multiple comparison test is not performed")
    }

    else if (input$req == "lsd") {
      d <- as.data.frame(csvfile())
      t <- as.numeric(input$trt)
      response <- d[, input$yield]
      treatment <- d[, input$treatment]
      treatment <- factor(treatment)
      anvaTable <- lm(response ~ treatment)
      result <- as.data.frame(anova(anvaTable))
      out <- LSD.test(d[, input$yield], d[, input$treatment], result[2, 1], result[2, 3])
      result1 <- out$statistics
      kable(result1, caption = "LSD test", digits = 3, align = "c") %>% kable_styling() %>% kable_paper("hover", full_width = F)
    }


    else if (input$req == "dmrt") {
      d <- as.data.frame(csvfile())
      t <- as.numeric(input$trt)
      response <- d[, input$yield]
      treatment <- d[, input$treatment]
      treatment <- factor(treatment)
      anvaTable <- lm(response ~ treatment)
      result <- as.data.frame(anova(anvaTable))
      out <- duncan.test(d[, input$yield], d[, input$treatment], result[2, 1], result[2, 3], alpha = 0.05, group = TRUE, main = NULL, console = FALSE)
      result1 <- out$duncan
      kable(result1, caption = "DMRT", digits = 3, align = "c", row.names = FALSE) %>% kable_styling() %>% kable_paper("hover", full_width = F)
    }


    else if (input$req == "tukey") {
      d <- as.data.frame(csvfile())
      t <- as.numeric(input$trt)
      response <- d[, input$yield]
      treatment <- d[, input$treatment]
      treatment <- factor(treatment)
      anvaTable <- lm(response ~ treatment)
      result <- as.data.frame(anova(anvaTable))
      out <- HSD.test(d[, input$yield], d[, input$treatment], result[2, 1], result[2, 3], alpha = 0.05, group = TRUE, main = NULL, unbalanced = FALSE, console = FALSE)
      result1 <- out$statistics
      kable(result1, caption = "Tukey", digits = 3, align = "c") %>% kable_styling() %>% kable_paper("hover", full_width = F)
    }
  }
}
########################## finish
tags$br()
##################### CD matrix
if (input$submit > 0) {
  if (input$filerepli == "unequal") {
    d <- as.data.frame(csvfile())
    t <- as.numeric(input$trt)
    response <- d[, input$yield]
    treatment <- d[, input$treatment]
    treatment <- factor(treatment)
    anvaTable <- lm(response ~ treatment)
    result <- as.data.frame(anova(anvaTable))
    if (result[1, 5] > 0.05) {
      return("Multiple comparison test is not performed")
    }
    else if (input$req == "lsd") {
      d <- as.data.frame(csvfile())
      t <- as.numeric(input$trt)
      response <- d[, input$yield]
      treatment <- d[, input$treatment]
      treatment <- factor(treatment)
      anvaTable <- lm(response ~ treatment)
      result <- as.data.frame(anova(anvaTable))
      count <- table(d[, input$treatment]) # count the number of replications of treatment
      t <- (result[1, 1] + 1) # no.of treatments
      repli <- as.data.frame(count)
      reciproc <- 1 / repli[, 2] # 1/ri
      npw <- choose(t, 2) # number of pairwise combinations
      sumres <- as.vector(apply(combn(reciproc, 2), 2, sum)) # all pairwise sum of reciprocals (1/ri+1/rj)
      ems <- as.vector(replicate(npw, (result[2, 3])))
      SE_D <- sqrt((ems * sumres)) # standard error of difference
      tvalue <- qt(0.975, result[2, 1]) # tvalue
      vect <- replicate(npw, tvalue) # vector of t value
      CD <- vect * SE_D # critical difference
      means <- aggregate(response, list(treatment), mean)
      std <- aggregate(response, list(treatment), sd)
      finalmean <- cbind(means, std[, 2])
      rownames(finalmean) <- NULL
      colnam <- c("Treatment", "mean", "std")
      colnames(finalmean) <- colnam
      b <- matrix(0, t, t)
      b[upper.tri(b, diag = FALSE)] <- CD
      name <- finalmean$Treatment
      colnames(b) <- name
      row.names(b) <- name
      kable(b, caption = "LSD test Matrix of CD values", digits = 3, align = "c") %>% kable_styling() %>% kable_paper("hover", full_width = F)
    }
  }
}
###################
tags$br()
################################### group
if (input$submit > 0) {
  d <- as.data.frame(csvfile())
  t <- as.numeric(input$trt)
  response <- d[, input$yield]
  treatment <- d[, input$treatment]
  treatment <- factor(treatment)
  anvaTable <- lm(response ~ treatment)
  result <- as.data.frame(anova(anvaTable))
  if (result[1, 5] > 0.05) {
    return("")
  }

  else if (input$req == "lsd") {
    d <- as.data.frame(csvfile())
    t <- as.numeric(input$trt)
    response <- d[, input$yield]
    treatment <- d[, input$treatment]
    treatment <- factor(treatment)
    anvaTable <- lm(response ~ treatment)
    result <- as.data.frame(anova(anvaTable))
    out <- LSD.test(d[, input$yield], d[, input$treatment], result[2, 1], result[2, 3])
    outgroup <- out$groups
    colnames(outgroup) <- c("trt_mean", "grouping")
    kable(outgroup, caption = "Treatment Grouping", align = "c") %>% kable_styling() %>% kable_paper("hover", full_width = F)
  }

  else if (input$req == "dmrt") {
    d <- as.data.frame(csvfile())
    t <- as.numeric(input$trt)
    response <- d[, input$yield]
    treatment <- d[, input$treatment]
    treatment <- factor(treatment)
    anvaTable <- lm(response ~ treatment)
    result <- as.data.frame(anova(anvaTable))
    out <- duncan.test(d[, input$yield], d[, input$treatment], result[2, 1], result[2, 3], alpha = 0.05, group = TRUE, main = NULL, console = FALSE)
    outgroup <- out$groups
    colnames(outgroup) <- c("trt_mean", "grouping")
    kable(outgroup, caption = "Treatment Grouping", align = "c") %>% kable_styling() %>% kable_paper("hover", full_width = F)
  }

  else if (input$req == "tukey") {
    d <- as.data.frame(csvfile())
    t <- as.numeric(input$trt)
    response <- d[, input$yield]
    treatment <- d[, input$treatment]
    treatment <- factor(treatment)
    anvaTable <- lm(response ~ treatment)
    result <- as.data.frame(anova(anvaTable))
    out <- HSD.test(d[, input$yield], d[, input$treatment], result[2, 1], result[2, 3], alpha = 0.05, group = TRUE, main = NULL, unbalanced = FALSE, console = FALSE)
    outgroup <- out$groups
    colnames(outgroup) <- c("trt_mean", "grouping")
    outgroup
    kable(outgroup, caption = "Treatment Grouping", align = "c") %>% kable_styling() %>% kable_paper("hover", full_width = F)
  }
}
tags$br()
############
if (input$submit > 0) {
  d <- as.data.frame(csvfile())
  t <- as.numeric(input$trt)
  response <- d[, input$yield]
  treatment <- d[, input$treatment]
  treatment <- factor(treatment)
  anvaTable <- lm(response ~ treatment)
  result <- as.data.frame(anova(anvaTable))
  if (result[1, 5] > 0.05) {
    return("")
  }
  if (input$req == "tukey" || input$req == "dmrt" || input$req == "lsd") {
    cat("Treatments with same letters are not significantly different")
  }
}

tags$br()
tags$br()
```
report generated from:
**Package: grapesAgri1, Version 1.0.0**

---
title: "Compare Means: Small Sample Test"
output: html_document
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
library(shiny)
library(shinyWidgets)
library(shinycssloaders)
library(rmarkdown)
library(pastecs)
library(dplyr)
library(reshape2)
library(knitr)
library(magrittr)
library(kableExtra)

```
## RESULT

```{r, echo = FALSE}
csvfile <- reactive({
    csvfile <- input$file1
    if (is.null(csvfile)){return(NULL)}
    dt <- read.csv(csvfile$datapath, header=input$header, sep=",",check.names = FALSE)
    dt
  })

################## summary one sample ttest
if(input$req1=='ottest'){
      if(input$submit3 > 0){
      grp1<- subset(csvfile(),select=input$dvar)
      final<-grp1
      res <- stat.desc(final)
      result<-as.data.frame(res)
      rownames(result)[rownames(result) == "nbr.val"] <- "Number of Obs."
      rownames(result)[rownames(result) == "nbr.null"] <- "null values"
      rownames(result)[rownames(result) == "nbr.na"] <- "NA"
      round(result,3)
      kable(result,caption = "Summary Statistics",digits=3) %>% kable_styling() %>% kable_paper("hover", full_width = F)
      }
    }
################# summary
if(input$req1 == 'ttest'||input$req1 == 'wttest'||input$req1=='ftest'||input$req1=='pttest'){
      if(input$submit1 > 0||input$submit2 > 0||input$submit4 > 0||input$submit5 > 0){
      grp1<- subset(csvfile(),select=input$dvar)
      grp2<- subset(csvfile(),select=input$ivar)
      final<-cbind(grp1,grp2)
      res <- pastecs::stat.desc(final)
      result<-as.data.frame(res)
      rownames(result)[rownames(result) == "nbr.val"] <- "Number of Obs."
      rownames(result)[rownames(result) == "nbr.null"] <- "null values"
      rownames(result)[rownames(result) == "nbr.na"] <- "NA"
      round(result,3)
      kable(result,caption = "Summary Statistics",digits=3) %>% kable_styling() %>% kable_paper("hover", full_width = F)
      }
    }
########## two sample ttest
 if(input$req1 == 'ttest'){
      if(input$submit1 > 0){
        x<-as.vector(csvfile()[,input$dvar])
        y<-as.vector(csvfile()[,input$ivar])
        t<-t.test(x, y, alternative = input$alt,
                  var.equal = TRUE,paired = FALSE,na.omit=TRUE)
        t_value<-round(t$statistic,3)
        df<-t$parameter
        Pvalue<-round(t$p.value,6)
        alt.Hypothesis<-t$alternative
        result<-cbind(t_value,df,Pvalue,alt.Hypothesis)
        result<-as.data.frame(result)
         kable(result,caption = "Two sample unpaired t-test",row.names = FALSE) %>% kable_styling() %>% kable_paper("hover", full_width = F)
      }
 }
h3("")
########## note 1
  if(input$req1 == 'ttest'){
      if(input$submit1 > 0){
        x<-as.vector(csvfile()[,input$dvar])
        y<-as.vector(csvfile()[,input$ivar])
        t<-t.test(x, y, alternative = input$alt,
                  var.equal = TRUE,paired = FALSE, na.omit=TRUE)

        if(t$p.value<=0.05){
        
        cat("Since P-value is < 0.05 we reject the null hypothesis at 5% level of significance.\n(here null hypothesis is: Population mean of group A = Population mean of group B)\n ")
       
        }
       else if(t$p.value>0.05){
       
        cat("Since P-value is > 0.05 we don't have enough evidence to reject the null hypothesis at 5% level of significance.\n(here null hypothesis is: Population mean of group A = Population mean of group B)\n")
        
         }
      }
  }
#############################################welch ttest
 if(input$req1 == 'wttest'){
      if(input$submit2 > 0){
        x<-as.vector(csvfile()[,input$dvar])
        y<-as.vector(csvfile()[,input$ivar])
        t<-t.test(x, y, alternative = input$alt,
                  var.equal = FALSE,paired = FALSE,na.omit=TRUE)
        t_value<-round(t$statistic,3)
        df<-round(t$parameter,2)
        Pvalue<-round(t$p.value,6)
        alt.Hypothesis<-t$alternative
        result<-cbind(t_value,df,Pvalue,alt.Hypothesis)
        result<-as.data.frame(result)
        result
        kable(result,caption = "Welch unpaired t-test",row.names = FALSE) %>% kable_styling() %>% kable_paper("hover", full_width = F)
      }
 }
h3("")
########### note2
 if(input$req1 == 'wttest'){
      if(input$submit2 > 0){
        x<-as.vector(csvfile()[,input$dvar])
        y<-as.vector(csvfile()[,input$ivar])
        t<-t.test(x, y, alternative = input$alt,
                  var.equal = FALSE,paired = FALSE, na.omit=TRUE)

        if(t$p.value<=0.05){
      cat("Since P-value is < 0.05 we reject the null hypothesis at 5% level of significance.\n(here null hypothesis is: Population mean of group A = Population mean of group B)\n ")
     
        }
        else if(t$p.value>0.05){
         cat("Since P-value is > 0.05 we don't have enough evidence to reject the null hypothesis at 5% level of significance.\n(here null hypothesis is: Population mean of group A = Population mean of group B)\n")
        
        }
      }
    }
############### one sample ttest
if(input$req1 == 'ottest'){
      if(input$submit3 > 0){
        x<-as.vector(csvfile()[,input$dvar])
        t<-t.test(x, y=NULL, alternative = input$alt,
                  mu = input$mu, na.omit=TRUE)
        t_value<-round(t$statistic,3)
        df<-round(t$parameter,2)
        Pvalue<-round(t$p.value,6)
        alt.Hypothesis<-t$alternative
        result<-cbind(t_value,df,Pvalue,alt.Hypothesis)
        result<-as.data.frame(result)
        kable(result,caption = "One sample t-test",row.names = FALSE) %>% kable_styling() %>% kable_paper("hover", full_width = F)
      }
}
h3("")

############### note 3
if(input$req1 == 'ottest'){
      if(input$submit3 > 0){
        x<-as.vector(csvfile()[,input$dvar])
        t<-t.test(x, y=NULL, alternative = input$alt,
                  mu = input$mu, na.omit=TRUE)
        mu<-as.numeric(input$mu)

        if(t$p.value<=0.05){
          cat("Since P-value is < 0.05.\nwe can reject the null hypothesis at 5 percent level of significance.\n")
        }
        else if(t$p.value>0.05){
          cat("Since P-value is > 0.05.\nwe don't have enough evidence to reject null hypothesis at 5 percent level of significance.\n")
        }
      }
    }
############### F test
if(input$req1 == 'ftest'){
      if(input$submit4 > 0){
        x<-as.vector(csvfile()[,input$dvar])
        y<-as.vector(csvfile()[,input$ivar])
        f<-var.test(x, y, ratio = 1,
                 alternative = input$alt)
        F_value<-round(f$statistic,3)
        df<-as.data.frame(f$parameter)
        Pvalue<-round(f$p.value,6)
        alt.Hypothesis<-f$alternative
        result<-cbind(F_value,t(df),Pvalue,alt.Hypothesis)
        result<-as.data.frame(result)
         kable(result,caption = "F test for Homogenity of Variance",row.names = FALSE) %>% kable_styling() %>% kable_paper("hover", full_width = F)
      }
}
h3("")
##### note 4
if(input$req1 == 'ftest'){
      if(input$submit4 > 0){
        x<-as.vector(csvfile()[,input$dvar])
        y<-as.vector(csvfile()[,input$ivar])
        f<-var.test(x, y, ratio = 1,
                    alternative = input$alt)

        if(f$p.value<=0.05){
          cat("Since P-value is < 0.05 we can reject the null hypothesis at 5 percent level of significance.\n(Here null hypothesis: Variances are Homogenous)\n")
        }
        else if(f$p.value>0.05){
          cat("Since P-value is > 0.05 we don't have enough evidence to reject null hypothesis at 5 percent level of significance. Variance is homogenous.\n(Here null hypothesis: Variances are Homogenous)\n")
          
        }
      }
    }
############################# Paired t test
if(input$req1 == 'pttest'){
      if(input$submit5 > 0){
      grp1<- subset(csvfile(),select=input$dvar)
      grp2<- subset(csvfile(),select=input$ivar)
      final<-cbind(grp1,grp2)
      ttest <- t.test(final[,1], final[,2], paired = TRUE, alternative = input$alt)
      tvalue<-round(ttest$statistic,3)
      df<-ttest$parameter
      pvalue<-round(ttest$p.value,6)
      meandiff<-round(ttest$estimate,3)
      result1<-cbind(tvalue,df,pvalue,meandiff)
      row.names(result1)<-NULL
       kable(result1,caption = "Paired t test",row.names = FALSE) %>% kable_styling() %>% kable_paper("hover", full_width = F)
      }
}
h3("")
 if(input$req1 == 'pttest'){
      if(input$submit5 > 0){
        x<-as.vector(csvfile()[,input$dvar])
        y<-as.vector(csvfile()[,input$ivar])
        t<-t.test(x, y, alternative = input$alt,
                  var.equal = FALSE,paired = TRUE, na.omit=TRUE)

        if(t$p.value<=0.05){
          cat("Since P-value is < 0.05 we reject the null hypothesis at 5% level of significance.\n(here null hypothesis is: Population mean of group A = Population mean of group B) \n")
          
        }
        else if(t$p.value>0.05){
         cat("Since P-value is > 0.05 we don't have enough evidence to reject the null hypothesis at 5% level of significance.\n(here null hypothesis is: Population mean of group A = Population mean of group B)\n")
          
        }
      }
    }

```
  
  
    
**Package: grapesAgri1, Version: 1.0.0**

---
title: "Summary Statistics"
output: html_document
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE,error = FALSE, warning = FALSE)
library(shiny)
library(pastecs)
library(ggpubr)
library(rmarkdown)
library(knitr)
library(kableExtra)
library(magrittr)
library(summarytools)
library(dplyr)
```
```{r echo=FALSE, error=FALSE, message=FALSE, warning=FALSE, include=TRUE,warn.conflicts=FALSE}

csvfile = reactive({
  csvfile = input$file1
  if (is.null(csvfile)) {
    return(NULL)
  }
  dt = read.csv(csvfile$datapath, header = input$header, sep = ",",check.names = FALSE)
})
# output
if (input$req == "summary") {
  if (input$submit4 > 0) {
    y = subset(csvfile(), select = input$var)
    final =
      summarytools::descr(y) %>%
      summarytools::tb(order = 3) %>%
      knitr::kable(digits = 2, caption = "Summary Statistics") %>%
      kableExtra::kable_styling("bordered", full_width = F) %>%
      kableExtra::collapse_rows(columns = 1, valign = "top")
    final
  }
}

if (input$req == "sumbygrp") {
  if (input$submit5 > 0) {
    y1 = subset(csvfile(), select = input$var)
    y2 = subset(csvfile(), select = input$group)
    final =
      summarytools::stby(y1, y2, descr) %>%
      summarytools::tb(order = 1) %>%
      knitr::kable(digits = 2, caption = "Summary Statistics by Group") %>%
      kableExtra::kable_styling("bordered", full_width = F) %>%
      kableExtra::collapse_rows(columns = 1, valign = "top")
    final
  }
}
```


**package: grapesAgri1, Version 1.0.0**

---
title: "Two way ANOVA (RBD)"
output: html_document
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
library(shiny)
library(ggplot2)
library(Hmisc)
library(agricolae)
library(shinyWidgets)
library(shinycssloaders)
library(dplyr)
library(gtools)
library(knitr)
library(kableExtra)
library(magrittr)
```
## RESULT
RBD ANALYSIS

```{r, echo = FALSE}
csvfile <- reactive({
  csvfile <- input$file1
  if (is.null(csvfile)) {
    return(NULL)
  }
  dt <- read.csv(csvfile$datapath, header = input$header, sep = ",")
  dt
})

if (input$submit > 0) {
  d <- as.data.frame(csvfile())
  r <- as.numeric(input$rep)
  t <- as.numeric(input$trt)
  response <- d[, input$yield]
  treatment <- d[, input$treatment]
  replication <- d[, input$Replication]
  treatment <- factor(treatment)
  replication <- factor(replication)
  anvaTable <- lm(response ~ treatment + replication)
  result <- as.data.frame(anova(anvaTable))
  out <- agricolae::LSD.test(csvfile()[, input$yield], csvfile()[, input$treatment], result[3, 1], result[3, 3])
  trtmeans <- out$means
   trtmeans <- trtmeans[ gtools::mixedsort(row.names(trtmeans)), ]
  colnames(trtmeans)[1] <- "Treatment_means"
  drops <- c("r", "Q25", "Q50", "Q75")
  trtmeans <- trtmeans[, !(names(trtmeans) %in% drops)]
  kable(trtmeans, caption = "Treatment mean and other statistics", digits = 3, align = "c", row.names = TRUE) %>% kable_styling() %>% kable_paper("hover", full_width = F)
}
tags$br()
################ anova table

if (input$submit > 0) {
  d <- as.data.frame(csvfile())
  r <- as.numeric(input$rep)
  t <- as.numeric(input$trt)
  response <- d[, input$yield]
  treatment <- d[, input$treatment]
  replication <- d[, input$Replication]
  treatment <- factor(treatment)
  replication <- factor(replication)
  anvaTable <- lm(response ~ treatment + replication)
  result <- as.data.frame(anova(anvaTable))
  SoV <- c("Treatment", "Replication", "Error")
  final <- cbind(SoV, result)
  kable(final, caption = "ANOVA TABLE", digits = 3, align = "c", row.names = FALSE) %>% kable_styling() %>% kable_paper("hover", full_width = F)
}
tags$br()
############################################## SEM
if (input$submit > 0) {
  d <- as.data.frame(csvfile())
  r <- as.numeric(input$rep)
  t <- as.numeric(input$trt)
  response <- d[, input$yield]
  treatment <- d[, input$treatment]
  replication <- d[, input$Replication]
  treatment <- factor(treatment)
  replication <- factor(replication)
  anvaTable <- lm(response ~ treatment + replication)
  result <- as.data.frame(anova(anvaTable))
  out <- LSD.test(d[, input$yield], d[, input$treatment], result[3, 1], result[3, 3])
  colnam <- c("MSE", "SE(d)", "SE(m)", "CV")
  stat <- out$statistics
  MSE <- stat[1, 1]
  SED <- sqrt((2 * MSE) / r)
  SEM <- sqrt(MSE / r)
  CV <- stat[1, 4]
  Result <- cbind(MSE, SED, SEM, CV)
  colnames(Result) <- colnam
  kable(Result, caption = "SEM & Other statistics", digits = 3, align = "c") %>% kable_styling() %>% kable_paper("hover", full_width = F)
}
tags$br()
if (input$submit > 0) {
  d <- as.data.frame(csvfile())
  r <- as.numeric(input$rep)
  t <- as.numeric(input$trt)
  response <- d[, input$yield]
  treatment <- d[, input$treatment]
  replication <- d[, input$Replication]
  treatment <- factor(treatment)
  replication <- factor(replication)
  anvaTable <- lm(response ~ treatment + replication)
  result <- as.data.frame(anova(anvaTable))
  if (result[1, 5] <= 0.05) {
    cat("Since the P-value in ANOVA table is < 0.05,\nthere is a significant difference between atleast a pair of treatments,\nso multiple comparison is required to identify best treatment(s)")
  }
  if (result[1, 5] > 0.05) {
    cat("Treatment means are not significantly different")
  }
}
############################### CD and measures
tags$br()
if (input$submit > 0) {
  d <- as.data.frame(csvfile())
  r <- as.numeric(input$rep)
  t <- as.numeric(input$trt)
  response <- d[, input$yield]
  treatment <- d[, input$treatment]
  replication <- d[, input$Replication]
  treatment <- factor(treatment)
  replication <- factor(replication)
  anvaTable <- lm(response ~ treatment + replication)
  result <- as.data.frame(anova(anvaTable))
  if (result[1, 5] > 0.05) {
    return()
  }

  else if (input$req == "lsd") {
    d <- as.data.frame(csvfile())
    r <- as.numeric(input$rep)
    t <- as.numeric(input$trt)
    response <- d[, input$yield]
    treatment <- d[, input$treatment]
    replication <- d[, input$Replication]
    treatment <- factor(treatment)
    replication <- factor(replication)
    anvaTable <- lm(response ~ treatment + replication)
    result <- as.data.frame(anova(anvaTable))
    out <- agricolae::LSD.test(d[, input$yield], d[, input$treatment], result[3, 1], result[3, 3])
    colnam <- c("MSE", "SE(d)", "SE(m)", "CD", "t value", "CV")
    stat <- out$statistics
    MSE <- stat[1, 1]
    SED <- sqrt((2 * MSE) / r)
    SEM <- sqrt(MSE / r)
    CD <- stat[1, 6]
    t <- stat[1, 5]
    CV <- stat[1, 4]
    Result <- cbind(MSE, SED, SEM, CD, t, CV)
    colnames(Result) <- colnam
    kable(Result, caption = "LSD test", digits = 3, align = "c") %>% kable_styling() %>% kable_paper("hover", full_width = F)
  }
  else if (input$req == "dmrt") {
    d <- as.data.frame(csvfile())
    r <- as.numeric(input$rep)
    t <- as.numeric(input$trt)
    response <- d[, input$yield]
    treatment <- d[, input$treatment]
    replication <- d[, input$Replication]
    treatment <- factor(treatment)
    replication <- factor(replication)
    anvaTable <- lm(response ~ treatment + replication)
    result <- as.data.frame(anova(anvaTable))
    out <- agricolae::duncan.test(d[, input$yield], d[, input$treatment], result[3, 1], result[3, 3], alpha = 0.05, group = TRUE, main = NULL, console = FALSE)
    Result <- out$duncan
    kable(Result, caption = "DMRT", digits = 3, align = "c") %>% kable_styling() %>% kable_paper("hover", full_width = F)
  }
  else if (input$req == "tukey") {
    d <- as.data.frame(csvfile())
    r <- as.numeric(input$rep)
    t <- as.numeric(input$trt)
    response <- d[, input$yield]
    treatment <- d[, input$treatment]
    replication <- d[, input$Replication]
    treatment <- factor(treatment)
    replication <- factor(replication)
    anvaTable <- lm(response ~ treatment + replication)
    result <- as.data.frame(anova(anvaTable))
    out <- agricolae::HSD.test(d[, input$yield], d[, input$treatment], result[3, 1], result[3, 3], alpha = 0.05, group = TRUE, main = NULL, unbalanced = FALSE, console = FALSE)
    Result <- out$statistics
    kable(Result, caption = "Tukey's HSD", digits = 3, align = "c") %>% kable_styling() %>% kable_paper("hover", full_width = F)
  }
}
tags$br()
########################################### grouping
if (input$submit > 0) {
  d <- as.data.frame(csvfile())
  r <- as.numeric(input$rep)
  t <- as.numeric(input$trt)
  response <- d[, input$yield]
  treatment <- d[, input$treatment]
  replication <- d[, input$Replication]
  treatment <- factor(treatment)
  replication <- factor(replication)
  anvaTable <- lm(response ~ treatment + replication)
  result <- as.data.frame(anova(anvaTable))
  if (result[1, 5] > 0.05) {
    return()
  }

  else if (input$req == "lsd") {
    d <- as.data.frame(csvfile())
    r <- as.numeric(input$rep)
    t <- as.numeric(input$trt)
    response <- d[, input$yield]
    treatment <- d[, input$treatment]
    replication <- d[, input$Replication]
    treatment <- factor(treatment)
    replication <- factor(replication)
    anvaTable <- lm(response ~ treatment + replication)
    result <- as.data.frame(anova(anvaTable))
    out <- agricolae::LSD.test(d[, input$yield], d[, input$treatment], result[3, 1], result[3, 3])
    outgroup <- out$groups
    colnames(outgroup) <- c("trt_mean", "grouping")
    kable(outgroup, caption = "Treatment Grouping", align = "c") %>% kable_styling() %>% kable_paper("hover", full_width = F)
  }
  else if (input$req == "dmrt") {
    d <- as.data.frame(csvfile())
    r <- as.numeric(input$rep)
    t <- as.numeric(input$trt)
    response <- d[, input$yield]
    treatment <- d[, input$treatment]
    replication <- d[, input$Replication]
    treatment <- factor(treatment)
    replication <- factor(replication)
    anvaTable <- lm(response ~ treatment + replication)
    result <- as.data.frame(anova(anvaTable))
    out <- agricolae::duncan.test(d[, input$yield], d[, input$treatment], result[3, 1], result[3, 3], alpha = 0.05, group = TRUE, main = NULL, console = FALSE)
    outgroup <- out$groups
    colnames(outgroup) <- c("trt_mean", "grouping")
    kable(outgroup, caption = "Treatment Grouping", align = "c") %>% kable_styling() %>% kable_paper("hover", full_width = F)
  }
  else if (input$req == "tukey") {
    d <- as.data.frame(csvfile())
    r <- as.numeric(input$rep)
    t <- as.numeric(input$trt)
    response <- d[, input$yield]
    treatment <- d[, input$treatment]
    replication <- d[, input$Replication]
    treatment <- factor(treatment)
    replication <- factor(replication)
    anvaTable <- lm(response ~ treatment + replication)
    result <- as.data.frame(anova(anvaTable))
    out <- agricolae::HSD.test(d[, input$yield], d[, input$treatment], result[3, 1], result[3, 3], alpha = 0.05, group = TRUE, main = NULL, unbalanced = FALSE, console = FALSE)
    outgroup <- out$groups
    colnames(outgroup) <- c("trt_mean", "grouping")
    kable(outgroup, caption = "Treatment Grouping", align = "c") %>% kable_styling() %>% kable_paper("hover", full_width = F)
  }
}
############
if (input$submit > 0) {
  d <- as.data.frame(csvfile())
  r <- as.numeric(input$rep)
  t <- as.numeric(input$trt)
  response <- d[, input$yield]
  treatment <- d[, input$treatment]
  replication <- d[, input$Replication]
  treatment <- factor(treatment)
  replication <- factor(replication)
  anvaTable <- lm(response ~ treatment + replication)
  result <- as.data.frame(anova(anvaTable))
  if (result[1, 5] > 0.05) {
    return("")
  }
  if (input$req == "tukey" || input$req == "dmrt" || input$req == "lsd") {
    cat("Treatments with same letters are not significantly different")
  }
}

tags$br()
tags$br()
```
Report generated from: **Package: grapesAgri1, Version 1.0.0**

---
title: "Correlation"
output: html_document
---


```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = FALSE)
library(knitr)
library(corrplot)
library(Hmisc)
library(magrittr)
library(kableExtra)
```
## RESULT
CORRELATION ANALYSIS 

```{r, echo = FALSE}
csvfile = reactive({
  csvfile = input$file1
  if (is.null(csvfile)) {
    return(NULL)
  }
  dt = read.csv(csvfile$datapath, header = input$header, sep = ",", check.names = FALSE)
  dt
})

# output
if (input$req1 == "correlation") {
  if (input$submit > 0) {
    a = as.vector(csvfile()[, input$dvar])
    y = as.vector(csvfile()[, input$ivar])
    x = cor.test(a, y,
      method = input$req, conf.level = as.numeric(input$ci),
      alternative = input$alt, exact = FALSE
    )
    t_value = round(x$statistic, 3)
    correlation = round(x$estimate, 3)
    df = x$parameter
    pvalue = round(x$p.value, 3)
    alt.Hypothesis = x$alternative
    result = cbind(correlation, t_value, df, pvalue, alt.Hypothesis)
    nam = x$method
    rownames(result) = nam
    result = as.data.frame(result)
    kable(result, caption = "Correlation Analysis", row.names = FALSE) %>%
      kable_styling() %>%
      kable_paper("hover", full_width = F)
  }
}

if (input$req1 == "correlation") {
  if (input$submit > 0) {
    if (input$req == "pearson") {
      a = as.vector(csvfile()[, input$dvar])
      y = as.vector(csvfile()[, input$ivar])
      x = cor.test(a, y,
        method = input$req, conf.level = as.numeric(input$ci),
        alternative = input$alt, exact = FALSE
      )
      ci = x$conf.int
      ci_nw = melt(ci, value.name = "Lower Limit and Upper limit")
      kable(round(ci_nw, 3), caption = "Confidence Interval", row.names = FALSE) %>%
        kable_styling() %>%
        kable_paper("hover", full_width = F)
    }
  }
}



if (input$req1 == "corrmat") {
  if (input$submit2 > 0) {
    x = as.data.frame(csvfile()[, input$selvar])
    cormat = rcorr(as.matrix(x), type = input$req)
    R = round(cormat$r, 3)
    p = cormat$P
    ## Define notions for significance levels; spacing is important.
    mystars = ifelse(p < .001, "*** ", ifelse(p < .01, "**  ", ifelse(p < .05, "*   ", "    ")))
    Rnew = matrix(paste(R, mystars, sep = ""), ncol = ncol(x))
    diag(Rnew) = paste(diag(R), " ", sep = "")
    row.names(Rnew) = names(x)
    colnames(Rnew) = names(x)
    kable(Rnew, caption = "Correlation Matrix") %>%
      kable_styling() %>%
      kable_paper("hover", full_width = F)
  }
}
tags$br()
if (input$req1 == "corrmat") {
  if (input$submit2 > 0) {
    cat("*** Correlation is significant at 0.001 level (two tailed) \n** Correlation is significant at 0.01 level (two tailed)\n* Correlation is significant at 0.05 level (two tailed)")
  }
}
tags$br()

if (input$req1 == "corrmat") {
  if (input$submit2 > 0) {
    x = as.data.frame(csvfile()[, input$selvar])
    cormat = rcorr(as.matrix(x), type = input$req)
    correlmat1 = cormat$P
    row.names(correlmat1) = names(x)
    kable(round(correlmat1, 3), caption = "Matrix of P-values") %>%
      kable_styling() %>%
      kable_paper("hover", full_width = F)
  }
}



h3("")



```








**package: grapesAgri1, Version; 1.0.0**

---
title: "Design Layout"
output: html_document
---


```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = FALSE)
library(rmarkdown)
library(agricolae)
library(dplyr)
library(ggplot2)
library(magrittr)
library(desplot)
library(knitr)
```

Details of the Experiment is given below.

```{r , echo=FALSE}


  if(input$design == 'crd'){
    if(input$rep_crd>0 && input$submit1>0){
      Treatments= input$trt_crd
      Replication=input$rep_crd
      Experimental.units=Treatments*Replication
      det=cbind(Treatments,Replication,Experimental.units)
      det=as.data.frame(det)
      kable(det,row.names = FALSE) %>%
      kable_styling() %>%
      kable_paper("hover", full_width = F)
    }
  }

    if(input$design == 'rbd'){
      if(input$rep_rbd>0 && input$submit2>0){
        Treatments= input$trt_rbd
        Blocks=input$rep_rbd
        Experimental.units=Treatments*Blocks
        det=cbind(Treatments,Blocks,Experimental.units)
        det=as.data.frame(det)
        kable(det,row.names = FALSE) %>%
      kable_styling() %>%
      kable_paper("hover", full_width = F)
      }
    }
    
    if(input$design == 'aug'){
      if(input$check_aug>0&&input$trt_aug&&input$rep_aug>0 && input$submit3>0){
        Check =input$check_aug
        Treatments= input$trt_aug
        Blocks=input$rep_aug
        Plots =Check*Blocks+Treatments
        det=cbind(Check,Treatments,Blocks,Plots)
        det=as.data.frame(det)
        kable(det,row.names = FALSE) %>%
      kable_styling() %>%
      kable_paper("hover", full_width = F)
      }
    }
  
    if(input$design == 'split'){
      if(input$maintrt_split>0&&input$subtrt_split&&input$rep_split>0 &&
         input$submit4>0){
        Main_plot_trt =input$maintrt_split
        Sub_plot_trt =input$subtrt_split
        Replications =input$rep_split
        No_of_Plots =Main_plot_trt*Sub_plot_trt*Replications
        det=cbind(Main_plot_trt,Sub_plot_trt,Replications,No_of_Plots)
        det=as.data.frame(det)
        kable(det,row.names = FALSE) %>%
      kable_styling() %>%
      kable_paper("hover", full_width = F)
      }
    }

    if(input$design == 'strip'){
      if(input$maintrt_strip>0&&input$subtrt_strip&&input$rep_strip>0 &&
         input$submit5>0){
        Main_plot_A =input$maintrt_strip
        Main_plot_B =input$subtrt_strip
        Replications =input$rep_strip
        No_of_Plots =Main_plot_A*Main_plot_B*Replications
        det=cbind(Main_plot_A,Main_plot_B,Replications,No_of_Plots)
        det=as.data.frame(det)
        kable(det,row.names = FALSE) %>%
      kable_styling() %>%
      kable_paper("hover", full_width = F)
      }
    }

```


Field layout of your experiment

```{r echo=FALSE, error=FALSE, message=FALSE, warning=FALSE, include=TRUE,warn.conflicts=FALSE}

 if (input$design == "crd") {
  if (input$trt_crd > 0) {
    if (input$rep_crd > 0) {
      if (input$submit1 > 0) {
        t = input$trt_crd
        r = input$rep_crd
        s = input$size
        rand = input$rand
        trtname = sprintf("T%d", 1:t)
        outdesign = agricolae::design.crd(trtname, r = r, seed = rand, serie = 0, kinds = "Super-Duper", randomization = TRUE)
        CRD = outdesign$book
        CRD = CRD[order(CRD$r), ]
        CRD$col = CRD$r
        CRD$row = rep(1:t, r)
        desplot::desplot(
          form = trtname ~ col + row, data = CRD, text = trtname, out1 = col,
          out2 = row, out2.gpar = list(col = "black", lwd = 3),
          cex = s, main = "Layout of Completely Randomized Design", show.key = FALSE
        )
      }
    }
  }
}
if (input$design == "rbd") {
  if (input$trt_rbd > 0) {
    if (input$rep_rbd > 0) {
      if (input$submit2 > 0) {
        t = input$trt_rbd
        rep = input$rep_rbd
        s = input$size_rbd
        trtname = sprintf("T%d", 1:t)
        n = t * rep
        outdesign = agricolae::design.rcbd(trt = trtname, r = rep, seed = input$rand2, serie = 0, kinds = "Super-Duper", randomization = TRUE)
        RBD = outdesign$book
        RBD = RBD[order(RBD$block), ]
        RBD$blocks = as.numeric(RBD$block)
        RBD$plots = rep(1:t, rep)
        desplot::desplot(
          form = block ~ blocks + plots, data = RBD, text = trtname, out1 = blocks,
          out2 = plots, out2.gpar = list(col = "green"),
          cex = s, main = "Layout of Randomized Block Design", show.key = TRUE
        )
      }
    }
  }
}
  
  if(input$design == 'aug'){
    if(input$check_aug> 0){
      if(input$trt_aug> 0){
        if(input$rep_aug> 0){
            if(input$submit3>0){
              NC=input$check_aug # no. of check
              blk=input$rep_aug # no: of Blocks
              trt=input$trt_aug # no.of trt
              s=input$size_aug
              T1=sprintf("C%d", 1:NC) # checks
              T2=sprintf("T%d", 1:trt) # treatments
              outdesign=agricolae::design.dau(T1,T2, r=blk,seed=input$rand3,serie=0,randomization = TRUE)
              aug= outdesign$book
              aug = aug[order(aug$block),]
              aug$blocks = as.numeric(aug$block)
              x=aug %>%
                group_by(block) %>%
                mutate(row = row_number())
              aug1=as.data.frame(cbind(aug,row=x$row))
              desplot::desplot(form=block~ blocks+row, data=aug1, text=trt, out1=blocks, out2=row,
                               cex=s, main="Layout of Augmented Randomized Block Design",show.key=FALSE)
              
            }
        }
      }
    }
  }
  
 if(input$design == 'strip'){
    if(input$maintrt_strip> 0){
      if(input$subtrt_strip> 0){
        if(input$rep_strip> 0){
            if(input$submit5>0){
              a=input$maintrt_strip
              b=input$subtrt_strip
              rep=input$rep_strip
              s=input$size_strip
              main1=sprintf("A%d", 1:a)
              main2=sprintf("B%d", 1:b)
              outdesign =agricolae::design.strip(main1,main2,r=rep,serie=0,seed=input$rand5,kinds="Super-Duper",randomization=TRUE)
              strip= outdesign$book
              strip$block2=strip$block
              v1 = do.call(paste, as.data.frame(t(apply(strip[4:5], 1, sort))))
              strip$row =  match(v1, unique(v1))
              v2 = do.call(paste, as.data.frame(t(apply(strip[2:3], 1, sort))))
                 strip$column =  match(v2, unique(v2))
              desplot::desplot(form=main1~ row+column, data=strip,text=main2, out1=column,
                               out2=row,out2.gpar = list(col = "#a83232"),
                               cex=s, main="Layout of Strip-Plot Design",show.key=TRUE)
              
            }
        }
      }
    }
  }
  
 if(input$design == 'split'){
    if(input$maintrt_split> 0){
      if(input$subtrt_split> 0){
        if(input$rep_split> 0){
            if(input$submit4>0){
              a=input$maintrt_split
              b=input$subtrt_split
              rep=input$rep_split
              s=input$size_split
              main=sprintf("A%d", 1:a)
              sub=sprintf("b%d", 1:b)
              outdesign =agricolae::design.split(main,sub,r=rep,serie=0,seed=input$rand4,kinds="Super-Duper",randomization=TRUE)
              split = outdesign$book
              split = split[order(split$plots),]
              split$plots = split$plots
              split$plots=as.numeric(split$plots)
              split$splots=as.numeric(split$splots)
              desplot::desplot(form=main~ plots+splots, data=split,col=main, text=sub, out1=plots, out2=splots,
                               cex=s, main="Layout of Split-Plot Design",show.key=TRUE)
              
            }
        }
      }
    }
  }
```


```{r , echo=FALSE}
if (input$design == "crd") {
  if (input$table_butt1 > 0) {
    t = input$trt_crd
    r = input$rep_crd
    n = t * r
    trtname = sprintf("T%d", 1:t)
    outdesign = agricolae::design.crd(trtname, r = r, seed = input$rand, serie = 0, kinds = "Super-Duper", randomization = TRUE)
    CRD = outdesign$book
    CRD = CRD[order(CRD$r), ]
    CRD$exp = rep(1:n)
    final = as.data.frame(cbind(Experimental.Unit = CRD$exp, Treatments = as.character(CRD$trtname)))
    kable(final, caption = "Layout of CRD", row.names = FALSE)
  }
}

if (input$design == "rbd") {
  if (input$table_butt2 > 0) {
    t = input$trt_rbd
    rep = input$rep_rbd
    trtname = sprintf("T%d", 1:t)
    n = t * rep
    outdesign = agricolae::design.rcbd(trt = trtname, r = rep, seed = input$rand2, serie = 0, kinds = "Super-Duper", randomization = TRUE)
    RBD = outdesign$book
    RBD = RBD[order(RBD$block), ]
    RBD$plot = rep(1:t, rep)
    final = as.data.frame(cbind(Block = RBD$block, Plot = RBD$plot, Treatment = as.character(RBD$trtname)))
    kable(final, caption = "Layout of RBD", row.names = FALSE)
  }
}


if (input$design == "aug") {
  if (input$table_butt3 > 0) {
    NC = input$check_aug # no. of check
    blk = input$rep_aug # no: of Blocks
    trt = input$trt_aug # no.of trt
    s = input$size_aug
    T1 = sprintf("C%d", 1:NC) # checks
    T2 = sprintf("T%d", 1:trt) # treatments
    outdesign = agricolae::design.dau(T1, T2, r = blk, seed = input$rand3, serie = 0, randomization = TRUE)
    aug = outdesign$book
    aug = aug[order(aug$block), ]
    x1 = aug %>%
      group_by(block) %>%
      mutate(Plot = row_number())
    final = as.data.frame(cbind(Block = x1$block, Plot = x1$Plot, Treatment = as.character(x1$trt)))
    kable(final, caption = "Layout of Augmented Design", row.names = FALSE)
  }
}


if (input$design == "split") {
  if (input$table_butt4 > 0) {
    a = input$maintrt_split
    b = input$subtrt_split
    rep = input$rep_split
    s = input$size_split
    main = sprintf("A%d", 1:a)
    sub = sprintf("b%d", 1:b)
    outdesign = agricolae::design.split(main, sub, r = rep, serie = 0, seed = input$rand4, kinds = "Super-Duper", randomization = TRUE)
    split = outdesign$book
    split = split[order(split$plots), ]
    final = as.data.frame(cbind(
      Main_plot = split$plots, Sub_plot = split$splots,
      Replication = split$block, Main_treatment = as.character(split$main), Sub_treatment = as.character(split$sub)
    ))
    kable(final, caption = "Layout of Split-Plot design", row.names = FALSE)
  }
}

if (input$design == "strip") {
  if (input$table_butt5 > 0) {
    a = input$maintrt_strip
    b = input$subtrt_strip
    rep = input$rep_strip
    s = input$size_strip
    main1 = sprintf("A%d", 1:a)
    main2 = sprintf("B%d", 1:b)
    outdesign = agricolae::design.strip(main1, main2, r = rep, serie = 0, seed = input$rand5, kinds = "Super-Duper", randomization = TRUE)
    strip = outdesign$book
    strip$block2 = strip$block
    v1 = do.call(paste, as.data.frame(t(apply(strip[4:5], 1, sort))))
    strip$row = match(v1, unique(v1))
    v2 = do.call(paste, as.data.frame(t(apply(strip[2:3], 1, sort))))
    strip$column = match(v2, unique(v2))
    final = as.data.frame(cbind(
      Replication = strip$block, Horizontal_row_No. = strip$row,
      Treatment_A = as.character(strip$main1),
      Vertical_row_No. = strip$column,
      Treatment_B = as.character(strip$main2)
    ))
    kable(final, caption = "Layout of Strip plot design", row.names = FALSE)
  }
}
  
```
**Package: grapesAgri1, Version;1.0.0**
  
  
  
